// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'

var app = angular.module('HefenApp', ['ionic', 'ui.router.router', 'ngCordova', 'ngIOS9UIWebViewPatch', 'MQDao', 'me-lazyimg', 'Cart', 'Pagination', 'Star'], function($httpProvider){
    $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
    var param = function(obj) {
        // console.log('====>',obj);
        var query = '',
            name, value, fullSubName, subName, subValue, innerObj, i;

        for (name in obj) {
            value = obj[name];

            if (value instanceof Array) {
                for (i = 0; i < value.length; ++i) {
                    subValue = value[i];
                    fullSubName = name + '[' + i + ']';
                    innerObj = {};
                    innerObj[fullSubName] = subValue;
                    query += param(innerObj) + '&';
                }
            } else if (value instanceof Object) {
                for (subName in value) {
                    subValue = value[subName];
                    fullSubName = name + '[' + subName + ']';
                    innerObj = {};
                    innerObj[fullSubName] = subValue;
                    query += param(innerObj) + '&';
                }
            } else if (value !== undefined && value !== null)
                query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
        }
        var result = query.length ? query.substr(0, query.length - 1) : query;
        // console.log('++++++>',result);
        return result;
    };

    // Override $http service's default transformRequest
    $httpProvider.defaults.transformRequest = [function(data) {
        return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
    }];
});

app.config(['$ionicConfigProvider', '$stateProvider', '$urlRouterProvider', function($ionicConfigProvider, $stateProvider, $urlRouterProvider) {
    //$ionicConfigProvider.scrolling.jsScrolling(false);
    $ionicConfigProvider.backButton.text('').icon('ion-ios-arrow-left');
    $ionicConfigProvider.navBar.alignTitle('center');
    $ionicConfigProvider.views.maxCache(10);
    $ionicConfigProvider.views.forwardCache(true);
    $ionicConfigProvider.platform.android.scrolling.jsScrolling(false);
    //$ionicConfigProvider.platform.ios.scrolling.jsScrolling(true);
    //$ionicConfigProvider.setPlatformConfig('android', {});
    //$ionicConfigProvider.setPlatformConfig('ios', iosConfigProperties);

    $stateProvider
        .state('home', {
            url: '/home',
            templateUrl: 'templates/home.html'
        })
        .state('shop-list', {
            url: '/shop-list',
            templateUrl: 'templates/shop_list.html'
        })
        .state('product-list', {
            url: '/product-list',
            templateUrl: 'templates/product_list.html'
        })
        .state('product-list-custom', {
            url: '/product-list-custom',
            templateUrl: 'templates/product_list_custom.html'
        })
        .state('shop-product-list', {
            url: '/shop-product-list',
            templateUrl: 'templates/shop_product_list.html'
        })
        .state('classification', {
            url: '/classification',
            templateUrl: 'templates/classification.html'
        })
        .state('user-center', {
            cache: true,
            url: '/user-center',
            templateUrl: 'templates/user_center.html'
        })
        .state('order-list', {
            cache: true,
            url: '/order-list',
            templateUrl: 'templates/order_list.html'
        })
        .state('order-list-v2', {
            cache: true,
            url: '/order-list-v2',
            templateUrl: 'templates/order_list_v2.html'
        })
        .state('cart', {
            cache: true,
            url: '/cart',
            templateUrl: 'templates/cart.html'
        })
        .state('evaluation', {
            cache: false,
            url: '/evaluation',
            templateUrl: 'templates/evaluation.html'
        })
        .state('product-details', {
            cache: true,
            url: '/product-details',
            templateUrl: 'templates/product_details.html'
        })
        .state('shop-details', {
            cache: true,
            url: '/shop-details',
            templateUrl: 'templates/shop_details.html'
        })
        .state('login', {
            cache: true,
            url: '/login',
            templateUrl: 'templates/login.html'
        })
        .state('register', {
            cache: false,
            url: '/register',
            templateUrl: 'templates/register.html'
        })
        .state('order-commit', {
            cache: false,
            url: '/order-commit',
            templateUrl: 'templates/order_commit.html'
        })
        .state('order-commit-v2', {
          cache: false,
          url: '/order-commit-v2',
          templateUrl: 'templates/order_commit_v2.html'
        })
        .state('order-commit-product', {
            cache: false,
            url: '/order-commit-product',
            templateUrl: 'templates/order_commit_product.html'
        })
        .state('address-message', {
            cache: true,
            url: '/address-message',
            templateUrl: 'templates/address_message.html'
        })
        .state('create-address', {
            cache: false,
            url: '/create-address',
            templateUrl: 'templates/create_address.html'
        })
        .state('find-community', {
            cache: false,
            url: '/find-community',
            templateUrl: 'templates/find_community.html'
        })
        .state('order-evaluate', {
            cache: false,
            url: '/order-evaluate',
            templateUrl: 'templates/order_evaluate.html'
        })
        .state('order-info', {
            cache: false,
            url: '/order-info',
            templateUrl: 'templates/order_info.html'
        })
        .state('order-tracking', {
            cache: false,
            url: '/order-tracking',
            templateUrl: 'templates/order_tracking.html'
        })
        .state('retrieve-password', {
            cache: false,
            url: '/retrieve-password',
            templateUrl: 'templates/retrieve_password.html'
        })
        .state('edit-password', {
            cache: false,
            url: '/edit-password',
            templateUrl: 'templates/edit_password.html'
        })
        .state('pay-online', {
            cache: false,
            url: '/pay-online',
            templateUrl: 'templates/pay_online.html'
        })
        .state('position-list', {
            cache: false,
            url: '/position-list',
            templateUrl: 'templates/position_list.html'
        })
        .state('search', {
            cache: true,
            url: '/search',
            templateUrl: 'templates/search.html'
        })
        .state('contact-list', {
            cache: false,
            url: '/contact-list',
            templateUrl: 'templates/contact_list.html'
        })
        .state('error-page', {
            cache: false,
            url: '/error-page',
            templateUrl: 'templates/error_page.html'
        })
        .state('update-community', {
            cache: false,
            url: '/update-community',
            templateUrl: 'templates/update_community.html'
        })
        .state('coupon-list', {
            cache: true,
            url: '/coupon-list',
            templateUrl: 'templates/coupon_list.html'
        })
        .state('custom-page', {
            cache: false,
            url: '/custom-page',
            templateUrl: 'templates/custom_page.html'
        })
        .state('integral-page',{
          cache: true,
          url:'/integral-page',
          templateUrl:'templates/user_integral.html'
        });

    $urlRouterProvider.when('', '/home');
    //$urlRouterProvider.deferIntercept();

}]);

app.run(['$rootScope', '$ionicPlatform', '$ionicPopup', '$location', '$state', '$timeout', '$ionicHistory', '$ionicLoading', '$cordovaGeolocation', 'userLocationFactory', '$mqDaoStack', function($rootScope, $ionicPlatform, $ionicPopup, $location, $state, $timeout, $ionicHistory, $ionicLoading, $cordovaGeolocation, userLocationFactory, $mqDaoStack) {

    $ionicPlatform.ready(function() {
        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)
        var positionTimeout = null;
        if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        }
        if (window.StatusBar) {
            StatusBar.styleDefault();
        }

        /* 调用很烂的地理位置获取方法，可以扔掉 */
        // getCurrentPosition(function(position) {
        //     alert('position:'+ position.lat + '--' + position.lon);
        //     // $rootScope.lat = position.lat;
        //     // $rootScope.lon = position.lon;
        // });

        /*
         * 调用监听地理位置方法，ngCordova 提供
         * 此方法会反复获取，如遇性能问题，在某些页面可以清理掉
         * $cordovaGeolocation.clearWatch($rootScope.watchPositionId);
         */

        var watchPositionStart = function(key, options) {
            var model = ionic.Platform.platform();
            if (model == 'android') {
                if (window.cordova) {
                    cordova.exec(function(success) {
                        if (success != "") {
                            var positionObj = {};
                            var positionArr = success.split(";");
                            for (var i = 0; i < positionArr.length; i++) {
                                var p = positionArr[i].split(":");
                                positionObj[p[0]] = p[1];
                            }
                            $rootScope['hfPosition'] = {
                                lat: positionObj.lat,
                                lon: positionObj.lon
                            };
                        } else {
                            if (positionTimeout) {
                                $timeout.cancel(positionTimeout);
                                positionTimeout = null;
                            }
                            positionTimeout = $timeout(function() {
                                watchPositionStart(key, options);
                            }, 1 * 1000);
                        }
                    }, function(error) {
                        //alert(error);
                    }, "GetBDPosition", "bdposition", "");
                } else {
                    // 这里是测试数据
                    // $rootScope['hfPosition'] = {
                    //     lat: 38.882246854779,
                    //     lon: 115.45585221126
                    // };
                }
            } else if (model == 'ios') {
                var setting = angular.extend({}, {
                    frequency: 100
                }, options);
                var watchPosition = $cordovaGeolocation.watchPosition(setting);
                var watchId = watchPosition.watchId;
                $rootScope.watchPositionId = watchPosition.watchId;
                watchPosition.promise.then(function(resp) {}, function(err) {
                    //alert('error:'+err.code);
                    $rootScope['hfPosition'] = {
                        errorMsg: err.message,
                        errorCode: err.code
                    };
                    $cordovaGeolocation.clearWatch(watchId);
                    watchId = null;
                    if (positionTimeout) {
                        $timeout.cancel(positionTimeout);
                        positionTimeout = null;
                    }
                    positionTimeout = $timeout(function() {
                        watchPositionStart(key, options);
                    }, 1 * 1000);
                }, function(position) {
                    //alert('current position: '+position.coords.latitude+' -- '+position.coords.longitude);
                    // //为不同精度存储不同的key
                    // $rootScope[key] = {
                    //     lat: position.coords.latitude,
                    //     lon: position.coords.longitude
                    // };
                    $rootScope['hfPosition'] = {
                        lat: position.coords.latitude,
                        lon: position.coords.longitude
                    };
                });
            }
        };


        watchPositionStart('hfPosition', {
            enableHighAccuracy: false, //是否用高精度，这里不用
            maximumAge: 5 * 1000, //每个n秒重新获取一次
            timeout: 5 * 1000 //超时时间
        });
        watchPositionStart('hfPositionHigh', {
            enableHighAccuracy: true, //是否用高精度，这里使用
            maximumAge: 5 * 1000, //每个n秒重新获取一次
            timeout: 5 * 1000 //超时时间
        });


        /* 获取当前设备地理位置，不进行监听，ngcordova 提供 */
        /*
        var getUserPosition = function(key, options){
            var position = $cordovaGeolocation.getCurrentPosition(options)
            position.then(function(position){
                //alert('current position: '+position.coords.latitude+' -- '+position.coords.longitude);
                $rootScope.hfPosition = {
                    lat: position.coords.latitude,
                    lon: position.coords.longitude
                };
            }, function(err){
                $rootScope['hfPosition'] = {
                    errorMsg: err.message,
                    errorCode: err.code
                };
                $timeout(function() {
                    getUserPosition(key, options);
                }, 1 * 1000);
            });
        };
        getUserPosition('hfPosition', {
            enableHighAccuracy: false, //是否用高精度，这里不用
            maximumAge: 5 * 1000, //每个n秒重新获取一次
            timeout: 5 * 1000 //超时时间
        });
        */
        /* 设置容器高度，这里设置的是body ，使输入框获取焦点时，输入法覆盖底栏 */
        var resize = function(){
            var ele = document.getElementById('containner');

            if (ele) {
                var cacheh = window.localStorage.getItem('window_height');
                var winh = window.innerHeight;
                if(winh < cacheh * 0.8){
                    var height = Math.max(cacheh, winh);
                }else{
                    var height = winh;
                }
                if(CURRENT_ENV != 'product'){
                    height = winh;
                }
                ele.style.height = height + 'px';
                if(cacheh < winh){
                    window.localStorage.setItem('window_height', winh);
                }
            }
        };
        resize();
        window.onresize = function(){
            resize();
        }

    });


    /**
     * 页面跳转
     */
    $rootScope.$on('$stateChangeStart', function(e, toState, toStateParams) {
        $mqDaoStack.clearAll();
        if (toState.name == "cart") {
            localStorage.setItem("beforeCart", $location.path().substring(1));
        }

        if (toState.name == "order-info") {
            localStorage.setItem("beforeOrderInfo", $location.path().substring(1));
        }

        if (toState.name == "order-list-v2") {
            localStorage.setItem("beforeOrderList", $location.path().substring(1));
        }

        if (toState.name == "login" || toState.name == "register") {
            if (userLocationFactory.isLoggedIn()) {
                e.preventDefault();
                $state.go('home');
                return false;
            }
        }

        /**
         * 每次跳转页面前，检查网络
         *
         */

        if (toState.name != 'error-page') {
            var conn = HefenConnection();
            if (!conn) {
                window.localStorage.setItem('backUrlForError', toState.name);
                e.preventDefault();
                $state.go('error-page');
                return false;
            }
        }

        if (checkLoginUrl.indexOf(toState.url) > -1) {
            if (!userLocationFactory.isLoggedIn()) {
                window.localStorage.setItem('backUrl', toState.name);
                e.preventDefault();
                $state.go('login');
                return false;
            }
        }


    });

    //主页面显示退出提示框
    $ionicPlatform.registerBackButtonAction(function(e) {

        var showConfirm = function() {
            var confirmPopup = $ionicPopup.confirm({
                title: '<strong>退出应用?</strong>',
                template: '你确定要退出应用吗?',
                okText: '退出',
                cancelText: '取消'
            });

            confirmPopup.then(function(res) {
                if (res) {
                    ionic.Platform.exitApp();
                } else {
                    // Don't close
                }
            });
        }

        // Is there a page to go back to?
        // if ($location.path() == '/home') {
        //     showConfirm();
        // }else{
        //     $rootScope.$ionicGoBack();
        // }
        //判断处于哪个页面时双击退出

        if ($location.path() == '/home') {
            showConfirm();
            // if($rootScope.backButtonPressedOnceToExit){
            //     ionic.Platform.exitApp();
            // }else{
            //     $rootScope.backButtonPressedOnceToExit = true;
            //     $ionicLoading.show({ template: '再按一次退出系统', noBackdrop: true, duration: 2000 });
            //     $timeout(function () {
            //         $rootScope.backButtonPressedOnceToExit = false;
            //     }, 3000);
            // }
        } else if ($location.path() == '/order-info') {
            var upOrderInfo = window.localStorage.getItem("beforeOrderInfo"); //获取跳转到订单详情页的上一页
            var upCart = window.localStorage.getItem("beforeCart"); //获取跳转到购物车页的上一页
            // if(upOrderInfo == "order-list"){
            //     $state.go(upOrderInfo);
            // }else if(upOrderInfo == "order-commit" && upCart == "order-info"){
            //     $state.go('home');
            // }else{
            //     $state.go(upCart);
            // }
            var goUrl = 'home';
            if (upOrderInfo == "order-list") {
                goUrl = 'order-list';
            }
            if (upOrderInfo == "order-list-v2") {
                goUrl = 'order-list-v2';
            }
            $state.go(goUrl);
        } else if($location.path() == '/order-list-v2'){
            var upOrderList = window.localStorage.getItem("beforeOrderList"); //获取跳转到订单详情页的上一页

            if(upOrderList && upOrderList == 'order-commit-v2'){
                $state.go('home');
            }else{
                $ionicHistory.goBack();
            }
        } else {
            $ionicHistory.goBack();
        }
        e.preventDefault();
        return false;
    }, 101);

}]);

app.filter('nameTrim', function() {
    return function(str) {
        var str = str || '';
        return str.replace(/(\s+)/g, "");
    };
});
app.filter('isInCart', function() {
    return function(id, list) {
        for (var i = 0; i < list.length; i++) {
            var goods = list[i];
            if (goods.goodsSpuId == id) {
                return true;
            }
        };
        return false;
    };
});
app.filter('trustHtml', ['$sce', function($sce) {
    return function(input) {
        return $sce.trustAsHtml(input);
    }
}]);
/**
 *  这里是搜索时，将结果按输入词排序
 */
app.filter('orderSearchByPos', function() {
    return function(list, term) {
        if (list.length && !!term) {
            var termLen = term.length;
            for (var i = 0; i < list.length; i++) {
                var shop = list[i];
                var name = shop.shopBrandName || '';
                var len = name.length;
                var pos = name.indexOf(term);
                var order = parseFloat((len - pos + termLen) / len);
                shop.orderBy = order;
            }
            return arraySort(list, 'orderBy', 'desc');
        };
        return list;
    };
});
/**
 *  这里是搜索时，将结果按输入词的拼音进行过滤
 */
app.filter('pinyinFilter', function() {
    return function(list, term) {
        if (list.length && !!term) {
            var result = [];
            var termPinyin = convertPinyin(term).toLowerCase();
            for (var i = 0; i < list.length; i++) {
                var shop = list[i];
                var match = shop.shopBrandNamePinYin.match(termPinyin);
                if (match) {
                    result.push(shop);
                }
            }
            return result;
        }
        return list;
    };
});
/**
 *  这里是搜索小区时，将结果按输入词排序
 */
app.filter('orderCommunityByPos', function() {
    return function(list, term) {

        if (list.length && !!term) {
            var termLen = term.length;
            for (var i = 0; i < list.length; i++) {
                var community = list[i];
                var name = community.communityName || '';
                var len = name.length;
                var pos = name.indexOf(term);
                var order = parseFloat((len - pos + termLen) / len);
                community.orderBy = order;
            }
            return arraySort(list, 'orderBy', 'desc');
        };
        return list;
    };
});
/**
 *  这里是搜索小区时，将结果按输入词的拼音进行过滤
 */
app.filter('pinyinFilterForCommunity', function() {
    return function(list, term) {
        if (list.length && !!term) {
            var result = [];
            var termPinyin = convertPinyin(term).toLowerCase();
            for (var i = 0; i < list.length; i++) {
                var community = list[i];
                var communityNamePinYin = convertPinyin(community.communityName).toLowerCase();

                var match = communityNamePinYin.match(termPinyin);
                if (match) {
                    result.push(community);
                }
            }
            return result;
        }
        return list;
    };
});
app.controller('appCtrl', ['$scope', '$rootScope', '$state', '$ionicPopup', '$location', '$timeout', '$interval', 'cartFactory', '$ionicHistory', 'shopBrandService', '$ionicLoading', '$ionicScrollDelegate', '$cordovaBarcodeScanner', 'orderService', 'couponService', 'userLocationFactory', '$mqDaoStack', 'goodsService', function($scope, $rootScope, $state, $ionicPopup, $location, $timeout, $interval, cartFactory, $ionicHistory, shopBrandService, $ionicLoading, $ionicScrollDelegate, $cordovaBarcodeScanner, orderService, couponService, userLocationFactory, $mqDaoStack, goodsService) {
    mobileSystem = ionic.Platform.platform();
    // console.log($ionicHistory.clearCache(['home']));
    // console.log($ionicHistory);
    $scope.appEnvironmentSystem = currentEnvironment();
    $scope.hideLoadingHtmlTimeout = null;
    $scope.isCordovaPlatform = ionic.Platform.isIOS();
    $rootScope.autoBackHtml = null; //返回页面参数
    $rootScope.selectVoucherIds = {}; //选择的优惠券对象
    $rootScope.orderCoupon = null; //优惠券参数
    $rootScope.scan = {};//扫码优惠参数
    $rootScope.scanEmployee = {};//员工扫码优惠参数
    $scope.animationImgUrl = './img/default.jpg';
    $scope.showPrePage = compareVersion();
    $scope.showPreTipPage = true;
    $scope.preTipFadeOut = false;
    $scope.appName = appNameMap[appEnvironment];
    $scope.userCommunity = {
        communityName: '选择小区'
    }; // 用户选择的小区地址
    $scope.$on('$locationChangeSuccess', function(e) {
        e.preventDefault();
        var currentPath = $location.path();

        $scope.showBarFooter = !(hideBarFooterUrl.indexOf(currentPath) > -1);
        // $scope.showIndexHeader = showIndexHeaderUrl.indexOf($location.path()) > -1;
        // $scope.showLoginHeader = showLoginHeaderUrl.indexOf($location.path()) > -1;
        $scope.hideAllHeader = hideAllHeaderUrl.indexOf(currentPath) > -1;
        $scope.currentFooterPath = currentPath;

        //购物车自动返回定时任务清理
        if ($rootScope.autoBackHtml && !$rootScope.autoBackHtml.$$state.value) {
            if (currentPath != '/cart') {
                $timeout.cancel($rootScope.autoBackHtml);
            }
        }
        //订单信息页面定时清理
        if ($rootScope.orderInfoTime) {
            if (currentPath != '/order-info') {
                $interval.cancel($rootScope.orderInfoTime);
            }
        }
        /**
         * 页面跳转后，显示加载提示框
         * 注意，由于是数据加载后，隐藏提示框，
         * 如果有Ionic的缓存页面，不加载数据，此提示框则会一直显示。
         */
        /*
        if(showLoadingUrl.indexOf(currentPath) > -1 ){
            var history = $ionicHistory.viewHistory();
            var historyList = [];
            for(viewId in history.views){
                var view = history.views[viewId];
                historyList.push(view.url);
            }
            var loadingConfig = {templateUrl:'templates/loading.html'};
            if(historyList.indexOf(currentPath) > -1){
                loadingConfig.duration = 600;
            }
            $ionicLoading.show(loadingConfig);
        }
        */
    });
    $scope.$on('$ionicView.afterEnter', function(evt, state) {
        if (!state.fromCache) {
            var initForPage = state.stateName + '-init';
            $scope.$broadcast(initForPage);
        } else {
            if (state.stateName == 'home') {
                $scope.$broadcast('home-network-init');
                $scope.$broadcast('home-preference-init');
            }
            if (state.stateName == 'login') {
                $scope.$broadcast('login-reset-form');
            }
        }
        // if(state.stateName=='home'){
        //     $scope.$broadcast('home-position-init');
        // }
    });

    $scope.$on('$ionicView.leave', function(e,state) {
        if (state.stateName == 'login') {
            $scope.$broadcast('login-leave');
        }
        if (state.stateName == 'register') {
            $scope.$broadcast('register-leave');
        }
    });

    $scope.myBack = function(){
        window.history.go(-1);
    };

    /**
     * 订单信息计时
     */
    $rootScope.orderInfoTime = null;

    $scope.showLoading = function(url) {
        var loadingConfig = {
            templateUrl: 'templates/' + url
        };
        $ionicLoading.show(loadingConfig);

        if($scope.hideLoadingHtml){
            $timeout.cancel($scope.hideLoadingHtml);
            $scope.hideLoadingHtml = null;
        }

        $scope.hideLoadingHtml = $timeout(function(){
            $scope.hideLoading();
        }, 8 * 1000 );
    };

    $scope.hideLoading = function() {
        $ionicLoading.hide();

        if($scope.hideLoadingHtml){
            $timeout.cancel($scope.hideLoadingHtml);
            $scope.hideLoadingHtml = null;
        }
    };

    $scope.enterHome = function() {
        $scope.showPrePage = false;
        window.localStorage.setItem('appVersion', appVersion);
        $scope.fadePreTipPage();
    };

    $scope.fadePreTipPage = function() {
        if (!$scope.showPrePage) {
            $scope.preTipFadeOut = true;
            $timeout(function() {
                $scope.showPreTipPage = false;
                var dom = $dom('#showPreTipPage');
                if(dom){
                    dom.style.display = 'none';
                }
            }, 2000);
        }
    };


    $scope.cartGlobal = {
        totalQuantity: 0,
        totalMoney: 0
    };
    $scope.currentFooterPath = '/home';
    $scope.showBarFooter = true;

    $scope.animationAddCart = function(url) {
        $scope.animationImgUrl = url;
        var dom = document.getElementsByClassName('hf-add-cart-animation');
        var angularDom = angular.element(dom);
        angularDom.css({
            'display': 'block'
        });
        $timeout(function() {
            angularDom.addClass('exec');
        }, 100);
        $timeout(function() {
            angularDom.css({
                'display': 'none'
            });
            angularDom.removeClass('exec');
        }, 2000);

    };

    $scope.init = function() {
        // $timeout(function() {
        //     $scope.fadePreTipPage();
        // }, 600);
        $scope.initCart();
    };
    $scope.initCart = function() {
        $scope.cartGlobal.items = cartFactory.getItemsList();
        $scope.cartGlobal.totalQuantity = cartFactory.getTotalQuantity();
        $scope.cartGlobal.totalMoney = cartFactory.getTotalMoney();
    };
    $scope.emptyCart = function() {
        cartFactory.emptyCart();
        $scope.$emit("changeCart");
    };
    $scope.minusQuantity = function(goods) {
        cartFactory.minusQuantity(goods);
        $scope.$emit("changeCart");
    };
    $scope.plusQuantity = function(goods){
        if($scope.canPlus(goods)){
            cartFactory.plusQuantity(goods);
            $scope.$emit("changeCart");
        }
    };
    $scope.canPlus = function(goods){
        var leftNumOne = goods.leftNumOne;
        var skuAllList = cartFactory.getItemsList();

        // if(leftNumOne == -1){
        //     '不限制'
        // }
        if(leftNumOne == 0){
            return false;
        }
        if(leftNumOne > 0){
            var buyCount = 0;
            for (var i = 0; i < skuAllList.length; i++) {
                var sku = skuAllList[i];
                if(sku.goodsSpuId == goods.goodsSpuId){
                    buyCount += sku.cNum;
                }
            }

            if(buyCount >= leftNumOne){
                return false;
            }
        }
        return true;
    };
    $scope.parsePlusBtn = function(goods){
        if(!$scope.canPlus(goods)){
            return './img/icon_cart_plus_gray.png';
        }
        return './img/icon_cart_plus.png';
    };
    $scope.toggleFooterCart = function() {
        /* 这里是底部 */
        var domFooter = document.getElementById('footerCartPanel');
        var angulardom = angular.element(domFooter);
        angulardom.toggleClass('open');

        /* 这里是遮罩 */
        var domBackdrop = document.getElementsByClassName('hf-backdrop-cart');
        var angularDomBackdrop = angular.element(domBackdrop);
        angularDomBackdrop.toggleClass('open');
    };

    $scope.$on('changeCart', function() {
        $scope.initCart();
    });


    /**** 屏幕swip、drag ***/
    $scope.onDragEnd = function() {
        $scope.toggleFooterCart();
    };

    $scope.onDragUp = function() {
        //$scope.hideTopBar();
        $scope.showHomeTopBar();
    };

    $scope.onDragDown = function() {
        //$scope.showTopBar();
        $scope.hideHomeTopBar();
    };
    $scope.homeTopBarNoBackground = false;

    $scope.showHomeTopBar = function() {
        var showScrollPosition = 120;
        var noBackgroundPosition = 44;
        var scrollPosition = $ionicScrollDelegate.getScrollPosition().top;
        var percent = parseFloat(scrollPosition / showScrollPosition);


        var dom = $dom('#homeTopBar');
        dom.style.background = 'rgba(255, 80, 1, ' + percent + ')';
        if (scrollPosition > noBackgroundPosition) {
            var domPosition = $dom('#homeTopBarPosition');
            var domSearch = $dom('#homeTopBarSearch');
            addClass(domPosition, 'home-top-bar-nobackground');
            addClass(domSearch, 'home-top-bar-nobackground');
        }
    };
    $scope.hideHomeTopBar = function() {
        var showScrollPosition = 120;
        var noBackgroundPosition = 44;
        var scrollPosition = $ionicScrollDelegate.getScrollPosition().top;
        var percent = parseFloat(scrollPosition / showScrollPosition);


        var dom = $dom('#homeTopBar');
        dom.style.background = 'rgba(255, 80, 1, ' + percent + ')';
        if (scrollPosition < noBackgroundPosition) {
            var domPosition = $dom('#homeTopBarPosition');
            var domSearch = $dom('#homeTopBarSearch');
            removeClass(domPosition, 'home-top-bar-nobackground');
            removeClass(domSearch, 'home-top-bar-nobackground');
        }
    };

    /**
     * 页面滚动时，改变顶栏的背景
     */
    $scope.changeTopBar = function() {
        var showScrollPosition = 120;
        var noBackgroundPosition = 44;
        var scrollPosition = $ionicScrollDelegate.getScrollPosition().top;
        var percent = parseFloat(scrollPosition / showScrollPosition);

        var dom = $dom('#homeTopBar');
        dom.style.background = 'rgba(255, 80, 1, ' + percent + ')';
        if (scrollPosition > noBackgroundPosition) {
            var domPosition = $dom('#homeTopBarPosition');
            var domSearch = $dom('#homeTopBarSearch');
            var domScanner = $dom('#homeTopBarScanner');
            addClass(domPosition, 'home-top-bar-nobackground');
            addClass(domSearch, 'home-top-bar-nobackground');
            addClass(domScanner, 'home-top-bar-nobackground');
        }
        if (scrollPosition < noBackgroundPosition) {
            var domPosition = $dom('#homeTopBarPosition');
            var domSearch = $dom('#homeTopBarSearch');
            var domScanner = $dom('#homeTopBarScanner');
            removeClass(domPosition, 'home-top-bar-nobackground');
            removeClass(domSearch, 'home-top-bar-nobackground');
            removeClass(domScanner, 'home-top-bar-nobackground');
        }
    };

    /**
     * 购买特惠专区的商品Spu
     * @param  {Object} data 商品数据
     * @return
     */
    $scope.buyPreferenceSpu = function(data){
        // console.log(data);

        if(!(data.isStart && !data.isEnd)){
            // $scope.showAlertWindow('还没开始或已结束。');
            return false;
        }
        if(!userLocationFactory.isLoggedIn()){
            $scope.toLogin();
            // $scope.showAlertWindow('您还没有登录，请登录。');
            return false;
        }
        if(data.leftNumOne == 0 ){
            // $scope.showAlertWindow('您已购买到最大限额，不能继续购买。');
            return false;
        }

        var info = data.preferenceGoodsSpu||{};
        info.leftNumOne = data.leftNumOne;
        info.preferenceId = data.preferenceId;
        $scope.showGoodsSku(info);

    };

    /***************加入购物车弹窗开始***************/
    /**
     * 打开商品弹窗
     * @param goodsObj 商品属性对象
     */
    $scope.showGoodsSku = function(goodsObj) {
        // console.log(goodsObj);

        if ($scope.cartGlobal.totalQuantity >= CART_MAX_LENGTH) {
            $ionicPopup.alert({
                title: '错误提示',
                template: '商品最多购买' + CART_MAX_LENGTH + '个!',
                buttons: [{
                    text: '确定',
                    type: 'button-assertive'
                }]
            });
            return false;
        }
        var num = $scope.cartSkuNum(goodsObj.goodsSpuSku[0]) || 1;
        var backdropDom = document.getElementsByClassName('backdrop')[0];
        backdropDom.style.display = 'block';
        $scope.goods = {}; //商品数据
        $scope.price = {}; //商品价格
        $scope.onChecked = 0; //选中skuId
        $scope.gotoCartObj = {}; //传到购物车数据
        $scope.gotoCartObj.cNum = num; //弹窗商品数量
        $scope.choiceNum = 0; //配料选择数量
        $scope.choiceIngredientObj = {}; //选中配料数据
        $scope.skuObj = {}; //选中sku数据
        $scope.goodsIngredient = Object.keys(goodsObj.goodsSpuIngredients).length;

        $scope.goods = goodsObj;
        $scope.goodsSkuImg = $scope.goods.goodsSpuSku[0].goodsSkuImg || $scope.goods.goodsSpuImgs[0];
        $ionicPopup.show({
                templateUrl: 'popup_window.html',
                scope: $scope,
                cssClass: 'popup_window',
                buttons: [{
                    text: ''
                }]
            })
            .then(function() {
                var backdropDom = document.getElementsByClassName('backdrop')[0];
                backdropDom.style.display = 'none';
                if (hefenAddCart) {
                    hefenAddCart = false;
                    $scope.gotoCartObj.goodsSpuId = $scope.goods.goodsSpuId;
                    $scope.gotoCartObj.goodsSpuName = $scope.goods.goodsSpuName;
                    $scope.gotoCartObj.goodsSpuImgs = $scope.goods.goodsSpuImgs;
                    $scope.gotoCartObj.goodsSpuShopBrandName = $scope.goods.goodsSpuShopBrandInfo.shopBrandName;
                    $scope.gotoCartObj.goodsSpuShopBrandId = $scope.goods.goodsSpuShopBrandInfo.shopBrandId;
                    $scope.gotoCartObj.goodsSpuType = $scope.goods.goodsSpuType;
                    $scope.gotoCartObj.leftNumOne = $scope.goods.leftNumOne;
                    $scope.gotoCartObj.preferenceId = $scope.goods.preferenceId;
                    $scope.gotoCartObj.hideShop = $scope.goods.hideShop;
                    if ($scope.choiceIngredientObj) {
                        $scope.gotoCartObj.ingredientsInfo = $scope.choiceIngredientObj;
                    }
                    $scope.animationAddCart(parseImgUrlNew($scope.goods.goodsSpuImgs, 'small'));
                    cartFactory.addItem($scope.gotoCartObj);
                    $scope.$emit("changeCart");
                }
            });
        $scope.choiceSku($scope.goods.goodsSpuSku[0]);
        var popupButton = document.getElementsByClassName('popup-buttons')[0];
        popupButton.style.display = 'none';
    };

    /**
     * 点击Sku
     * @param skuObj sku属性对象
     * @param categoryName sku属性名
     */
    $scope.choiceSku = function(skuObj) {
        var num = $scope.cartSkuNum(skuObj);
        $scope.gotoCartObj.cNum = num;
        if ($scope.onChecked == skuObj.goodsSkuId) {
            $scope.initializationPop();
        } else {
            if (skuObj.goodsSkuImg) {
                $scope.goodsSkuImg = skuObj.goodsSkuImg;
            } else if ($scope.goodsSkuImg != $scope.goods.goodsSpuImgs[0]) {
                $scope.goodsSkuImg = $scope.goods.goodsSpuImgs[0];
            }
            $scope.skuObj = skuObj;
            $scope.onChecked = skuObj.goodsSkuId;
            $scope.totlePrice();
            $scope.gotoCartObj.goodsSkuName = skuObj.goodsSkuName;
            $scope.gotoCartObj.goodsSkuId = skuObj.goodsSkuId;
            // $scope.gotoCartObj.goodsSkuPromotionPrice = skuObj.goodsSkuPromotionPrice || 0; // 切记不能使用促销价，会减两次
            $scope.gotoCartObj.goodsSkuPrice = skuObj.goodsSkuPrice;
            $scope.gotoCartObj.goodsSkuPromotion = skuObj.goodsSkuPromotion || [];
            $scope.gotoCartObj.goodsSkuScanDown = skuObj.goodsSkuScanDown || 0;
            $scope.gotoCartObj.goodsSkuScanLimit = skuObj.goodsSkuScanLimit || 0;
        }
    };

    /**
     * 弹窗商品数量运算
     * @param operation 加减法
     */
    $scope.changeGoodsNum = function(operation) {

        var leftNum = $scope.goods.leftNumOne;
        var tmpNum = $scope.gotoCartObj.cNum;
        var buyCount = 0;
        var skuAllList = cartFactory.getItemsList();
        for (var i = 0; i < skuAllList.length; i++) {
            var sku = skuAllList[i];
            if(sku.goodsSpuId == $scope.goods.goodsSpuId){
                buyCount += sku.cNum;
            }
        }
        var thisItem = arrayGetItemByKey(skuAllList, 'goodsSkuId', $scope.gotoCartObj.goodsSkuId) || {};
        var thisNum = thisItem.cNum || 0;
        var canNum = leftNum - ( buyCount - thisNum );

        if ($scope.onChecked) {
            if (operation == "sub") {
                if ($scope.gotoCartObj.cNum != 1) {
                    $scope.gotoCartObj.cNum--;
                }
            } else {
                if( canNum && canNum > 0 ){
                    if( $scope.gotoCartObj.cNum < canNum ) {
                        $scope.gotoCartObj.cNum++;
                    }
                }else{
                    $scope.gotoCartObj.cNum++;
                }
            }
        }
        if ($scope.choiceNum) {
            $scope.ingredientNum();
        }
        $scope.totlePrice();
    };

    /**
     * 点击配配料
     * @param ingredient 配料信息
     * @param limit 选择配料数量最大值
     */
    $scope.choiceIngredient = function(ingredient, limit) {
        if ($scope.onChecked) {
            if ($scope.choiceIngredientObj[ingredient.ingredientsId]) {
                $scope.choiceNum -= $scope.choiceIngredientObj[ingredient.ingredientsId].num;
                delete $scope.choiceIngredientObj[ingredient.ingredientsId];
            } else {
                if ($scope.choiceNum < limit) {
                    if (!$scope.choiceIngredientObj[ingredient.ingredientsId]) {
                        $scope.choiceIngredientObj[ingredient.ingredientsId] = {};
                    }
                    $scope.choiceIngredientObj[ingredient.ingredientsId] = ingredient;
                    $scope.choiceIngredientObj[ingredient.ingredientsId].num = 1;
                    $scope.choiceNum++;
                }
            }
            $scope.ingredientNum();
            $scope.totlePrice();
        }
    };

    /**
     * 配料数量运算
     * @param ingredientsName 配料名
     * @param operation 加减法
     */
    $scope.changeIngredientsNum = function(ingredientsId, operation) {
        if ($scope.onChecked) {
            var ing = $scope.choiceIngredientObj[ingredientsId];
            if (operation == "sub") {
                if (ing.num != 1) {
                    ing.num--;
                } else {
                    delete $scope.choiceIngredientObj[ingredientsId];
                }
                $scope.choiceNum--;
            } else {
                if ($scope.choiceNum < $scope.goods.goodsSpuIngredients.limitNum) {
                    ing.num++;
                    $scope.choiceNum++;
                }
            }
            $scope.ingredientNum();
            $scope.totlePrice();
        }
    };

    /**
     * 配料数量显示
     */
    $scope.ingredientNum = function() {
        if ($scope.choiceIngredientObj) {
            angular.forEach($scope.choiceIngredientObj, function(ingredient, ingredientsId) {
                $scope.choiceIngredientObj[ingredientsId].showNum = ingredient.num * $scope.gotoCartObj.cNum;
            });
        }
    };

    /**
     * 价格计算
     */
    $scope.totlePrice = function() {
        if ($scope.onChecked) {
            var iPrice = 0;
            var tPriceSku = $scope.skuObj.goodsSkuPromotionPrice;
            var priceSku = $scope.skuObj.goodsSkuPrice;
            if ($scope.choiceIngredientObj) {
                angular.forEach($scope.choiceIngredientObj, function(ingredient) {
                    ingredient.showPrice = accMul(ingredient.ingredientsPrice, ingredient.num, 1);
                    iPrice += parseFloat(ingredient.showPrice);
                });
            }
            if (tPriceSku && tPriceSku > 0) {
                $scope.price.cPrice = accMul(parseFloat(accAdd(tPriceSku, iPrice, 1)), $scope.gotoCartObj.cNum, 1);
                $scope.price.oPrice = accMul(parseFloat(accAdd(priceSku, iPrice, 1)), $scope.gotoCartObj.cNum, 1);
                // $scope.gotoCartObj.unitCPrice = accAdd(tPriceSku, iPrice, 1);
                // $scope.gotoCartObj.unitOPrice = accAdd(priceSku, iPrice, 1);
            } else {
                $scope.price.cPrice = accMul(parseFloat(accAdd(priceSku, iPrice, 1)), $scope.gotoCartObj.cNum, 1);
                $scope.price.oPrice = 0;
                // $scope.gotoCartObj.unitCPrice = accAdd(priceSku, iPrice, 1);
                // $scope.gotoCartObj.unitOPrice = 0;
            }
            // $scope.gotoCartObj.cPrice = $scope.price.cPrice;
            // $scope.gotoCartObj.oPrice = $scope.price.oPrice;
            // $scope.gotoCartObj.goodsPrice = $scope.gotoCartObj.unitOPrice ? $scope.gotoCartObj.unitOPrice : $scope.gotoCartObj.unitCPrice;
            $scope.gotoCartObj.iPrice = iPrice;
        }
    };

    /**
     * 获取购物车中，某商品已加入的数量
     * @param  {Object} sku 需要加入的某商品
     * @return {Integer}      某商品已加入的数量，如果没有此商品则返回 1
     */
    $scope.cartSkuNum = function(sku){
        var skuAllList = cartFactory.getItemsList();

        for (var i = 0; i < skuAllList.length; i++) {
            var cartSku = skuAllList[i];
            if(cartSku.goodsSkuId == sku.goodsSkuId){
                return cartSku.cNum;
            }
        }
        return 1;
    };

    /**
     * 订单商品格式转换成购物车需要的商品格式
     * @param dataObj
     */
    $scope.orderGoodsTurnCartGoods = function(dataObj) {

        var result = [];
        var dataList = [];
        for (shopId in dataObj) {
            var info = dataObj[shopId];
            var goodsList = info.singleGoods || [];
            for (promotionId in info.groupGoods) {
                var promotionInfo = info.groupGoods[promotionId];
                goodsList = goodsList.concat(promotionInfo.goodses || []);
            }
            dataList = dataList.concat(goodsList);
        }

        for (var i = 0; i < dataList.length; i++) {
            var _goods = dataList[i];
            // var goods = {
            //     goodsSpuId: _goods.goodsSpuId,
            //     goodsSpuName: _goods.goodsSpuName,
            //     goodsSpuImgs: _goods.goodsSpuImgs,
            //     goodsSpuShopBrandName: _goods.goodsSpuShopBrandName,
            //     goodsSpuShopBrandId: _goods.goodsSpuShopBrandId,
            //     ingredientsInfo: _goods.goodsSkuIngredients || {},
            //     goodsSkuName: _goods.goodsSkuName,
            //     goodsSkuId: _goods.goodsSkuId,
            //     goodsSkuPromotionPrice: _goods.goodsSkuPrice.promotionalPrice,
            //     goodsSkuPrice: _goods.goodsSkuPrice.originalPrice,
            //     goodsSkuPromotion: _goods.goodsSkuPromotionInfo || [],
            //     cNum: _goods.goodsNum,
            //     cPrice: (_goods.goodsSkuPrice.promotionalPrice * _goods.goodsNum),
            //     oPrice: 0,
            //     unitCPrice: _goods.goodsSkuPrice.promotionalPrice,
            //     unitOPrice: 0,
            //     goodsPrice: _goods.goodsSkuPrice.originalPrice,
            //     goodsSpuType: _goods.goodsSpuType
            // };
            var goods = {
                "cNum": _goods.goodsNum,
                "cPrice": 0,
                "iPrice":  _goods.iPrice || 0,
                "goodsSkuName": _goods.goodsSkuName,
                "goodsSkuId": _goods.goodsSkuId,
                "goodsSkuPrice": _goods.goodsSkuPrice.originalPrice || 0,
                "goodsSkuPromotion": _goods.goodsSkuPromotionInfo || [],
                "goodsSkuScanDown": 0,
                "goodsSkuScanLimit": 0,
                "goodsSpuId": _goods.goodsSpuId,
                "goodsSpuName": _goods.goodsSpuName,
                "goodsSpuImgs": _goods.goodsSpuImgs,
                "goodsSpuShopBrandName": _goods.goodsSpuShopBrandName,
                "goodsSpuShopBrandId": _goods.goodsSpuShopBrandId,
                "goodsSpuType": _goods.goodsSpuType,
                "ingredientsInfo": _goods.goodsSkuIngredients || {}
            };
            result.push(goods);
        }
        return result;
    };

    /**
     * 初始化
     */
    $scope.initializationPop = function() {
        $scope.skuObj = {};
        $scope.onChecked = 0;
        $scope.price = {};
        if ($scope.choiceIngredientObj) {
            $scope.choiceIngredientObj = {};
            $scope.choiceNum = 0;
        }
        if ($scope.goodsSkuImg != $scope.goods.goodsSpuImgs[0]) {
            $scope.goodsSkuImg = $scope.goods.goodsSpuImgs[0];
        }
    };
    /***************加入购物车弹窗结束***************/

    /***************警告弹窗开始***************/
    $scope.showAlertWindow = function(text, page) {
        $scope.popupAlertMsg = text;
        if (page) {
            $ionicPopup.show({
                    templateUrl: 'popup_alert.html',
                    scope: $scope,
                    cssClass: 'popup_window',
                    buttons: [{
                        text: '确定'
                    }]
                })
                .then(function() {
                    $ionicHistory.goBack();
                });
        } else {
            $ionicPopup.show({
                templateUrl: 'popup_alert.html',
                scope: $scope,
                cssClass: 'popup_window',
                buttons: [{
                    text: '确定'
                }]
            })
        }
        var popupBodyArr = document.getElementsByClassName('popup-body');
        var popupBody = popupBodyArr[popupBodyArr.length - 1];
        popupBody.style.padding = 0;
        var popupArr = document.getElementsByClassName('popup');
        var popup = popupArr[popupArr.length - 1];
        popup.style.borderRadius = 5 + "px";
        var popupButtonArr = document.getElementsByClassName('popup-buttons');
        var popupButton = popupButtonArr[popupButtonArr.length - 1];
        popupButton.style.display = 'none';
    };
    /***************警告弹窗结束***************/
    /***************取消订单弹窗开始***************/
    $scope.showCancelOrderAlertWindow = function(text) {
    	$scope.popupAlertMsg = text;
		$ionicPopup.show({
			templateUrl: 'cancel_order_alert.html',
			scope: $scope,
			cssClass: 'popup_window',
			buttons: [{
				text: '确定'
			}]
		})
		var popupBodyArr = document.getElementsByClassName('popup-body');
        var popupBody = popupBodyArr[popupBodyArr.length - 1];
        popupBody.style.padding = 0;
        var popupArr = document.getElementsByClassName('popup');
        var popup = popupArr[popupArr.length - 1];
        popup.style.borderRadius = 5 + "px";
        var popupButtonArr = document.getElementsByClassName('popup-buttons');
        var popupButton = popupButtonArr[popupButtonArr.length - 1];
        popupButton.style.display = 'none';
    };
    /***************取消订单弹窗结束***************/

    /***************页面跳转开始***************/
    $scope.toLogin = function(){
        $state.go('login');
    };

    $scope.backHomeAfterChoiceCommunity = function(){
        $scope.toHome();
        $timeout(function(){
            $scope.$broadcast('clear-data-for-home');
        }, 100);
    };

    /**
     * 跳转首页
     */
    $scope.toHome = function() {
        $state.go('home');
    };

    /**
     * 商品列表
     * @param sortId 品类Id
     * @param sortName 品类名称
     */
    $scope.toProductList = function(sortId, sortName, secondId, threeId) {
        $ionicHistory.clearCache(['product-list']);
        window.localStorage.setItem('productListStatus', "product");
        window.localStorage.setItem('categoryId', sortId);
        window.localStorage.setItem('categoryName', sortName);
        window.localStorage.setItem('categorySecondLevelId', secondId);
        window.localStorage.setItem('categoryThreeLevelId', threeId);
        $timeout(function() {
            $state.go('product-list');
        }, 200);
    };

    $scope.toCustomProductList = function(list, name) {
        $ionicHistory.clearCache(['product-list-custom']);
        var str = angular.toJson(list);
        window.localStorage.setItem('customProductIdList', str);
        window.localStorage.setItem('customProductName', name);
        $timeout(function() {
            $state.go('product-list-custom');
        }, 200);

    };

    /**
     * 店铺列表
     * @param sortId 品类Id
     * @param sortName 品类名称
     */
    $scope.toShopList = function(sortId, sortName, secondId, threeId) {
        $ionicHistory.clearCache(['shop-list']);
        window.localStorage.setItem('categoryId', sortId);
        window.localStorage.setItem('categoryName', sortName);
        window.localStorage.setItem('categorySecondLevelId', secondId);
        window.localStorage.setItem('categoryThreeLevelId', threeId);
        $timeout(function() {
            $state.go('shop-list');
        }, 100);
    };

    /**
     * 店铺商品列表
     * @param shopName 店铺名
     */
    $scope.toShopProductList = function(shopBrandName) {
        $ionicHistory.clearCache(['shop-product-list']);
        window.localStorage.setItem('shopProductList', shopBrandName);
        $timeout(function(){
            $state.go('shop-product-list');
        }, 100);
    };

    /**
     * 评价列表
     * @param goodsId 商品Id
     */
    $scope.toEvaluationList = function(goodsId) {
        window.localStorage.setItem('evaluationList', goodsId);
        $state.go('evaluation');
    };

    /**
     * 商品详情
     * @param goodsId
     */
    $scope.toProductDetails = function(goodsId, resource) {
        $ionicHistory.clearCache(['product-details']);
        window.localStorage.setItem('productDetails', goodsId);
        window.localStorage.setItem('productDetailsResource', resource || '');
        $timeout(function(){
            $state.go('product-details');
        }, 100);

    };

    /**
     * 店铺详情
     * @param goodsId
     */
    $scope.toShopDetails = function(goods) {
        if (goods.goodsSpuType == 1) {
            var shopId = goods.goodsSpuShopBrandInfo.shopBrandId;
            shopBrandService.queryShopBrandDetails(function(data) {
                if (data.resultCode == 'success') {
                    window.localStorage.setItem('shopDetails', shopId);
                    $state.go('shop-details');
                } else {
                    var confirmPopup = $ionicPopup.alert({
                        title: '错误提示',
                        template: data.resultMsg || '获取店铺信息错误，请稍后重试！',
                        buttons: [{
                            text: '确定',
                            type: 'button-assertive'
                        }]
                    });
                }
            }, shopId);
        }
    };

    /**
     * 跳转购物车
     */
    $scope.toCart = function(isToggle) {
        if(!isToggle){
            $scope.toggleFooterCart();
        }
        $ionicHistory.clearCache(['cart']);
        $timeout(function(){
            $state.go('cart');
        }, 200);
    };

    /**
     * 跳转创建用户收货地址页面
     */
    $scope.toCreateAddress = function(url) {
        window.localStorage.setItem('createAddressUrlSource', url);
        $state.go('create-address');
    };

    /**
     * 跳转订单提交页面
     */
    $scope.toOrderCommit = function() {
        //window.localStorage.setItem('shopDetails', goodsId);
        $timeout(function(){
            var url = 'order-commit';
            if((typeof orderListVersion) === 'function'){
                var v = orderListVersion(appEnvironment);
                if(v){
                  url = 'order-commit-' + v;
                }
            }
            $state.go(url);
        }, 100);
    };

    /**
     * 跳转订单列表页面
     */
    $scope.toOrderList = function() {
        $ionicHistory.clearCache(['order-list']);
        $ionicHistory.clearCache(['order-list-v2']);
        $timeout(function(){
            var url = 'order-list';
            if((typeof orderListVersion) === 'function'){
                var v = orderListVersion(appEnvironment);
                if(v){
                    url = 'order-list-' + v;
                }
            }
            $state.go(url);
        }, 100);
    };

    /**
     * 跳转地址管理页面
     */
    $scope.toAddressMessage = function(urlSource) {
        var url = !!urlSource ? urlSource : '';
        window.localStorage.setItem('DefaultAddressUrlSource', url);
        $ionicHistory.clearCache(['address-message']);
        $timeout(function(){
            $state.go('address-message');
        }, 100);

    };

    /**
     * 跳转选择小区页面
     */
    $scope.toFindCommunity = function() {
        $state.go('find-community');
    };

    /**
     * 跳转订单评价页面
     */
    $scope.toOrderEvaluate = function() {
        $state.go('order-evaluate');
    };

    /**
     * 跳转订单信息详情页面
     */
    $scope.toOrderInfo = function(orderId, orderNum) {
        if (orderId) {
            window.localStorage.setItem('orderInfoOrderId', orderId);
        }
        if (orderNum) {
            window.localStorage.setItem('orderInfoOrderNum', orderNum);
        }
        $state.go('order-info');
    };

    /**
     * 跳转订单跟踪页面
     */
    $scope.toOrderTracking = function(orderAppNum) {
        if (orderAppNum) {
            localStorage.setItem("orderTrackingOrderAppNum", orderAppNum);
        }
        $state.go('order-tracking');
    };

    /**
     * 跳转在线支付页面
     */
    $scope.toOnlinePay = function(orderInfoObj) {
        var onlinePayString = orderInfoObj.orderNum + ";:;" + orderInfoObj.goodsName + ";:;" + orderInfoObj.goodsDescription + ";:;" + orderInfoObj.price + ";:;" + orderInfoObj.orderAddress.contactPerson + ";:;" + orderInfoObj.orderAddress.communityName + orderInfoObj.orderAddress.addressContent + ";:;" + orderInfoObj.orderId;
        window.localStorage.setItem('onlinePayString', onlinePayString);
        $state.go('pay-online');
    };

    /**
     * 跳转到分类页面
     */
    $scope.toClassification = function() {
        $state.go('classification');
    };

    /**
     * 跳转到用户中心
     */
    $scope.toUserCenter = function() {
        $ionicHistory.clearCache(['user-center']);
        $timeout(function(){
            $state.go('user-center');
        }, 100);
    };

    /**
     * 跳转到配送位置选择页面
     */
    $scope.toPositionList = function() {
        $state.go('position-list');
    };

    /**
     * 跳转修改小区页面
     * @param url 上一个页面的地址
     */
    $scope.toUpdateCommunity = function(url) {
        window.localStorage.setItem('updateCommunityUrlSource', url);
        $state.go('update-community');
    };

    /**
     * 跳转到联系人页面
     */
    $scope.toContact = function() {
        $state.go('contact-list');
    };

    /**
     * 跳转到搜索页面
     */
    $scope.toSearchPage = function() {
        $ionicHistory.clearCache(['search']);
        $timeout(function() {
            $state.go('search');
        }, 100);
    };

    $scope.setSearchFocus = function() {
        var dom = $dom('#hfSearchInput');
        dom.focus();
    };

    $scope.toCustomPage = function(title, url){
        // window.open(url, '_blank');
        $ionicHistory.clearCache(['custom-page']);
        window.localStorage.setItem('customPageTitle', title);
        window.localStorage.setItem('customPageUrl', url);
        $timeout(function() {
            $state.go('custom-page');
        }, 100);
    };

    /**
     * 跳转广告
     */
    $scope.goAdvertPage = function(advert) {
        $scope.goAdvertPageByBack(advert);

        // if (advert.advertisementType == hashGetKey(advertEnum, 'shop')) {
        //     //跳转到店铺商品列表，需要店铺名称
        //     $scope.toShopProductList(advert.advertisementTypeInfo.shopBrandName);
        // }
        // if (advert.advertisementType ==  hashGetKey(advertEnum, 'category')) {
        //     //跳转到分类商品列表，需要分类id 分类名称
        //     //$scope.toProductList(advert.advertisementTypeInfo.categoryId, advert.advertisementTypeInfo.categoryName)
        //     var firstLevelId;
        //     var secondLevelId;
        //     var info = advert.advertisementTypeInfo || {};

        //     if (parseInt(info.categoryPId) == 0) {
        //         firstLevelId = info.categoryId;
        //         secondLevelId = null;
        //     }
        //     if (parseInt(info.categoryPId) != 0) {
        //         firstLevelId = info.categoryPId;
        //         secondLevelId = info.categoryId;
        //     }
        //     $scope.toProductList(firstLevelId, info.categoryName, secondLevelId);

        // }
        // if (advert.advertisementType == hashGetKey(advertEnum, 'area')) {

        // }
        // if (advert.advertisementType == hashGetKey(advertEnum, 'goods')) {
        //     //跳转商品详情 需要商品id
        //     $scope.toProductDetails(advert.advertisementTypeInfo.goodsSpuId);
        // }

    };

    $scope.goAdvertPageByBack = function(advert){
        // console.log(advert);
        goodsService.advertJump(function(data){
            // console.log('appCtrl',data);
            if(data.resultCode == 'success'){
                var result = data.resultTO || {};
                var str = '$scope.' + result.methodName + result.params;
                // var str = '$scope.' + 'toCustomPage' + "('我是标题','http://www.baidu.com')";
                // console.log(str);
                eval(str);
            }else{
                $ionicPopup.alert({
                    title: '提示信息',
                    template: data.resultMsg || '程序错误',
                    okText: '确定'
                });
            }
        }, advert.advertisementId);

    };

    /**
     * 公共返回按钮
     */
    $scope.goBack = function(){
        $ionicHistory.goBack();
    };

    /**
     * 网络错误页面的返回按钮点击事件
     */
    $scope.goBackForError = function() {
        var url = window.localStorage.getItem('backUrlForError');
        if (url) {
            $ionicHistory.clearCache([url]);
            $timeout(function(){
                $state.go(url);
            }, 200);
        } else {
            $state.go('home');
        }
    };

    /**
     * 跳转优惠券页面
     */
    $scope.toCouponList = function( formHtml ) {
    	if( formHtml == 'userCenter' ){
    		window.localStorage.setItem('formHtml','userCenter');
    	}else if( formHtml == 'orderCommit' ){
    		window.localStorage.setItem('formHtml','orderCommit');
    	}
        $ionicHistory.clearCache(['coupon-list']);
        $timeout(function(){
            $state.go('coupon-list');
        }, 100);
    };

    $scope.toRegist = function(){
        $state.go('register');
    };
    /**
    *跳转到积分
    */
    $scope.toIntegral=function(){
        $ionicHistory.clearCache(['integral-page']);
        $timeout(function(){
            $state.go('integral-page');
        }, 100);
    };
    /***************页面跳转结束***************/

    /***************搜索功能开始***************/
    $scope.search = {};
    $scope.searchByword = {};
    $scope.searchGoods = function() {
        window.localStorage.setItem('productListStatus', "search");
        window.localStorage.setItem('searchTerm', $scope.search.term);
        window.localStorage.setItem('searchListUseCategory', false);
        if ($location.path() == '/product-list') {
            $scope.$broadcast('searchGoodsInner');
        } else {
            $state.go('product-list');
        }
    };
    /**
     * 当搜索页面的搜索框内容改变时触发的函数
     */
    $scope.loadSearchKey = function() {
        $scope.$broadcast('loadByKeyInSearchPage');
    };
    /**
     * 点击页面中的热门搜索词语和历史搜索词语 执行app.js中的方法 $scope.searchGoods();
     * @param word 搜索词语
     */
    $scope.searchGoodsByKeyword = function(word) {
        if (!!word) {
            $ionicHistory.clearCache(['product-list']);
            $scope.search.term = word;
            $timeout(function() {
                $scope.searchGoods();
            }, 200);
        }
    };
    /**
     * 监听搜索页面的键盘事件
     * @param evt 事件
     * 如果是回车事件，则进行搜索
     */
    $scope.loadSearchDataByKeyup = function(evt) {
        if (evt.keyCode == 13) {
            $scope.searchGoodsByKeyword($scope.searchByword.term);
        }
    };
    /***************搜索功能结束***************/
    /***************在线支付开始***************/
    $scope.onlinePay = function(infoObj, mode) {
        window.localStorage.setItem("orderInfoOrderId", infoObj.orderId);
        window.localStorage.setItem("orderInfoOrderNum", infoObj.orderNum);
        if (mode == "alipay") {
            orderService.queryAlipayOrderInfo(function(data) {
                if (data.resultCode == "success") {
                    if (mobileSystem == "android") {
                        var aliAndroidString = data.resultTO + ";:;" + infoObj.orderNum;
                        cordova.exec(function(success) {}, function(error) {}, "RunAlipay", "goalipay", aliAndroidString);
                    } else if (mobileSystem == "ios") {
                        alipay(data.resultTO);
                    }
                } else if (data.resultCode == "failed") {
                    $scope.showAlertWindow(data.resultMsg);
                }
            }, infoObj.orderId);
        } else if (mode == "wxpay") {
            orderService.weChatUnifiedPay(function(data) {
                if (data.resultCode == "success") {
                    if (mobileSystem == "android") {
                        var wxAndroidString = data.resultTO.appId + ";:;" + data.resultTO.partnerid + ";:;" + data.resultTO.prepay_id + ";:;" + data.resultTO.package + ";:;" + data.resultTO.nonceStr + ";:;" + data.resultTO.timeStamp + ";:;" + infoObj.orderNum + ";:;" + appEnvironment;
                        cordova.exec(function(success) {}, function(error) {}, "RunWXpay", "gowxpay", wxAndroidString);
                    } else if (mobileSystem == "ios") {
                        wxpay(data.resultTO.appId, data.resultTO.partnerid, data.resultTO.prepay_id, data.resultTO.package, data.resultTO.nonceStr, data.resultTO.timeStamp, infoObj.orderNum);
                    }

                } else if (data.resultCode == "failed") {
                    $scope.showAlertWindow(data.resultMsg);
                }
            }, infoObj.orderId);
        }

    };
    /***************在线支付结束***************/
    /***************支付宝同步请求开始***************/
    $scope.onlinePayInfoSynchronous = function( infoStr, orderId, orderNum ) {
        var resultObj = {};
        resultObj.orderNum = orderNum;
        resultObj.payInfo = infoStr;
        orderService.onlinePayInfoSynchronous(function(data) {
            $scope.onlinpayToHtml();
        }, resultObj);
    };
    /***************支付宝同步请求结束***************/
    $scope.onlinpayToHtml = function () {
        var versionV2 = (typeof orderListVersion) === 'function' && orderListVersion(appEnvironment) == 'v2';
        if( versionV2 ){
            $scope.toOrderList();
        }else{
            $scope.toOrderInfo( orderId );
        }
    };
    /***************微信同步请求开始***************/
    $scope.wxOnlinePayInfoSynchronous = function( orderId, orderNum ) {
        if( orderNum ){
            orderService.wxOnlinePayInfoSynchronous(function(data) {
                $scope.onlinpayToHtml();
            }, orderNum);
        }else{
            $scope.onlinpayToHtml();
        }
    };
    /***************微信同步请求结束***************/

    /**
     * 联系人
     */
    $scope.writeContactInAddress = function(contact) {

        $timeout(function() {
            $scope.$broadcast('writeContactInAddress', contact);
        }, 50);
    };

    $scope.scannerCode = function ( data, type ) {
        couponService.scanCodeEncrypted(function(msg) {
            //alert(JSON.stringify(msg));
            if (msg.resultCode == 'success') {
                var result = msg.resultTO;
                if (result.checkLogin && !userLocationFactory.isLoggedIn()) {
                    if(!result.skip){
                        window.localStorage.setItem('backUrlForScan', '');
                        window.localStorage.setItem('backUrl', $ionicHistory.currentStateName());
                    }else{
                        window.localStorage.setItem('backUrlForScan', result.method + result.params + '');
                    }
                    $state.go('login');
                    return false;
                }
                var str = '$scope.' + result.method + result.params;
                eval(str);
            } else {
                //alert(msg.resultMsg||'错误');
                $ionicPopup.alert({
                    title: '提示信息',
                    template: msg.resultMsg || '程序错误',
                    okText: '确定'
                });
            }
        }, data, type);
    }

    /**
     * 订单提交页面扫码减钱
     * 此方式是作为一个特殊优惠券方式
     * 此方法会广播一个方法，在订单提交页面进行监听接受，订单支付金额会减去相应的钱。
     * @param money 减的钱数
     * @param couponId 特殊优惠券的Id
     * @param resource 来源'scancode'
     */
    $scope.orderCommitScan = function(money, couponId, resource){
        $scope.$broadcast('orderCommitForScan',money, couponId, resource);
    };

    /**
     * 订单提交时，扫员工码进行优惠
     */
    $scope.orderCommitScanEmployee = function(streetMin, streetMax, platformMin, platformPersent, isFreight, name){
        $scope.$broadcast('orderCommitForScanEmployee', streetMin, streetMax, platformMin, platformPersent, isFreight, name);
    };

    /**
     * 扫码后，领取优惠券
     * 如果扫的码已被领取，则不能被领取，并提示 158****2323 已领取此码
     */
    $scope.pickupCouponScan = function(infoId, recommender, uuid){
        var userMobile = userLocationFactory.user().phone;
        couponService.addCoupon(function(data){
            if(data.resultCode){
                $scope.toCouponList();
            }else{
                $ionicPopup.alert({
                    title: '提示信息',
                    template: data.resultMsg || '程序错误',
                    okText: '确定'
                });
            }
        }, infoId, recommender, uuid, userMobile);
    };

    /**
     * 扫一扫
     */
    $scope.scanner = function() {
        // var code = '3323_Y291cG9uXzEzMjQxMTE1MjUzXzc4M2NjZTRhLTUxNjQtNDgzNy05NWJkLWUwNWU2NjRkNGYwMF8xNDgw'; // 扫码领取优惠券
        // var code = 'goods_19381'; // 商品扫码优惠，构成：构成：标志类型[goods] + 信息主体[商品SPU的Id]
        // var code = 'order_MTIzNDU2Nzg5'; // 有余额的优惠券，谁都能扫，构成：标志类型[order] + 信息主体[某券的唯一编码]
        // var code = '41B0CE78EE64F28DBE107C5CB02CACC9'; // 员工优惠码，构成：标志类型[employee] + 信息主体[手机号]，并且Base64加密
        // couponService.scanCodeEncrypted(function(msg){
        //     if(msg.resultCode == 'success'){
        //         var result = msg.resultTO;
        //         if (result.checkLogin && !userLocationFactory.isLoggedIn()) {
        //             if(!result.skip){
        //                 window.localStorage.setItem('backUrlForScan', '');
        //                 window.localStorage.setItem('backUrl', $ionicHistory.currentStateName());
        //             }else{
        //                 window.localStorage.setItem('backUrlForScan', result.method + result.params + '');
        //             }

        //             $state.go('login');
        //             return false;
        //         }
        //         var str = '$scope.' + result.method + result.params;
        //         eval(str);
        //     }else {
        //         //alert(msg.resultMsg||'错误');
        //         $ionicPopup.alert({
        //             title: '提示信息',
        //             template: msg.resultMsg || '程序错误',
        //             okText: '确定'
        //         });
        //     }
        // }, code, 'QR_CODE');

        // return false;
        if(mobileSystem == "ios"){
            scan();
        }else if(mobileSystem == "android"){
            if (window.cordova) {
                $cordovaBarcodeScanner.scan().then(function(imageData) {
                    // var str = '';
                    // str += 'text: ' + imageData.text + '\n';
                    // str += 'format: ' + imageData.format + '\n';
                    // str += 'cancelled: ' + imageData.cancelled + '\n';
                    // alert(str);
                    // console.log("Barcode Format -> " + imageData.format);
                    // console.log("Cancelled -> " + imageData.cancelled);
                    if (!imageData.cancelled) {
                        var data = imageData.text || '';
                        var type = imageData.format || '';
                        $scope.scannerCode( data, type );
                    }
                }, function(error) {
                    // console.log("An error happened -> " + error);
                });
            } else {
                $ionicPopup.alert({
                    title: '提示信息',
                    template: '不支持扫码',
                    okText: '知道了'
                });
            }
        }
    };

    $rootScope.orderCommitProductObj = {};
    $scope.init();
}]);

app.controller('subNavCtrl', ['$scope', '$rootScope', '$location', 'sunNavFactory', 'goodsService', 'shopBrandService', function($scope, $rootScope, $location, sunNavFactory, goodsService, shopBrandService) {
    var backdrop = hfBackdrop('.hf-backdrop-inner');
    // $scope.hfPosition = $rootScope.hfPosition || {};
    $scope.hfPosition = {lat: window.localStorage.getItem('userCommunityLat'), lon: window.localStorage.getItem('userCommunityLon')};
    $scope.showPosition = !!$scope.hfPosition.lat;
    $scope.categoryList = [];
    // $scope.sortId = !!$scope.hfPosition.lat ? "3" : "1";
    $scope.sortId = "1";
    $scope.categoryFirstLevelId = null;
    $scope.categorySecondLevelId = null;
    $scope.categoryThreeLevelId = null;
    $scope.categoryFirstName = '';
    $scope.showSubCategory = false;


    var init = function() {
        var path = $location.path();
        var status = window.localStorage.getItem('productListStatus');
        $scope.categoryFirstLevelId = parseInt(window.localStorage.getItem('categoryId')) || null;
        $scope.categoryFirstName = window.localStorage.getItem('categoryName') || '';
        $scope.categorySecondLevelId = parseInt(window.localStorage.getItem('categorySecondLevelId')) || null;
        $scope.categoryThreeLevelId = parseInt(window.localStorage.getItem('categoryThreeLevelId')) || null;

        if (path == '/shop-list') {
            initCategoryForShop();
        }
        if (path == '/product-list') {
            if (status != 'search') {
                initCategoryForProduct();
            }
        }

    };

    var initCategoryForShop = function() {
        var communityId = window.localStorage.getItem('userCommunityId');
        shopBrandService.queryShopBrandCategoryListByCommunity(function(data) {
            //console.log('店铺列表，获取分类数据：', data);
            $scope.categoryList = data;
        }, communityId, $scope.categoryFirstLevelId);
    };

    var initCategoryForProduct = function() {
        var communityId = window.localStorage.getItem('userCommunityId');
        goodsService.queryGoodsSpuCategoryListByCommunity(function(data) {
            //console.log('商品列表，获取分类数据：', data);
            $scope.categoryList = data;
        }, communityId, $scope.categoryFirstLevelId, $scope.categorySecondLevelId, $scope.categoryThreeLevelId);
    };

    $scope.changeSort = function(sortId, key) {
        $scope.sortId = sortId;
        $scope.showSubCategory = false;
        backdrop.close();
        if (key == 'shop') {
            sunNavFactory.loadShopBySort(sortId);
        }
        if (key == 'product') {
            sunNavFactory.loadProductBySort(sortId);
        }

    };

    $scope.changeCategory = function(categoryFirstId, categoryPId, categoryId, key) {
        //console.log('改变分类', categoryFirstId, categoryPId, categoryId);
        $scope.categoryFirstLevelId = categoryFirstId;
        $scope.categorySecondLevelId = categoryPId;
        $scope.categoryThreeLevelId = categoryId;
        $scope.showSubCategory = false;
        backdrop.close();
        if (key == 'shop') {
            sunNavFactory.loadShopByCategory(categoryFirstId, categoryPId, categoryId);
        }
        if (key == 'product') {
            sunNavFactory.loadProductByCategory(categoryFirstId, categoryPId, categoryId);
        }
    };

    $scope.showCategory = function() {
        $scope.showSubCategory = !$scope.showSubCategory;
        backdrop.toggle();
    };

    $scope.slideToggleCategory = function(id) {
        var dom = document.getElementById(id);
        var angulardom = angular.element(dom);
        angulardom.toggleClass('open');
    };

    $scope.$on('loadCategoryForSearch', function() {
        var data = sunNavFactory.categoryList;
        $scope.categoryList = data;
    });

    $scope.$on('closeBackdrop', function() {
        $scope.showSubCategory = false;
        backdrop.close();
    });

    init();
}]);

app.factory('sunNavFactory', ['$rootScope', function($rootScope) {
    var service = {};
    service.closeBackdrop = function() {
        $rootScope.$broadcast('closeBackdrop');
    };
    service.loadShopBySort = function(sortId) {
        this.shopSortId = sortId;
        $rootScope.$broadcast('loadShopBySort');
    };
    service.loadShopByCategory = function(categoryFirstId, categoryPId, categoryId) {
        this.categoryFirstId = categoryFirstId;
        this.categoryPId = categoryPId;
        this.categoryId = categoryId;
        $rootScope.$broadcast('loadShopByCategory');
    };
    service.loadProductBySort = function(sortId) {
        this.productSortId = sortId;
        $rootScope.$broadcast('loadProductBySort');
    };
    service.loadProductByCategory = function(categoryFirstId, categoryPId, categoryId) {
        this.categoryFirstId = categoryFirstId;
        this.categoryPId = categoryPId;
        this.categoryId = categoryId;
        $rootScope.$broadcast('loadProductByCategory');
    };
    service.loadCategoryForSearch = function(data) {
        this.categoryList = parseCategory(data);
        $rootScope.$broadcast('loadCategoryForSearch');
    };
    return service;
}]);

app.directive('onFinishRenderFilters', ['$timeout', function ($timeout) {
    return {
        restrict: 'A',
        link: function(scope, ele, attr) {
            if (scope.$last === true) {
                $timeout(function() {
                    scope.$emit('ngRenderFinished');
                });
            }
        }
    };
}]);

app.controller('customPageCtrl',['$scope', '$sce', function($scope, $sce){
    $scope.pageTitle = '';
    $scope.pageUrl = '';
    $scope.init = function(){
        var t = window.localStorage.getItem('customPageTitle');
        var u = window.localStorage.getItem('customPageUrl');
        // console.log(t, u);
        $scope.pageTitle = t;
        $scope.pageUrl = $sce.trustAsResourceUrl(u);

    };
    $scope.$on('custom-page-init', function(){
        $scope.init();
    });
}]);
