app.controller('classificationCtrl', ['$scope', 'goodsService', '$ionicScrollDelegate', '$timeout', '$ionicSlideBoxDelegate', 'advertService', function($scope, goodsService, $ionicScrollDelegate, $timeout, $ionicSlideBoxDelegate, advertService){
    $scope.innerAdvertStyle = {height:advertHeightSmall+'px'};

    $scope.sortAdvert = {};
    $scope.thisSortAdvert = "0";
    $scope.sortOneImgArr = [{
        advertisementImg:"./img/default_position.jpg"
    }];
    $scope.sortNameMap = [];
    $scope.selectSortName = "";
    $scope.selectSortNameTwo = "";
    $scope.selectSortNamePosition = "";
    $scope.scrollSortChangeStatus = true;
    $scope.start = true;
    $scope.stateHeight = function(){
        //var box = document.getElementsByClassName("slider")[0];
      //var boxHeight = box.clientHeight||0;
      //if(mobileSystem == "ios"){
      //    return boxHeight+20;
      //}
      //if(mobileSystem == "android"){
      //    return boxHeight;
      //}
      //return boxHeight;
      var winWidth = window.innerWidth;
      var slideWidth = winWidth * 0.75;
      var slideHeight = slideWidth / 16 * 6;
      return parseInt(slideHeight);
    };
    $scope.boxHeight = $scope.stateHeight();
    $scope.classContentHeight = window.innerHeight - 88 - $scope.boxHeight;

    $scope.goAdvertPageClass = function ( sortOneImg ) {
    	if( sortOneImg.advertisementImg != "./img/default_position.jpg" ){
    		$scope.goAdvertPageByBack(sortOneImg);
    	}
    }

    /**
     * 加载广告
     */
    $scope.loadAdvert = function( sortList ) {
        advertService.queryCategoryAdvertisementList(function(data){
            var formatData = {};
            for(key in data){
                var formatedArr = [];
                for(var i=0;i<data[key].length;i++){
                    data[key][i].advertisementImg = "http://"+data[key][i].advertisementImg;
                    formatedArr.push(data[key][i]);
                }
                formatData[key] = formatedArr;
            }
            $scope.sortAdvert = formatData;
            $scope.sortAdvert['0'] = $scope.sortOneImgArr;
            for( var i=0 ; i<sortList.length ; i++ ){
                if( !$scope.sortAdvert[sortList[i].categoryId] ) {
                    $scope.sortAdvert[sortList[i].categoryId] = $scope.sortOneImgArr;
                }
            }
        });
    };

    $scope.loadCategory = function (){
        goodsService.queryIndexCategory(function(data){
            $scope.sortListMap = data;
            $scope.loadAdvert(data);
            $scope.hideLoading();
        });
    };

    /**
     * 改变左侧导航栏选中项
     * @param name 选中名字
     */
    $scope.navChoiced = function( sort ){
        var navList = document.getElementsByName("sortNavList");
        var navSortName = document.getElementById("sortNav"+sort);
        var navListDom = angular.element(navList);
        var domActive = angular.element(navSortName);
        navListDom.removeClass('classificationNav-sortNameSelete');
        domActive.addClass('classificationNav-sortNameSelete');
    };

    $scope.slideHasChanged = function ( index ) {
    };

    /**
     * 点击分类改变商品列表位置
     * @param sortName 分类名
     */
    $scope.choiceSortName = function( sortName ){
        $scope.scrollSortChangeStatus = false;
        var ele = document.getElementById(sortName);
        $ionicScrollDelegate.scrollTo(0,ele.offsetTop,true);
        if($scope.timeSwitch){
            $timeout.cancel($scope.timeSwitch);
        }
        $scope.timeSwitch = $timeout(function(){
            $scope.scrollSortChangeStatus = true;
        }, 300);
        $scope.navChoiced( sortName );
        $ionicSlideBoxDelegate.stop();
        // $scope.sortOneImgArr = [];
        // $scope.sortOneImgArr = $scope.sortAdvert[sortName];
        $scope.thisSortAdvert = sortName;
        $ionicSlideBoxDelegate.update();
        $ionicSlideBoxDelegate.start();
        $ionicSlideBoxDelegate.loop(true);
    };

    /**
     * 滚动商品列表改变分类
     */
    $scope.sortNameShow = function(){
        if( $scope.start ) {
            angular.forEach($scope.sortListMap, function(sortFirst, i) {
                var ele = document.getElementById(sortFirst.categoryId);
                var obj = {};
                obj.id = sortFirst.categoryId;
                obj.top = ele.offsetTop;
                $scope.sortNameMap.push(obj);
            });
            $scope.start = false;
        }
        if($scope.scrollSortChangeStatus){
            var currTop = $ionicScrollDelegate.getScrollPosition().top;
            angular.forEach($scope.sortNameMap, function( sortList ) {
                if( sortList.top-5 < currTop ){
                    $scope.selectSortName = sortList.id;
                }
                if( $scope.selectSortName != $scope.selectSortNameTwo ) {
                    $scope.navChoiced( $scope.selectSortName );
                    $scope.selectSortNameTwo = $scope.selectSortName;
                }
            });
            if($scope.selectSortNameTwo != $scope.selectSortNamePosition){
                $ionicSlideBoxDelegate.stop();
                // $scope.sortOneImgArr = [];
                // $scope.sortOneImgArr = $scope.sortAdvert[$scope.selectSortNameTwo];
                $scope.thisSortAdvert = $scope.selectSortNameTwo;
                $ionicSlideBoxDelegate.update();
                $ionicSlideBoxDelegate.start();
                $ionicSlideBoxDelegate.loop(true);
                $scope.selectSortNamePosition = $scope.selectSortNameTwo;
            }
        }
    };

	/**
	 * 页面跳转
	 * @param obj 分类数据
	 */
	$scope.webPageJump = function( obj ){
		if( obj.categoryJump == 0 ){
			$scope.toShopList( obj.categoryFirstId, obj.categoryName, obj.categoryPid, obj.categoryId );
		}else{
			$scope.toProductList( obj.categoryFirstId, obj.categoryFirstName, obj.categoryPid, obj.categoryId );
		}
	};

    $scope.$on('classification-init', function(){
        $scope.showLoading('loading.html');
        $scope.loadCategory();
    });
}]);
