app.controller('couponListCtrl', ['$scope', '$rootScope', '$ionicPopup', '$timeout', 'paginationFactory', 'userLocationFactory', 'couponService', function($scope, $rootScope, $ionicPopup, $timeout, paginationFactory, userLocationFactory, couponService) {
    $scope.couponValidList = []; // 优惠券列表，可以使用
    $scope.couponInValidList = []; // 优惠券列表，不可以使用
    $scope.endData = false; // 数据是否已加载完成
    $scope.emptyData = false; // 第一次加载完后是否有数据，如果没有则为true
    $scope.scrool = true;
    $scope.fromHtml = window.localStorage.getItem('formHtml');
    $scope.shopBrandMessage = JSON.parse(window.localStorage.getItem('voucherShopId'));
    $scope.orderInfoIsV2 = (typeof orderListVersion) === 'function' && orderListVersion(appEnvironment) == 'v2';

    var page = paginationFactory.init();

    /**
     * 初始化
     */
    var init = function() {

    };

    /**
     * 排除已选中优惠券
     */
    $scope.checkCoupon = function ( data ) {
        if( $rootScope.orderCoupon ) {
            $rootScope.selectVoucherIds = {};
            for( shopId in $rootScope.orderCoupon ){
                $rootScope.selectVoucherIds[$rootScope.orderCoupon[shopId].couponRecordId] = true;
            }
        }
        if( Object.keys($rootScope.selectVoucherIds).length > 0 ){
            for( var i = 0; i < data.length ; i++ ){
                var couponId = data[i].couponRecordId;
                if( !$rootScope.selectVoucherIds[couponId] ){
                    $scope.couponValidList.push(data[i]);
                }
            }
            $scope.emptyData = $scope.couponValidList.length == 0;
        }else{
            $scope.couponValidList = data;
            $scope.emptyData = $scope.couponValidList.length == 0;
        }

    };

    /**
     * 加载优惠券数据
     */
    var loadData = function() {
        // console.log('加载数据中...');
        var phone = userLocationFactory.user().phone;
        // var phone = '18330236345';
        if ($scope.fromHtml == 'userCenter') {
        	if( !$scope.scrool ) {
            	return;
            }
            $scope.scrool = false;
            couponService.queryAllCouponListByUserMobile(function(data) {
                // console.log(JSON.stringify(data));
                $scope.couponValidList = data['valid'] || [];
                $scope.couponInValidList = data['invalid'] || [];
                $scope.emptyData = page.getCurrentPage() == 1 && $scope.couponValidList.length == 0 && $scope.couponInValidList.length == 0;
                $scope.endData = $scope.couponValidList.length == 0 && $scope.couponInValidList.length == 0;
                $scope.scrool = true;
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }, phone, page);
        } else if ($scope.fromHtml == 'orderCommit') {
            if( $scope.orderInfoIsV2 ){
              //window.localStorage.removeItem('voucherShopId');
              var goodsInfo = {};
              goodsInfo[$scope.shopBrandMessage.id] = $rootScope.orderCommitProductObjCoupon[$scope.shopBrandMessage.id];
              couponService.queryShopCouponListInShoppingCarNotCheckMoney(function(data) {
                $scope.checkCoupon(data);
              }, goodsInfo, phone, $scope.shopBrandMessage.id);
            }else{
              couponService.queryCouponListInShoppingCar(function(data) {
                // console.log(JSON.stringify(data));
                $scope.couponValidList = data;
                $scope.emptyData = data.length == 0;
              }, $rootScope.orderCommitProductObjCoupon, phone);
            }
        }
    };

    /**
     * 优惠券点击事件
     * 如果缓存中有值，则跳转回去（订单提交页面）
     */
    $scope.choiceCoupon = function(couponObj) {

        if ($scope.fromHtml == 'orderCommit') {
            if( !$rootScope.orderCoupon ) {
                $rootScope.orderCoupon = {};
            }
            if (couponObj.couponPrice > $rootScope.orderMoney) {
                var confirmPopup = $ionicPopup.confirm({
                    title: '<strong>选择优惠券</strong>',
                    template: '购物券金额大于订单金额，使用后将无余额，是否确认使用？',
                    okText: '否',
                    okType: 'button-default',
                    cancelText: '是',
                    cancelType: 'button-positive'
                });
                confirmPopup.then(function(res) {
                    if (!res) {
                    	if( $scope.orderInfoIsV2 ) {
                    		$rootScope.orderCoupon[$scope.shopBrandMessage.id] = couponObj;
                            $rootScope.selectVoucherIds = {};
                            for( shopId in $rootScope.orderCoupon ){
                                $rootScope.selectVoucherIds[$rootScope.orderCoupon[shopId].couponRecordId] = true;
                            }
                    	}else{
                        	$rootScope.orderCoupon = couponObj;
                        }
                    	$scope.toOrderCommit();
                    }
                });
            } else {
            	if( $scope.orderInfoIsV2 ) {
            		$rootScope.orderCoupon[$scope.shopBrandMessage.id] = couponObj;
                    $rootScope.selectVoucherIds = {};
                    for( shopId in $rootScope.orderCoupon ){
                        $rootScope.selectVoucherIds[$rootScope.orderCoupon[shopId].couponRecordId] = true;
                    }
            	}else{
                	$rootScope.orderCoupon = couponObj;
                }
            	$scope.toOrderCommit();
            }
        }
    };

    $scope.parseCouponShopTip = function(coupon){
      var orderMoney = $rootScope.orderMoney;
        if( orderMoney >= coupon.couponLimitPrice ) {
          coupon.canUse = true;
          return '此优惠券可以使用';
        }else{
          coupon.canUse = false;
          return '满<em>'+ coupon.couponLimitPrice +'</em>减<em>'+ coupon.couponPrice +'</em>元，再买<em>'+ accSub(parseFloat(coupon.couponLimitPrice),parseFloat(orderMoney),1) +'</em>元即可使用';
        }
    };

    /**
     * 上拉加载更多
     */
    $scope.loadMore = function() {
        loadData();
    };


    $scope.$on('coupon-list-init', function() {
        loadData();
    });
}]);
