/**
 * Created by cwt on 2015/9/8.
 */
app.controller('createAddressCtrl', ['$scope', 'userService', 'userLocationFactory', 'communalLocationFactory', '$ionicPopup', '$timeout', '$ionicScrollDelegate', '$location', function($scope, userService, userLocationFactory, communalLocationFactory, $ionicPopup, $timeout, $ionicScrollDelegate, $location) {
    $scope.createAddressSchool = currentEnvironment();
    /**
     * 测试数据
     * @type {{contactPerson: string, contactPhone: string, communityName: string, addressContent: string}}
     */
    $scope.addressObj = {
        communityId: 0,
        contactPerson: "",
        contactPhone: "",
        communityName: "",
        addressContent: "",
        buildingName: "请选择",
        buildingDorm: ""
    };
    $scope.buildingName = $scope.addressObj.buildingName ? $scope.addressObj.buildingName : "请选择";
    /**
     * 用户手机号
     */
    $scope.contactPhone = userLocationFactory.user().phone;
    $scope.addressObj.contactPhone = $scope.contactPhone;
    /**
     * 楼号列表
     */
    $scope.buildingList = [];

    $scope.buildingShow = false;

    $scope.buttonName = "保存";
    $scope.createStatus = "add";
    /**
     * 验证姓名、手机号、小区、地址的状态    true:通过 false:禁止
     * @type {string}
     */
    $scope.checkStatus = false;

    $scope.suibian = true;

    $scope.testObj = {};
    /**
     * 错误信息提示
     */
    $scope.errorMessage = "";

    var createAddressUrlSource = window.localStorage.getItem('createAddressUrlSource');
    $scope.createAddressUrlSource = createAddressUrlSource;
    //console.log(createAddressUrlSource);

    /**
     * 显示弹窗
     * @param message   提示语，字符串也可以写HTML
     */
    $scope.showAlert = function(message) {
        if ($scope.suibian) {
            $scope.suibian = false;
            $ionicPopup.alert({
                    title: '错误提示',
                    template: message,
                    buttons: [{
                        text: '确定',
                        type: 'button-assertive'
                    }]
                })
                .then(function() {
                    $timeout(function() {
                        $scope.suibian = true;
                    }, 100);
                    //console.log('Thank you for not eating my delicious ice cream cone');
                });
        }
    };


    /**
     * 检测地址信息
     * @param addressObj
     */
    $scope.checkInfo = function(addressObj) {
        if (addressObj.contactPerson && !checkEnterTextAll.test(addressObj.contactPerson)) {
            $scope.testObj.name = 1;
        } else {
            delete $scope.testObj.name;
        }
        if (checkMobile.test(addressObj.contactPhone)) {
            $scope.testObj.tel = 1;
        } else {
            delete $scope.testObj.tel;
        }
        if (addressObj.communityName) {
            $scope.testObj.communityName = 1;
        } else {
            delete $scope.testObj.communityName;
        }
        if (currentEnvironment()) {
            if (addressObj.addressContent && !checkEnterTextAllTwo.test(addressObj.addressContent)) {
                $scope.testObj.addressContent = 1;
                $scope.errorMessage = "";
            } else {
                var symbol = "";
                if (!addressObj.addressContent) addressObj.addressContent = "";
                var pos = addressObj.addressContent.search(checkEnterTextAllTwo);
                if (pos > -1) {
                    symbol = addressObj.addressContent.substr(pos, 1);
                    $scope.errorMessage = '您的地址信息不能包含:&nbsp;&nbsp;' + symbol + '&nbsp;&nbsp;字符';
                } else {
                    $scope.errorMessage = "";
                }
                delete $scope.testObj.addressContent;
            }
        } else {
            if (addressObj.buildingDorm && !checkEnterTextAllTwo.test(addressObj.buildingDorm)) {
                $scope.testObj.buildingDorm = 1;
                $scope.errorMessage = "";
            } else {
                var symbol = "";
                if (!addressObj.buildingDorm) addressObj.buildingDorm = "";
                var pos = addressObj.buildingDorm.search(checkEnterTextAllTwo);
                if (pos > -1) {
                    symbol = addressObj.buildingDorm.substr(pos, 1);
                    $scope.errorMessage = '您的地址信息不能包含:&nbsp;&nbsp;' + symbol + '&nbsp;&nbsp;字符';
                } else {
                    $scope.errorMessage = "";
                }
                delete $scope.testObj.buildingDorm;
            }
        }
    };

    /**
     * 根据检测地址信息判断提示窗
     * @param addressObj
     * @param type
     */
    $scope.checkAddressObj = function(addressObj, type) {
        var currentPath = $location.path();
        if (currentPath != '/create-address') return;
        var message = "";
        $scope.buttonSwitch();
        switch (type) {
            case "contactPerson":
                if (!$scope.testObj.name) {
                    message = "联系人姓名不能为空！";
                    $scope.showAlert(message);
                }
                break;
            case "contactPhone":
                if (!$scope.testObj.tel) {
                    message = "手机号格式错误,请填写正确手机号！";
                    $scope.showAlert(message);
                }
                break;
            case "communityName":
                if (!$scope.testObj.communityName) {
                    message = "小区名称不能为空！";
                    $scope.showAlert(message);
                }
                break;
            case "addressContent":
                if (!$scope.testObj.addressContent) {
                    message = "详细地址不能为空，且不能输入特殊符号！";
                    $scope.showAlert(message);
                }
                break;
            case "buildingDorm":
                if (!$scope.testObj.buildingDorm) {
                    message = "宿舍/教室信息不能为空，且不能输入特殊符号！";
                    $scope.showAlert(message);
                }
                break;
            default:
                break;
        }
    };

    $scope.buttonSwitch = function() {
        $scope.checkInfo($scope.addressObj);
        if (Object.keys($scope.testObj).length > 3) {
            $scope.checkStatus = true;
        } else {
            $scope.checkStatus = false;
        }
    };

    /**
     * 确认创建用户地址
     * @param createStatus  add:新增  update：修改
     */
    $scope.sureAddUserAddress = function() {
        var userMobile = userLocationFactory.user().phone;
        var addressLinkTel = $scope.addressObj.contactPhone;
        var addressLinkMen = $scope.addressObj.contactPerson;
        var communityName = $scope.addressObj.communityName;
        var communityId = $scope.addressObj.communityId;
        var addressContent = $scope.addressObj.addressContent;

        var buildingId = $scope.addressObj.buildingId ? $scope.addressObj.buildingId : null;
        var buildingName = $scope.addressObj.buildingName ? $scope.addressObj.buildingName : null;
        if (!currentEnvironment()) addressContent = $scope.addressObj.buildingDorm;

        if ($scope.createStatus == "add") {
            userService.addUserAddress(function(data) {
                if (data) {
                    if (createAddressUrlSource == "address-message") {
                        $scope.toAddressMessage();
                    } else if (createAddressUrlSource == "order-commit") {
                        window.localStorage.setItem('userCommunityId', communityId);
                        window.localStorage.setItem('userCommunityName', communityName);
                        $scope.userCommunity.communityId = communityId;
                        $scope.userCommunity.communityName = communityName;
                        $scope.toOrderCommit();
                    } else {
                        $scope.toAddressMessage();
                    }
                } else {
                    $ionicPopup.alert({
                        title: '错误提示',
                        template: data.resultMsg || '用户地址添加失败!',
                        buttons: [{
                            text: '确定',
                            type: 'button-assertive'
                        }]
                    });
                }
            }, userMobile, addressLinkTel, addressLinkMen, communityName, communityId, addressContent, buildingId, buildingName);
        } else if ($scope.createStatus == "update") {
            var addressId = $scope.addressObj.addressId;
            userService.updateUserAddress(function(data) {
                if (data == 1) {
                    //console.log("修改成功:"+JSON.stringify(data));
                    if (createAddressUrlSource == "address-message") {
                        $scope.toAddressMessage();
                    } else if (createAddressUrlSource == "order-commit") {
                        window.localStorage.setItem('userCommunityId', communityId);
                        window.localStorage.setItem('userCommunityName', communityName);
                        $scope.userCommunity.communityId = communityId;
                        $scope.userCommunity.communityName = communityName;
                        $scope.toOrderCommit();
                    } else {
                        $scope.toAddressMessage();
                    }
                } else {
                    //console.log("修改失败！");
                    $ionicPopup.alert({
                        title: '错误提示',
                        template: data.resultMsg || '用户地址修改失败!',
                        buttons: [{
                            text: '确定',
                            type: 'button-assertive'
                        }]
                    });
                }
            }, addressId, userMobile, addressLinkTel, addressLinkMen, communityName, communityId, addressContent, buildingId, buildingName);
        }
    };


    /**
     * 获取小区
     */
    $scope.goFindCommunity = function() {
        communalLocationFactory.createAddressObj.put("create_address_info", $scope.addressObj);
        $scope.toFindCommunity();
    };

    /**
     * 跳转小区选择页面
     */
    $scope.goUpdateCommunity = function() {
        //      $ionicPopup.confirm({
        //            title: '错误提示',
        //            template: data.resultMsg||'用户地址修改失败!',
        //            buttons:[
        //                {
        //                    text: '确定',
        //                    type: 'button-assertive'
        //                }
        //            ]
        //        });
        if ($scope.createStatus == "update" && createAddressUrlSource == "address-message") {
            communalLocationFactory.updateAddress.put("address_message_updateAddress", $scope.addressObj);
        } else {
            //          console.log("$scope.addressObj:"+JSON.stringify($scope.addressObj));
            communalLocationFactory.createAddressObj.put("create_address_info", $scope.addressObj);
        }
        $scope.toUpdateCommunity('create_address');
    };

    /**
     * 根据校区Id获取楼号
     */
    $scope.getBuildingListByCommunityId = function(communityId) {
        userService.getBuildingListByCommunityId(function(data) {
            //          console.log("getBuildingListByCommunityId:"+JSON.stringify(data));
            $scope.buildingList = data;

        }, communityId);
    };
    /**
     * 判断这个楼号是否被选中
     */
    $scope.checkedBuilding = function(buildingName) {
        //      console.log("buildingName:"+buildingName);
        //      console.log("$scope.addressObj.buildingName:"+$scope.addressObj.buildingName);
        if ($scope.addressObj.buildingName == buildingName) {
            return true;
        } else {
            return false;
        }
    };

    $scope.showBuildingName = function() {
        //      console.log("$scope.buildingShow:"+$scope.buildingShow);
        if ($scope.buildingShow) {
            $scope.hideBuildingName();
        } else {
            $scope.buildingShow = true;
        }
    };
    $scope.hideBuildingName = function() {
        $scope.buildingShow = false;
    };
    /**
     * 选择楼号
     */
    $scope.choiceBuildingName = function(buildingObj) {
        $scope.hideBuildingName();
        $scope.addressObj.buildingName = buildingObj.buildingName;
        $scope.addressObj.buildingId = buildingObj.buildingId;
        //      console.log("$scope.addressObj1:"+JSON.stringify($scope.addressObj));
        $ionicScrollDelegate.scrollTop();
    };

    /**
     * 初始化
     */
    $scope.init = function() {

        var communityName = "";
        var communityId = 0;
        communityName = localStorage.getItem('updateCommunityCommunityName');
        communityId = parseInt(localStorage.getItem('updateCommunityCommunityId'));

        var obj = communalLocationFactory.updateAddress.get("address_message_updateAddress");

        if (angular.isObject(obj) && obj.addressId) {
            $scope.addressObj = obj;
            $scope.buttonName = "修改";
            $scope.createStatus = "update";
            //            console.log(JSON.stringify(obj));
            //            console.log("communityName111:"+communityName);
            if (!communityName) {
                communityName = obj.communityName;
                if (!currentEnvironment()) communityId = obj.communityId;
            }
            communalLocationFactory.updateAddress.remove("address_message_updateAddress");
        } else {
            $scope.addressObj = obj || {};
            $scope.createStatus = "add";
            $scope.addressObj.contactPhone = $scope.contactPhone;
            communalLocationFactory.updateAddress.remove("address_message_updateAddress");
        }

        var addressInfo = communalLocationFactory.createAddressObj.get("create_address_info");

        if (angular.isObject(addressInfo)) {
            $scope.addressObj = addressInfo;
            //            console.log("addressInfo:"+JSON.stringify(addressInfo));
            communalLocationFactory.createAddressObj.remove("create_address_info");
        }


        // console.log("communityName:"+communityName);
        if (!communityName) {
            communityName = localStorage.getItem("userCommunityName");
        }
        if(!communityId){
            communityId = parseInt(localStorage.getItem("userCommunityId"));
        }
        // var communityName = localStorage.getItem("find_community_communityName");
        // var communityId = localStorage.getItem("find_community_communityId");
        if (communityName) {
            $scope.addressObj.communityName = communityName;
            localStorage.removeItem("updateCommunityCommunityName");
            $scope.checkInfo($scope.addressObj);
        }
        // console.log('communityId2', communityId);
        if (communityId) {
            $scope.addressObj.communityId = communityId;
            localStorage.removeItem("updateCommunityCommunityId");
        }
        $scope.buttonSwitch();
        //        console.log("communityId:"+communityId);
        if (!currentEnvironment()) {
            $scope.getBuildingListByCommunityId(communityId);
        }
    };

    $scope.goContactPage = function() {
        localStorage.setItem('updateCommunityCommunityName', $scope.addressObj.communityName);
        localStorage.setItem('updateCommunityCommunityId', $scope.addressObj.communityId);
        communalLocationFactory.updateAddress.put("address_message_updateAddress", $scope.addressObj);
        $scope.toContact();
    };


    $scope.$on('create-address-init', function() {
        $scope.init();
    });

}]);

app.directive('setFocus', ['$timeout', function($timeout) {
    return function(scope, element) {
        //      console.log("我要获取焦点!");
        $timeout(function() {
            element[0].focus();
        }, 200);
    };
}]);
