app.controller('homeCtrl', ['$scope', '$rootScope', '$timeout', '$ionicSlideBoxDelegate', '$ionicPopup', 'goodsService', 'advertService', 'cartFactory', 'userLocationFactory', function($scope, $rootScope, $timeout, $ionicSlideBoxDelegate, $ionicPopup, goodsService, advertService, cartFactory, userLocationFactory) {
    // console.log('页面进入...', (new Date).getTime());
    var showDay = {'today':'今日','tomorrow':'明日'};
    $scope.goodsList = [];
    $scope.advertList = [];
    $scope.homeColumn = [];
    $scope.indexSlideLoaded = false;
    $scope.homeAdvert = {height:advertHeight+'px'};
    $scope.hfPosition = {};

    $scope.preferentialData = [];
    $scope.barForPreferentialData = null;
    $scope.timeForPreferentialData = 1800;
    $scope.preferentialDayTip = showDay['today'];

    $scope.isLoggedIn = userLocationFactory.isLoggedIn();

    /**
     * 加载广告
     */
    $scope.loadAdvert = function() {
        $scope.advertList = [];
        advertService.getAdvertByPosition(function(data){
            $scope.indexSlideLoaded = true;
            $timeout(function(){
                var arr = [];
                if(!$scope.appEnvironmentSystem){
                    arr = data.slice(0, 3);
                }else{
                    arr = data;
                }
                $scope.advertList = arr;
                var indexSlideBoxHandle = $ionicSlideBoxDelegate.$getByHandle('indexSlideBoxHandle');
                indexSlideBoxHandle.loop(true);
                indexSlideBoxHandle.update();
                indexSlideBoxHandle.start();

            }, 50);
        }, 'index');
    };

    /**
     * 加载首页栏目和商品
     */
    $scope.loadIndexGoods = function(){
        //$scope.hfPosition = {lat: window.localStorage.getItem('userCommunityLat'), lon: window.localStorage.getItem('userCommunityLon')};
        var communityId = window.localStorage.getItem('userCommunityId');
        goodsService.homeColumnByCommunityId(function(data){
            // console.log('加载完成...', (new Date).getTime());
            $scope.homeColumn = data.homeColumn;
            $scope.goodsList = data.homeGoods;
        }, communityId);
    };

    /**
     * 跳转内页，用于8个
     */
    $scope.goInnerPage = function(column) {
        //console.log('====>', column);
        if(column.homeColumnTargetType==0){
            // 跳转某品类下的商品列表
            $scope.toShopList(column.homeColumnCategoryId, column.homeColumnName, null, null);
        }
        if(column.homeColumnTargetType==1){
            // 跳转某品类下的店铺列表
            $scope.toProductList(column.homeColumnCategoryId, column.homeColumnName, null, null);
        }
    };

    /**
     * 跳转推荐位
     */
    $scope.goInnerPageByRecomment = function(column){
        // console.log('====>', column);
        if(column.homeColumnTargetType==1){
            // 跳转到所选商品列表
            $scope.toCustomProductList(column.homeColumnGoodsSpuIdList, column.homeColumnName);
        }
        if(column.homeColumnTargetType==2){
            // 跳转某品类下的商品列表
            var firstLevelId;
            var secondLevelId;
            if(parseInt(column.homeColumnCategoryPId) == 0){
                firstLevelId = column.homeColumnCategoryId;
                secondLevelId = null;
            }
            if(parseInt(column.homeColumnCategoryPId) != 0){
                firstLevelId = column.homeColumnCategoryPId;
                secondLevelId = column.homeColumnCategoryId;
            }
            $scope.toProductList(firstLevelId, column.homeColumnName, secondLevelId);
        }
        if(column.homeColumnTargetType==3){
            // 这里跳转供货商
            $scope.toShopProductList(column.homeColumnCategoryShopBrandName);
        }
    };

    /**
     * 判断是否已选择小区
     */
    $scope.hasPosition = function(){
        if(!$scope.appEnvironmentSystem){
            window.localStorage.setItem('userCommunityId', APP_SCHOOL_DEFAULT_COMMUNITY_ID);
            window.localStorage.setItem('userCommunityName', APP_SCHOOL_DEFAULT_COMMUNITY_NAME);
        }
        var userCommunityId = parseInt(window.localStorage.getItem('userCommunityId'))||0;
        var userCommunityName = window.localStorage.getItem('userCommunityName')||'';
        if(userCommunityId <= 0){

            $scope.toPositionList();

        }else{
            $scope.userCommunity.communityId = userCommunityId;
            $scope.userCommunity.communityName = userCommunityName;
        }
    };

    /**
     * 加载特惠专区数据
     * @return
     */
    $scope.loadPreferenceGoodsSpuList = function(){
        var phone = userLocationFactory.user().phone;
        var communityId = parseInt(window.localStorage.getItem('userCommunityId'))||0;
        goodsService.queryPreferenceGoodsSpuListNoPromotion(function(data){
            var list = [];
            list = list.concat(data.today);
            list = list.concat(data.tomorrow);
            $scope.preferentialData = list;
            var indexPreferenceSlideBoxHandle = $ionicSlideBoxDelegate.$getByHandle('indexPreferenceSlideBoxHandle');
            indexPreferenceSlideBoxHandle.update();

            $scope.updatePreferenceData();
        }, phone, communityId);
    };

    /**
     * 显示今日专区下一个
     * @return
     */
    $scope.nextPreferential = function(){
        var indexPreferenceSlideBoxHandle = $ionicSlideBoxDelegate.$getByHandle('indexPreferenceSlideBoxHandle');
        indexPreferenceSlideBoxHandle.next();
    };
    /**
     * 显示今日专区前一个
     * @return
     */
    $scope.prevPreferential = function(){
        var indexPreferenceSlideBoxHandle = $ionicSlideBoxDelegate.$getByHandle('indexPreferenceSlideBoxHandle');
        indexPreferenceSlideBoxHandle.previous();
    };
    $scope.preferentialIndex = 0;
    $scope.preferenceSlideChange = function(index){
        var preference = $scope.preferentialData[index];
        $scope.preferentialDayTip = showDay[preference.showDay];
        $scope.preferentialIndex = index;
    };
    /**
     * 更新专区数据，循环更新
     * @return
     */
    $scope.updatePreferenceData = function(){
        $scope.preferentialData = parsePreferenceData($scope.preferentialData) || [];

        $scope.barForPreferentialData = $timeout(function(){
            $scope.updatePreferenceData();
        }, $scope.timeForPreferentialData * 1000);
    };

    /**
     * 更新专区数据
     * @return
     */
    $scope.stop = function(){
        $timeout.cancel($scope.barForPreferentialData);
        $scope.barForPreferentialData = null;
    };

    /**
     * 页面 render 完成之后执行
     */
    $scope.$on('ngRenderFinished', function (evt) {
        //下面是在dom更改并且渲染完成后执行的js
        // console.log('页面改变完成！！！', (new Date).getTime());
        // $timeout(function() {
        //     $scope.hideLoading();
        // }, 800);
        $timeout(function() {
            if(!$scope.showPrePage){
                $scope.enterHome();
            }
        }, 100);
    });

    $scope.$on('home-init', function(){
        $timeout(function(){
            // console.log('home-init');
            // $scope.showLoading('loading.html');
            $scope.hasPosition();
            $scope.loadAdvert();
            $scope.loadIndexGoods();
            $scope.loadPreferenceGoodsSpuList();
        }, 400);
    });

    // $scope.$on('home-position-init', function(){
    //     //$scope.hasPosition();
    // });
    $scope.$on('home-network-init', function(){
        $scope.hasPosition();
        if($scope.goodsList.length == 0){
            // console.log('home-network-init');
            $scope.loadAdvert();
            $scope.loadIndexGoods();
        }
    });

    $scope.$on('home-preference-init', function(){
        // console.log('home-preference-init');
        $scope.loadPreferenceGoodsSpuList();
        $scope.isLoggedIn = userLocationFactory.isLoggedIn();
    });

    $scope.$on('clear-data-for-home', function(){
        // console.log('clear-data-for-home');
        $scope.loadIndexGoods();
    });

    $scope.$on('home-leave', function(){
        $scope.stop();
    });
}]);
