app.factory('loginFactory', ['$rootScope', function($rootScope){
    var service = {};
    service.tabid = 0;
    service.loginFactoryTab = function(tab){
        this.tabid = tab;
        $rootScope.$broadcast('loginTab');
    };
    return service;
}])
app.controller('loginCtrl', ['$scope', '$ionicPopup', '$state', '$timeout', '$ionicNavBarDelegate', 'loginFactory', 'userService', 'userLocationFactory' , function($scope, $ionicPopup, $state, $timeout, $ionicNavBarDelegate, loginFactory, userService, userLocationFactory){
    var KEY = 'login';
    var timeBar;
    var stopTimeBar = function(){
        $timeout.cancel(timeBar);
        timeBar = null;
    };
    var initTimeoutNum = CURRENT_ENV == 'product' ? 120 : 20;
    var init = function(){
        $scope.user = {};
        $scope.user.userPhone = '';
        $scope.user.userPassword = '';
        $scope.user.userQrcode = '';
        $scope.loginError = false;
        $scope.phoneLoginError = false;
        $scope.phoneLoginErrorInfo = '';
        $scope.loginPhoneStep = 1;
        $scope.clockNum = initTimeoutNum;
        $scope.vcode = '';
        // $scope.canClickForMsgLogin = true;
    };
    $scope.user = {};
    $scope.loginError = false;
    $scope.phoneLoginError = false;
    $scope.phoneLoginErrorInfo = '';
    $scope.check = {
        checkMobile: checkMobile
    };
    $scope.loginPhoneStep = 1;
    $scope.clockNum = initTimeoutNum;
    $scope.vcode = '';
    // $scope.canClickForMsgLogin = true;
    /**
     * 切换登录方式
     */
    $scope.loginTab = function(tab){
        loginFactory.loginFactoryTab(tab);
    };

    /**
     * 登录荷粉系统
     */
    $scope.loginHefen = function(form){
        if(form.$valid){
            //console.log('验证成功', $scope.user.userPhone);

            userService.userLanding(function(data){
                //console.log('登录：',data);
                if(data.status == 4){
                    userLocationFactory.login($scope.user.userPhone);

                    var scanUrl = window.localStorage.getItem('backUrlForScan');
                    var url = window.localStorage.getItem('backUrl');
                    if(scanUrl){
                        var str = '$scope.' + scanUrl;
                        eval(str);
                    }else{
                        if(!url){
                            url = 'home';
                        }
                        $state.go(url);
                    }
                }else{
                    $scope.loginError = true;
                    $scope.loginErrorInfo = data.msg;
                }
            }, $scope.user.userPhone, $scope.user.userPassword);
        }else{
            //console.log('验证失败', $scope.user.userPhone);
            $scope.loginError = true;
        }
    };

    /**
     * 获取验证码
     */
    $scope.getQrcode = function(form){
        var phone = $scope.user.userPhone;
        if(form.$valid){
            // $scope.changBtnDisable();
            $scope.showConfirmQrcode();
            $scope.phoneLoginError = false;
        }else{
            $scope.phoneLoginError = true;
        }
    };

    /**
     * 获取验证码
     */
    $scope.getQrcodeByCount = function(form){
        var count = userLocationFactory.readVerCodeCount();
        userLocationFactory.writeVerCodeCount(count+1);
        $scope.getQrcode(form);
    };

    /**
     * 显示验证码弹出框
     */
    $scope.showConfirmQrcode = function() {

        var phone = $scope.user.userPhone;
        var phone_str = phone.slice(0,3) + ' ' + phone.slice(3,7) + ' ' + phone.slice(7,11);
        var confirmPopup = $ionicPopup.confirm({
            template: '我们将发送短信验证码至：<div class="tip">'+phone_str+'</div>',
            cssClass: 'hf-popup-login',
            cancelText: '取消',
            okText: '确认',
            okType: 'button-assertive',
        });
        confirmPopup.then(function(res) {
           if(res) {
                // $scope.canClickForMsgLogin = false;
                $scope.loginPhoneStep = 2;
                // $scope.clockMinus();
                $scope.sendQrcode();
           } else {
             //console.log('You are not sure '+phone);
           }
        });
    };

    /**
     * 发送验证码
     */
    $scope.sendQrcode = function(){
        // userService.sendVCode(function(msg){
        //     if(msg != -1){
        //         $scope.vcode = msg;
        //     }
        // }, $scope.user.userPhone);
        var mobile = $scope.user.userPhone;
        var count = userLocationFactory.readVerCodeCount();
        userService.sendVerCode(function(data){
            if(data >= 0){
                var seconds = data;
                if(data==0){
                    seconds = initTimeoutNum;
                }
                $scope.clockNum = seconds;
                $scope.clockMinus();
            }else{
                $ionicPopup.alert({
                    title: '提示信息',
                    template: '验证码发送失败',
                    buttons: [{
                        text: '确定',
                        type: 'button-assertive'
                    }]
                });
                $scope.clockNum = initTimeoutNum;
                $scope.clockMinus();
            }
        }, mobile, count, KEY);
    };

    /**
     * 登录、记录本地缓存
     */
    $scope.doLogin = function(){
        var mobile = $scope.user.userPhone;
        var vcode = $scope.user.userQrcode;
        userService.checkVerCode(function(data){
            // console.log(data);
            if(data.resultCode == 1){
                $scope.phoneLoginError = false;
                userLocationFactory.login($scope.user.userPhone);

                var scanUrl = window.localStorage.getItem('backUrlForScan');
                var url = window.localStorage.getItem('backUrl');
                if(scanUrl){
                    var str = '$scope.' + scanUrl;
                    eval(str);
                }else{
                    if(!url){
                        url = 'home';
                    }
                    $state.go(url);
                }
            }else{
                $ionicPopup.alert({
                    title: '提示信息',
                    template: data.resultMsg || '失败',
                    buttons: [{
                        text: '确定',
                        type: 'button-assertive'
                    }]
                });
            }
        }, mobile, vcode, KEY);


        // if($scope.vcode != $scope.user.userQrcode){
        //     $scope.phoneLoginError = true;
        //     $scope.phoneLoginErrorInfo = '验证码错误';
        // }else{
        //     $scope.phoneLoginError = false;
        //     userLocationFactory.login($scope.user.userPhone);

        //     var scanUrl = window.localStorage.getItem('backUrlForScan');
        //     var url = window.localStorage.getItem('backUrl');
        //     if(scanUrl){
        //         var str = '$scope.' + scanUrl;
        //         eval(str);
        //     }else{
        //         if(!url){
        //             url = 'home';
        //         }
        //         $state.go(url);
        //     }
        // }
    };

    /**
     * 倒计时
     */
    $scope.clockMinus = function(){
        $scope.clockNum--;
        timeBar = $timeout(function(){
            if($scope.clockNum == 0){
                stopTimeBar();
                // $scope.canClickForMsgLogin = true;
            }else{
                $scope.clockMinus();
            }
        }, 1000);
    };

    // $scope.changBtnDisable = function(){
    //     $scope.canClickForMsgLogin = false;
    //     $timeout(function(){
    //         $scope.canClickForMsgLogin = true;
    //     }, 2000);
    // };

    $scope.textChange = function(){
        $scope.resetLoginError();
    };

    $scope.resetLoginError = function(){
        $scope.loginError = false;
        $scope.loginErrorInfo = '';
    };

    $scope.$on('login-leave', function(){
        stopTimeBar();
    });

    $scope.$on('login-reset-form', function(){
        init();
    });
}]);
app.controller('loginBarCtrl', ['$scope', '$ionicSlideBoxDelegate', 'loginFactory', function($scope, $ionicSlideBoxDelegate, loginFactory){
    var loginSlideBoxHandle = $ionicSlideBoxDelegate.$getByHandle('loginSlideBoxHandle');
    $scope.loginPhone = false;
    $scope.loginNormal = true;
    $scope.loginTab = function(tab){
        $scope.loginPhone = tab == 0;
        $scope.loginNormal = tab == 1;
        loginSlideBoxHandle.slide(tab);
    };

    $scope.$on('loginTab', function(){
        $scope.loginTab(loginFactory.tabid);
    });
}]);