/**
 * Created by cwt on 2015/9/6.
 */

app.controller('orderCommitCtrl', ['$scope', '$rootScope', '$timeout', 'userService', 'orderService', 'communalLocationFactory', '$ionicModal', '$ionicPopup', 'cartFactory', 'userLocationFactory', 'shopIdListFactory', function($scope, $rootScope, $timeout, userService, orderService, communalLocationFactory, $ionicModal, $ionicPopup, cartFactory, userLocationFactory, shopIdListFactory) {

    $scope.goods = {}; //购物车数据
    $scope.order = {}; //订单数据
    $scope.order.payment = {}; //支付方式
    $scope._param = {}; //后台检测数据
    $scope.orderInfo = {}; //添加订单数据
    $scope.onlinPayObj = {}; //在线支付需要数据
    $scope.onlinPayObj.goodsName = "";
    $scope.onlinPayObj.goodsDescription = "";
    var userMobile = userLocationFactory.user().phone;
    $scope.userCommunityId = parseInt(localStorage.getItem("userCommunityId"));
    $scope.userCommunityName = localStorage.getItem("userCommunityName");
    var noAddressTip = "暂无该小区详细地址点击编辑";
    var addressLodingTip = "详细地址加载中...";
    $scope.userAddressContent = noAddressTip;
    // $scope.userAddressContent = "详细地址加载中...";
    $scope.moreAddressImgUrl = "./img/icon_right_hide_1.png";
    $scope.userCommunityAddressList = [];
    $scope.userChoiceCommunityAddress = {};
    /**
     * 可选地址状态  false不显示     true显示
     * @type {boolean}
     */
    $scope.choiceAddressType = false;

    $scope.coupon = {};
    /**
     * 隐藏等待页面    false：不隐藏  true：隐藏
     */
    $scope.hideLoad = {
        queryUserAddressByUserTable: false,
        userShopingCartInfo: false
    };

    /**
     * 隐藏等待页面
     */
    $scope.hideLoadingAfterData = function(){
        if ($scope.hideLoad.userShopingCartInfo && $scope.hideLoad.queryUserAddressByUserTable) {
            $scope.hideLoading();
        }
    };

    /**
     * 获取用户小区地址列表
     */
    $scope.getUserCurrentCommunityAddress = function() {
        $scope.userAddressContent = addressLodingTip;
        userService.queryUserAddressByUserTable(function(data) {
            for (var i = 0; i < (data.commenAddress||[]).length; i++) {
                if (data.commenAddress[i].communityName == $scope.userCommunityName) {
                    if (data.defaultAddress.addressId == data.commenAddress[i].addressId) {
                        $scope.userCommunityAddressList.unshift(data.commenAddress[i]);
                    } else {
                        $scope.userCommunityAddressList.push(data.commenAddress[i]);
                    }
                }
            }
            if($scope.userCommunityAddressList.length == 0){
                $scope.userAddressContent = noAddressTip;
            }
            $scope.userChoiceCommunityAddress = $scope.userCommunityAddressList[0];
            $scope.hideLoad.queryUserAddressByUserTable = true;
            $scope.hideLoadingAfterData();
        }, userMobile);
    };

    /**
     * 修改默认地址
     * @param i
     * @param addressId
     */
    $scope.updateDefaultAddress = function(i, addressId) {
        $scope.clickShowChoiceAddress();
        userService.updateUserDefaultAddress(function(data) {
            if (data == 1) {
                var arry = [];
                arry = $scope.userCommunityAddressList[0];
                $scope.userCommunityAddressList[0] = $scope.userCommunityAddressList[i];
                $scope.userCommunityAddressList[i] = arry;
                $scope.userChoiceCommunityAddress = $scope.userCommunityAddressList[0];
            }
        }, userMobile, addressId);
    };
    /**
     * 显示隐藏地址选择
     */
    $scope.clickShowChoiceAddress = function() {
        var addressInfo = document.getElementsByClassName("order-commit-addressInfo")[0].getBoundingClientRect();
        $scope.addressChoiceMinHeight = document.body.clientHeight - addressInfo.height - addressInfo.top - 2;
        if ($scope.choiceAddressType) {
            $scope.choiceAddressType = false;
            $scope.moreAddressImgUrl = "./img/icon_right_hide_1.png";
        } else {
            $scope.choiceAddressType = true;
            $scope.moreAddressImgUrl = "./img/icon_down_show_1.png";
        }
    };

    /**
     * 购物车商品数据处理
     * @param obj 商品数据
     * @returns {*} 返回值
     */
    $scope.goodsDataProcessing = function(obj) {
        if (!obj.canSale) {
            return false;
        } else {
            var goodes = {};
            goodes.preferenceId = obj.preferenceId;
            goodes.leftNumOne = obj.leftNumOne;
            goodes.goodsNum = obj.cNum;
            goodes.goodsSkuId = obj.goodsSkuId;
            if (obj.ingredientsLength > 0) {
                goodes.goodsSkuIngredients = {};
                for (ingre in obj.ingredientsInfo) {
                    var ingredient = {};
                    ingredient.ingredientsId = obj.ingredientsInfo[ingre].ingredientsId;
                    ingredient.ingredientsNum = obj.ingredientsInfo[ingre].num;
                    goodes.goodsSkuIngredients[obj.ingredientsInfo[ingre].ingredientsId] = ingredient;
                }
            } else {
                goodes.goodsSkuIngredients = {};
            }
            goodes.goodsSkuScanDown = obj.goodsSkuScanDown || 0;
            goodes.goodsSkuScanLimit = obj.goodsSkuScanLimit || 0;
            goodes.iPrice = obj.iPrice || 0;

            if ($scope.onlinPayObj.goodsName) {
                $scope.onlinPayObj.goodsName += "、";
            }
            $scope.onlinPayObj.goodsName += goodes.goodsSpuName;

            if ($scope.onlinPayObj.goodsDescription) {
                $scope.onlinPayObj.goodsDescription += "、";
            }
            $scope.onlinPayObj.goodsDescription += goodes.goodsSpuName + "（" + goodes.goodsSkuName + "）X" + goodes.goodsNum;
            return goodes;
        }
    };

    /**
     * 选择支付方式
     * @param choice 'arrival':货到付款;'online':在线支付;
     */
    $scope.choicePayment = function(choice) {
        if (choice == 'arrival') {
            $scope.order.payment.choice = '货到付款';
            $scope.order.payment.arrival = '06';
            $scope.order.payment.online = '05';
        } else {
            $scope.order.payment.choice = '在线支付';
            $scope.order.payment.arrival = '05';
            $scope.order.payment.online = '06';
        }
    };

    /**
     * 进入页面函数
     */
    $scope.loadMsg = function() {
        $scope.getUserCurrentCommunityAddress();
        orderService.userShopingCartInfo(function(data) {
            // console.log('userShopingCartInfo --> ',data);
            $scope.order.msg = data;
            $scope.hideLoad.userShopingCartInfo = true;
            $scope.hideLoadingAfterData();
        }, userMobile);
        $scope.goods = cartFactory.getCartItems();

        if( $scope.appEnvironmentSystem ){
            $scope.choicePayment( 'arrival' );
        }else{
            $scope.choicePayment( 'online' );
        }

        $scope.order.orderprice = {};
        $scope.order.orderprice.goodsTotalPrice = cartFactory.getTotalPromotionMoney();
        $scope.order.orderprice.freight = cartFactory.getFreight();
        $scope.order.orderprice.voucher = ($rootScope.orderCoupon || {}).couponPrice || 0;
        $scope.order.orderprice.firstorder = 0;
        if ($scope.order.firstorder && $scope.order.orderprice.goodsTotalPrice >= $scope.order.firstorder.activeTerm.priceReach) {
            $scope.order.orderprice.firstorder = $scope.order.firstorder.activeTerm.priceDown;
        }
        $scope.order.orderprice.amountPayable = accSub(parseFloat(accSub(parseFloat(accAdd($scope.order.orderprice.goodsTotalPrice, $scope.order.orderprice.freight)), $scope.order.orderprice.voucher)), $scope.order.orderprice.firstorder, 1);
        $scope.orderInfo.orderGoodsInfo = {};
        $rootScope.orderCommitProductObj = {};

        //处理商品列表数据
        for (shopId in $scope.goods) {
            $scope.orderInfo.orderGoodsInfo[shopId] = {};
            $scope.orderInfo.orderGoodsInfo[shopId].groupGoods = {};
            $scope.orderInfo.orderGoodsInfo[shopId].singleGoods = [];
            $scope.orderInfo.orderGoodsInfo[shopId].shopMoney = $scope.goods[shopId].shopMoney;
            $scope.orderInfo.orderGoodsInfo[shopId].shopGoodsLength = $scope.goods[shopId].shopGoodsLength;

            $rootScope.orderCommitProductObj[shopId] = {};
            $rootScope.orderCommitProductObj[shopId].groupGoods = {};
            $rootScope.orderCommitProductObj[shopId].singleGoods = [];
            $rootScope.orderCommitProductObj[shopId].name = $scope.goods[shopId].name;
            $rootScope.orderCommitProductObj[shopId].shopMoney = $scope.goods[shopId].shopMoney;
            $rootScope.orderCommitProductObj[shopId].shopGoodsLength = $scope.goods[shopId].shopGoodsLength;

            var groupGoods = $scope.goods[shopId].groupGoods;
            var singleGoods = $scope.goods[shopId].singleGoods;
            $scope._param[shopId] = [];

            if (!!groupGoods) {
                $scope.orderInfo.orderGoodsInfo[shopId].groupGoods = {};
                $rootScope.orderCommitProductObj[shopId].groupGoods = {};
                for (promotionId in groupGoods) {
                    var giftList = [];
                    if(groupGoods[promotionId].giftList && groupGoods[promotionId].giftList.length){
                        var quantity = 0;
                        for (var i = 0; i < groupGoods[promotionId].giftList.length; i++) {
                            var gift = groupGoods[promotionId].giftList[i];
                            quantity += gift.num;
                        }
                        if(quantity > 0){
                            giftList = groupGoods[promotionId].giftList;
                        }
                    }
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId] = {};
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].goodses = [];
//                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].name = groupGoods[promotionId].name;
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].promotionTerm = groupGoods[promotionId].promotionTerm;
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].money = groupGoods[promotionId].money;
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].moneyOrg = groupGoods[promotionId].moneyOrg;
                    var giftListArr = [];
                    for(var g = 0; g < giftList.length; g++){
                    	var giftListObj = {};
                    	giftListObj.id = giftList[g].id;
                    	giftListObj.num = giftList[g].num;
                    	giftListArr.push(giftListObj);
                    }
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].giftList = giftListArr;

                    $rootScope.orderCommitProductObj[shopId].groupGoods[promotionId] = {};
                    $rootScope.orderCommitProductObj[shopId].groupGoods[promotionId].goodses = [];
                    $rootScope.orderCommitProductObj[shopId].groupGoods[promotionId].name = groupGoods[promotionId].name;
                    $rootScope.orderCommitProductObj[shopId].groupGoods[promotionId].promotionTerm = groupGoods[promotionId].promotionTerm;
                    $rootScope.orderCommitProductObj[shopId].groupGoods[promotionId].money = groupGoods[promotionId].money;
                    $rootScope.orderCommitProductObj[shopId].groupGoods[promotionId].msg = groupGoods[promotionId].msg;
                    $rootScope.orderCommitProductObj[shopId].groupGoods[promotionId].msgPill = groupGoods[promotionId].msgPill;
                    $rootScope.orderCommitProductObj[shopId].groupGoods[promotionId].moneyOrg = groupGoods[promotionId].moneyOrg;
                    $rootScope.orderCommitProductObj[shopId].groupGoods[promotionId].giftList = giftList;

                    for (i = 0; i < groupGoods[promotionId].goodses.length; i++) {
                        var goods = $scope.goodsDataProcessing(groupGoods[promotionId].goodses[i]);
                        if (!!goods) {
                            $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].goodses.push(goods);
                            $rootScope.orderCommitProductObj[shopId].groupGoods[promotionId].goodses.push(groupGoods[promotionId].goodses[i]);
                        }
                    }
                    if (!$scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].goodses[0]) {
                        delete $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId];
                        delete $rootScope.orderCommitProductObj[shopId].groupGoods[promotionId];
                    }
                }
            }
            if (singleGoods[0]) {
                for (s = 0; s < singleGoods.length; s++) {
                    var goods = $scope.goodsDataProcessing(singleGoods[s]);
                    if (goods) {
                        $scope.orderInfo.orderGoodsInfo[shopId].singleGoods.push(goods);
                        $rootScope.orderCommitProductObj[shopId].singleGoods.push(singleGoods[s]);
                    }
                }
            }
            if ((Object.keys($scope.orderInfo.orderGoodsInfo[shopId].groupGoods).length == 0) && !$scope.orderInfo.orderGoodsInfo[shopId].singleGoods[0]) {
                delete $scope.orderInfo.orderGoodsInfo[shopId];
                delete $rootScope.orderCommitProductObj[shopId];
            }
        }
        $scope.shopIdList = Object.keys($scope.orderInfo.orderGoodsInfo);
        for (var i = 0; i < $scope.shopIdList.length; i++) {
            $scope.shopIdList[i] = parseInt($scope.shopIdList[i]);
        }
        var money = $scope.parseScanMoney();
        $scope.couponWithScan(money); // 调用扫码优惠
        $scope.couponWithScanEmployee(money); // 调用扫员工码优惠
        $scope.parseScanMoneyForFreight(); // 调用扫员工码优惠后判断是否减免运费
        if (parseFloat($scope.order.orderprice.amountPayable) < 0) {
            $scope.order.orderprice.amountPayable = 0;
        }
        $rootScope.orderCommitProductObjCoupon = $scope.orderInfo.orderGoodsInfo;
    };

    /**
     * 展开/收起 配料
     */
    $scope.toggleIngredients = function(id){
        var dom = $dom('#'+id);
        var angularDom = angular.element(dom);
        angularDom.toggleClass('open');
    };

    /**
     * 展开/收起 赠品
     */
    $scope.toggleCartPromotionGift = function(id){
        var dom = $dom('#'+id);
        var angularDom = angular.element(dom);

        angularDom.toggleClass('open');
    };

    /**
     * 商品列表配料展开收起
     * @param id 配料DOM
     */
    $scope.ingredientFold = function(id) {
        var dom = $dom('#' + id);
        var angularDom = angular.element(dom);
        angularDom.toggleClass('open');
    };

    /**
     * 选择地址
     */
    $scope.goAddressMessage = function() {
        $scope.toAddressMessage('order-commit');
    };
    /**
     * 修改用户地址
     */
    $scope.updateUserAddress = function() {
        shopIdListFactory.put("order_commit_shopIdList", $scope.shopIdList);
        if (angular.isObject($scope.userChoiceCommunityAddress)) {
            //          console.log("address_message_updateAddress");
            communalLocationFactory.updateAddress.put("address_message_updateAddress", $scope.userChoiceCommunityAddress);
        }
        communalLocationFactory.createAddressObj.remove("create_address_info");
        $scope.toCreateAddress("order-commit");
    };

    /**
     * 点击确认检测商品
     */
    $scope.addOrderCheck = function() {
        var communityId = window.localStorage.getItem('userCommunityId');
        var _param = {};
        var _items = cartFactory.getItems();
        // 构造检验商品的json格式
        for(shopId in _items){
            var val = _items[shopId];
            var goodses = val.goodses||[];
            _param[shopId] = [];
            for(var i=0; i<goodses.length; i++){
                var goods = goodses[i];
                var _paramSku = {};
                _paramSku.skuId = goods.goodsSkuId;
                _paramSku.skuPrice = goods.goodsSkuPrice;
                _paramSku.skuPromotion = goods.goodsSkuPromotion;
                _paramSku.preferenceId = goods.preferenceId;
                _param[shopId].push(_paramSku);
            }

        }
        //$scope.showLoading('loading_order_commit.html');
        orderService.checkShoppingCartNew(function(data){
            if(data.appServerStatus == 'close') {
                $scope.showAlertWindow(data.resultMsg, 'cart');
            }
            cartFactory.validGoods(data.resultFlush);
            $scope.loadMsg();
            // $scope.hideLoading();
        }, _param, userMobile, communityId);
    };

    /**
     * 没有地址信息时弹窗
     */
    $scope.noAddressAlert = function() {
        var message = "亲，要写详细的地址哦~~";
        $scope.showAlertWindow(message);
    };

    $scope.gotoCouponList = function() {
        $rootScope.orderMoney = parseFloat($scope.order.orderprice.amountPayable);
        $scope.toCouponList('orderCommit');
    };

    /**
     * 添加订单
     */
    $scope.addOrder = function() {
    	if( $scope.userChoiceCommunityAddress && $scope.userChoiceCommunityAddress.addressId > 0 ){
    		$scope.showLoading('loading_order_commit.html');
            var vouchers = [];
            if ($rootScope.orderCoupon) {
                vouchers.push($rootScope.orderCoupon.couponRecordId);
            }
            if (!angular.isObject($scope.userChoiceCommunityAddress)) {
                $scope.showAlertWindow("请添加或编辑收货地址！");
                $scope.hideLoading();
                return;
            }
            $scope.orderInfo.addressId = $scope.userChoiceCommunityAddress.addressId;
            $scope.orderInfo.orderMobile = userLocationFactory.user().phone;
            $scope.orderInfo.orderPayInfo = {};
            $scope.orderInfo.orderPayInfo.payMethod = 0;
            if( $scope.order.orderprice.amountPayable == 0 ){
                $scope.order.payment.choice = "货到付款";
            }
            if ($scope.order.payment.choice == "在线支付") {
                $scope.orderInfo.orderPayInfo.payMethod = 1;
            }
            $scope.orderInfo.orderActivityInfo = $scope.order.msg.firstorder;
            $scope.orderInfo.orderCost = {};
            $scope.orderInfo.orderCost.voucherIds = vouchers;
            $scope.orderInfo.orderCost.orderprice = {};
            $scope.orderInfo.orderCost.orderprice.goodsTotalPrice = $scope.order.orderprice.goodsTotalPrice;
            $scope.orderInfo.orderCost.orderprice.amountPayable = $scope.order.orderprice.amountPayable;
            $scope.onlinPayObj.orderAddress = angular.fromJson(angular.toJson($scope.userChoiceCommunityAddress));
            $scope.onlinPayObj.price = $scope.order.orderprice.amountPayable;
            if ($scope.order.orderprice.firstorder > 0) {
                $scope.orderInfo.orderCost.firstorder = true;
            } else {
                $scope.orderInfo.orderCost.firstorder = false;
            }
            $scope.orderInfo.orderCost.freight = $scope.order.orderprice.freight;

            $scope.orderInfo.orderCost.scanActualPriceDown = parseFloat($scope.order.scanActualPriceDown); // 添加扫码公共key值，实际减的金额，普通扫码和员工码都有
            $scope.orderInfo.orderCost.scanType = $scope.order.scanType; // 添加扫码公共key值，扫码类型 normal:普通优惠码 employee:员工码

            $scope.orderInfo.orderCost.scanCouponPrice = $scope.order.scanCouponPrice; // 添加普通扫码key值，金额
            $scope.orderInfo.orderCost.scanCouponId = $scope.order.scanCouponId; // 添加普通扫码key值，特殊优惠券Id

            $scope.orderInfo.orderCost.scanEmployeePrice = $scope.order.scanEmployeePrice; // 添加扫员工码key值，金额
            $scope.orderInfo.appEnvironment = appEnvironment;
            $scope.orderInfo.appVersion = appVersion;
            $scope.orderInfo.userLocalTime = new Date().format( 'yyyy-MM-dd hh:mm:ss' );
            // console.log('订单数据：',JSON.stringify($scope.orderInfo));
            // return false;
            orderService.addOrderBack(function(data) {
                $rootScope.orderCoupon = null;
                $rootScope.scan = null;
                $rootScope.scanEmployee = null;
                if (data.resultCode == "error") {
                    $scope.showAlertWindow(data.resultMsg, '11');
                }
                if (data.resultCode == "success") {
                    if ($scope.order.payment.choice == "在线支付") {
                        $scope.onlinPayObj.orderNum = data.resultTO.orderNum;
                        $scope.onlinPayObj.orderId = data.resultTO.orderId;
                        $scope.toOnlinePay($scope.onlinPayObj);
                    } else {
                        $scope.toOrderInfo(data.resultTO.orderId);
                    }
                    $scope.emptyCart();
                }
                $scope.hideLoading();
                GOODS_PROMOTION_RULE = {}; // 清除存储的验证规则
            }, $scope.orderInfo);
    	} else {
    		$scope.noAddressAlert();
    	}
    };

    /**
     * 扫码按钮点击事件
     * 如果已经扫过码，则不能再次扫码
     */
    $scope.orderCommitScanner = function() {
        if (Object.keys($rootScope.scan).length > 0 || Object.keys($rootScope.scanEmployee).length > 0) {
            $ionicPopup.alert({
                title: '提示信息',
                template: '您已经扫码，不能再次扫码',
                okText: '知道了'
            });
        } else {
            $scope.scanner();
        }
    };

    /**
     * 订单扫码优惠
     * 给订单多添加三个key
     * @param money 优惠金额
     */
    $scope.couponWithScan = function(money) {
        if (Object.keys($rootScope.scan).length > 0) {
            var _money = Math.min($scope.order.orderprice.amountPayable, money);
            $scope.mountOrderMoney(money);
            $scope.order.scanActualPriceDown = _money.toFixed(1); // 实际优惠金额，页面使用和后台使用
            $scope.order.scanType = 'normal';
            $scope.order.scanCouponPrice = money;
            $scope.order.scanCouponId = $rootScope.scan.scanCouponId;
        }
    };

    /**
     * 订单扫员工码优惠
     * 给订单多添加两个key
     * @param money 优惠金额
     */
    $scope.couponWithScanEmployee = function(money) {
        if (Object.keys($rootScope.scanEmployee).length > 0) {
            var _money = Math.min($scope.order.orderprice.amountPayable, money);
            $scope.mountOrderMoney(money);
            $scope.order.scanActualPriceDown = _money.toFixed(1); // 实际优惠金额，页面使用
            $scope.order.scanType = 'employee'; // 实际优惠金额，后台使用
            $scope.order.scanEmployeePrice = money;
        }
    };

    $scope.mountOrderMoney = function(money){
        var _money = Math.min($scope.order.orderprice.amountPayable, money);
        $scope.order.orderprice.amountPayable = accSub($scope.order.orderprice.amountPayable, _money.toFixed(1), 1);
    };

    /**
     * 计算扫码优惠金额，按不同的规则
     * $rootScope.scan 普通扫码，直接返回优惠金额
     * $rootScope.scanEmployee 扫员工码  街边店返回 0.3 ~ 1 之间的随机数 + 自营返回 0.3 ~ 自营商品合计*0.05
     */
    $scope.parseScanMoney = function(){
        var money = 0;
        if (Object.keys($rootScope.scan).length > 0 && $rootScope.scan.scanCouponPrice) {
            money = $rootScope.scan.scanCouponPrice;
        }else if($rootScope.scanEmployee && $rootScope.scanEmployee.scanCouponPrice){
            money = $rootScope.scanEmployee.scanCouponPrice;
        }else{

        }

        return money;
    };

    $scope.parseScanMoneyForEmployee = function(streetMin, streetMax, platformMin, platformPersent){
        var money = 0;
        var selfShopMoney = ($scope.orderInfo.orderGoodsInfo[SELF_SHOP_ID] || {}).shopMoney || 0;
        var streetShopMoney = 0;
        if ($scope.orderInfo.orderGoodsInfo) {
            for (shopId in $scope.orderInfo.orderGoodsInfo) {
                var shop = $scope.orderInfo.orderGoodsInfo[shopId];
                if (shopId == SELF_SHOP_ID) {
                } else {
                    streetShopMoney += shop.shopMoney;
                }
            }
        }
        if (selfShopMoney > platformMin) {
            var m1 = getRandomNum(platformMin, selfShopMoney * platformPersent);
            if(selfShopMoney * platformPersent <= platformMin){
                m1 = 0;
            }
            money += m1;
        }
        if (streetShopMoney > streetMin) {
            var m2 = getRandomNum(streetMin, streetMax);
            money += m2;
        }
        return money;
    };

    $scope.parseScanMoneyForFreight = function(){
        if(Object.keys($rootScope.scanEmployee).length > 0 && $rootScope.scanEmployee.isFreight=='0'){
            $scope.order.isFreight = $rootScope.scanEmployee.isFreight=='0';
            $scope.order.orderprice.amountPayable = accSub($scope.order.orderprice.amountPayable, $scope.order.orderprice.freight, 1);
            $scope.order.orderprice.freight = 0;
        }
    };

    /**
     * 扫码后弹窗提示 优惠金额
     * @param money 金额
     */
    $scope.showScanMoney = function( money, name ){
        var _money = Math.min($scope.order.orderprice.amountPayable, money).toFixed(1);
        if(name){
                var text = '您好'+name+',此次扫码为您优惠'+ _money +'元';
            }else{
                var text = '您此次扫码优惠'+ _money +'元';
            }
        $ionicPopup.alert({
            title: '提示信息',
            template: text,
            okText: '知道了'
        });
    };

    $scope.$on('order-commit-init', function() {
        $scope.showLoading('loading.html');
        $scope.addOrderCheck();
        $scope.coupon = $rootScope.orderCoupon || {};
        // console.log($rootScope.orderCoupon);
    });

    /**
     * 监听此页面扫码之后的操作
     * @param e
     * @param priceDown 减多少钱
     */
    $scope.$on('orderCommitForScan', function(e, priceDown, id, resource) {
        $rootScope.scan = {};
        $rootScope.scan.scanCouponPrice = priceDown;
        $rootScope.scan.scanCouponId = id;
        var money = $scope.parseScanMoney();
        $scope.showScanMoney(money);
        $scope.couponWithScan(money);
    });

    /**
     * 扫员工码
     * @param e
     * @param streetMin 街边店优惠最小金额
     * @param streetMax 街边店优惠最大金额
     * @param platformMin 平台自营优惠最小金额
     * @param platformPersent 平台自营优惠最大百分比
     */
    $scope.$on('orderCommitForScanEmployee', function(e, streetMin, streetMax, platformMin, platformPersent, isFreight, name) {

        $rootScope.scanEmployee = {};
        $rootScope.scanEmployee.scanCouponPrice = $scope.parseScanMoneyForEmployee(streetMin, streetMax, platformMin, platformPersent);
        $rootScope.scanEmployee.isFreight = isFreight;
        $scope.parseScanMoneyForFreight();
        var money = $scope.parseScanMoney();
        $scope.showScanMoney(money, name);
        $scope.couponWithScanEmployee(money);
    });

}]);
