app.controller('orderCommitV2Ctrl', ['$scope', '$rootScope', '$timeout', 'userService', 'orderService', 'couponService', 'communalLocationFactory', '$ionicModal', '$ionicPopup', 'cartFactory', 'userLocationFactory', 'shopIdListFactory', function($scope, $rootScope, $timeout, userService, orderService, couponService, communalLocationFactory, $ionicModal, $ionicPopup, cartFactory, userLocationFactory, shopIdListFactory) {

    $scope.goods = {}; //购物车数据
    $scope.order = {}; //订单数据
    $scope.order.payment = {}; //支付方式
    $scope._param = {}; //后台检测数据
    $scope.orderInfo = {}; //添加订单数据
    $scope.onlinPayObj = {}; //在线支付需要数据
    $scope.goodsDetail = {}; //店铺商品详情状态 true:展开
    var userMobile = userLocationFactory.user().phone;
    $scope.userCommunityId = parseInt(localStorage.getItem("userCommunityId"));
    $scope.userCommunityName = localStorage.getItem("userCommunityName");
    var noAddressTip = "暂无该小区详细地址点击编辑";
    var addressLodingTip = "详细地址加载中...";
    $scope.userAddressContent = noAddressTip;
    // $scope.userAddressContent = "详细地址加载中...";
    $scope.moreAddressImgUrl = "./img/icon_right_hide_1.png";
    $scope.userCommunityAddressList = [];
    $scope.userChoiceCommunityAddress = {};
    /**
     * 可选地址状态  false不显示     true显示
     * @type {boolean}
     */
    $scope.choiceAddressType = false;

    /**
     * 隐藏等待页面    false：不隐藏  true：隐藏
     */
    $scope.hideLoad = {
        queryUserAddressByUserTable: false,
        userShopingCartInfo: false
    };

    /**
     * 隐藏等待页面
     */
    $scope.hideLoadingAfterData = function() {
        if ($scope.hideLoad.userShopingCartInfo && $scope.hideLoad.queryUserAddressByUserTable) {
            $scope.hideLoading();
        }
    };

    /**
     * 展开店铺商品
     * @param shopId 店铺ID
     */
    $scope.openDetail = function(shopId) {
        $scope.goodsDetail[shopId] = true;
    };

    /**
     * 获取用户小区地址列表
     */
    $scope.getUserCurrentCommunityAddress = function() {
        $scope.userAddressContent = addressLodingTip;
        userService.queryUserAddressByUserTable(function(data) {
            for (var i = 0; i < (data.commenAddress || []).length; i++) {
                if (data.commenAddress[i].communityName == $scope.userCommunityName) {
                    if (data.defaultAddress.addressId == data.commenAddress[i].addressId) {
                        $scope.userCommunityAddressList.unshift(data.commenAddress[i]);
                    } else {
                        $scope.userCommunityAddressList.push(data.commenAddress[i]);
                    }
                }
            }
            if ($scope.userCommunityAddressList.length == 0) {
                $scope.userAddressContent = noAddressTip;
            }
            $scope.userChoiceCommunityAddress = $scope.userCommunityAddressList[0];
            $scope.hideLoad.queryUserAddressByUserTable = true;
            $scope.hideLoadingAfterData();
        }, userMobile);
    };


    /**
     * 修改默认地址
     * @param i
     * @param addressId
     */
    $scope.updateDefaultAddress = function(i, addressId) {
        $scope.clickShowChoiceAddress();
        userService.updateUserDefaultAddress(function(data) {
            if (data == 1) {
                var arry = [];
                arry = $scope.userCommunityAddressList[0];
                $scope.userCommunityAddressList[0] = $scope.userCommunityAddressList[i];
                $scope.userCommunityAddressList[i] = arry;
                $scope.userChoiceCommunityAddress = $scope.userCommunityAddressList[0];
            }
        }, userMobile, addressId);
    };

    /**
     * 显示隐藏地址选择
     */
    $scope.clickShowChoiceAddress = function() {
        var addressInfo = document.getElementsByClassName("order-commit-addressInfo")[0].getBoundingClientRect();
        $scope.addressChoiceMinHeight = document.body.clientHeight - addressInfo.height - addressInfo.top - 2;
        if ($scope.choiceAddressType) {
            $scope.choiceAddressType = false;
            $scope.moreAddressImgUrl = "./img/icon_right_hide_1.png";
        } else {
            $scope.choiceAddressType = true;
            $scope.moreAddressImgUrl = "./img/icon_down_show_1.png";
        }
    };

    /**
     * 可用优惠券数量计算
     */
    $scope.shopVoucherNum = function(data) {
        // console.log("vo:",$rootScope.selectVoucherIds);
        // console.log("voNum:",Object.keys($rootScope.selectVoucherIds).length);
        var couponId = 0;
        if (Object.keys($rootScope.selectVoucherIds).length > 0) {
            for (shopId in data) {
                var couponList = data[shopId];
                for (var i = 0; i < couponList.length; i++) {
                    if ($rootScope.selectVoucherIds[couponList[i]] && $scope.orderCommitObj[shopId].voucherNum > 0) {
                        $scope.orderCommitObj[shopId].voucherNum--;
                    }
                }
            }
        }
        // console.log('num:',$scope.orderCommitObj[shopId].voucherNum);
    };

    /**
     * 购物车商品数据处理
     * @param obj 商品数据
     * @returns {*} 返回值
     */
    $scope.goodsDataProcessing = function(obj, shopId) {
        if (!obj.canSale) {
            return false;
        } else {
            var goodes = {};

            goodes.preferenceId = obj.preferenceId;
            // goodes.leftNumOne = obj.leftNumOne;
            goodes.goodsNum = obj.cNum;
            goodes.goodsSkuId = obj.goodsSkuId;
            if (obj.ingredientsLength > 0) {
                goodes.goodsSkuIngredients = {};
                for (ingre in obj.ingredientsInfo) {
                    var ingredient = {};
                    ingredient.ingredientsId = obj.ingredientsInfo[ingre].ingredientsId;
                    ingredient.ingredientsNum = obj.ingredientsInfo[ingre].num;
                    goodes.goodsSkuIngredients[obj.ingredientsInfo[ingre].ingredientsId] = ingredient;
                }
            } else {
                goodes.goodsSkuIngredients = {};
            }
            goodes.goodsSkuScanDown = obj.goodsSkuScanDown || 0;
            goodes.goodsSkuScanLimit = obj.goodsSkuScanLimit || 0;
            goodes.iPrice = obj.iPrice || 0;

            if (!$scope.orderCommitObj[shopId].goodsMsg) {
                if ($scope.orderCommitObj[shopId].shopGoodsLength > 1) {
                    $scope.orderCommitObj[shopId].goodsMsg = obj.goodsSpuName + "等" + $scope.orderCommitObj[shopId].shopGoodsLength + "件商品";
                } else {
                    $scope.orderCommitObj[shopId].goodsMsg = obj.goodsSpuName;
                }
            }

            if ($scope.orderCommitObj[shopId].goodsImg.length < 4) {
                $scope.orderCommitObj[shopId].goodsImg.push("http://" + obj.goodsSpuImgs[0]);
            }

            $scope.orderCommitObj[shopId].goods.push(obj);
            return goodes;
        }
    };

    /**
     * 选择支付方式
     * @param choice 'arrival':货到付款;'online':在线支付;
     */
    $scope.choicePayment = function(choice) {
        if (choice == 'arrival') {
            $scope.order.payment.choice = '货到付款';
            $scope.order.payment.arrival = '06';
            $scope.order.payment.online = '05';
        } else {
            $scope.order.payment.choice = '在线支付';
            $scope.order.payment.arrival = '05';
            $scope.order.payment.online = '06';
        }
    };

    /**
     * 计算订单总金额
     */
    $scope.totalPrice = function() {
        $scope.order.orderprice.amountPayable = 0;
        for (shopId in $scope.orderInfo.orderGoodsInfo) {
            $scope.order.orderprice.amountPayable += parseFloat($scope.orderInfo.orderGoodsInfo[shopId].shopMoney);
        }
    };

    /**
     * 进入页面函数
     */
    $scope.loadMsg = function() {
        $scope.getUserCurrentCommunityAddress();
        //orderService.userShopingCartInfo(function(data) {
        //  //console.log('userShopingCartInfo --> ',data);
        //  $scope.order.msg = data;
        //  $scope.hideLoad.userShopingCartInfo = true;
        //  $scope.hideLoadingAfterData();
        //}, userMobile);
        $scope.goods = cartFactory.getCartItems();

        if ($scope.appEnvironmentSystem) {
            $scope.choicePayment('arrival');
        } else {
            $scope.choicePayment('online');
        }

        $scope.order.orderprice = {};
        $scope.order.orderprice.goodsTotalPrice = cartFactory.getTotalPromotionMoney();
        $scope.order.orderprice.freight = 0;
        $scope.order.orderprice.voucher = 0;
        //$scope.order.orderprice.firstorder = 0;
        //if ($scope.order.firstorder && $scope.order.orderprice.goodsTotalPrice >= $scope.order.firstorder.activeTerm.priceReach) {
        //  $scope.order.orderprice.firstorder = $scope.order.firstorder.activeTerm.priceDown;
        //}
        //$scope.order.orderprice.amountPayable = accSub(parseFloat(accSub(parseFloat(accAdd($scope.order.orderprice.goodsTotalPrice, $scope.order.orderprice.freight)), $scope.order.orderprice.voucher)), $scope.order.orderprice.firstorder, 1);
        $scope.order.orderprice.amountPayable = $scope.order.orderprice.goodsTotalPrice;
        $scope.orderInfo.orderGoodsInfo = {};
        $scope.orderCommitObj = {};

        //处理商品列表数据
        for (shopId in $scope.goods) {
            $scope.orderInfo.orderGoodsInfo[shopId] = {};
            $scope.orderInfo.orderGoodsInfo[shopId].groupGoods = {};
            $scope.orderInfo.orderGoodsInfo[shopId].singleGoods = [];
            $scope.orderInfo.orderGoodsInfo[shopId].shopGoodsLength = $scope.goods[shopId].shopGoodsLength;
            $scope.orderInfo.orderGoodsInfo[shopId].shopMoney = parseFloat($scope.goods[shopId].shopMoney);
            $scope.orderInfo.orderGoodsInfo[shopId].freight = parseFloat($scope.goods[shopId].freight);
            $scope.orderInfo.orderGoodsInfo[shopId].voucherId = 0;
            $scope.orderInfo.orderGoodsInfo[shopId].voucherPrice = 0;
            // 2016.06.22 运费改版 新添加
            $scope.orderInfo.orderGoodsInfo[shopId].freightShop = $scope.goods[shopId].freightShop;

            $scope.orderInfo.orderGoodsInfo[shopId].freightUseRule = $scope.goods[shopId].freightUseRule;
            $scope.orderInfo.orderGoodsInfo[shopId].freightTotal = $scope.goods[shopId].shopBrandFreight;

            $scope.orderInfo.orderGoodsInfo[shopId].remark = '';

            $scope.goodsDetail[shopId] = false;
            $scope.orderCommitObj[shopId] = {};
            $scope.orderCommitObj[shopId].groupGoods = {};
            $scope.orderCommitObj[shopId].singleGoods = [];
            $scope.orderCommitObj[shopId].goods = [];
            $scope.orderCommitObj[shopId].goodsImg = [];
            $scope.orderCommitObj[shopId].goodsMsg = "";
            $scope.orderCommitObj[shopId].promotionList = [];
            $scope.orderCommitObj[shopId].name = $scope.goods[shopId].name;
            $scope.orderCommitObj[shopId].shopGoodsLength = $scope.goods[shopId].shopGoodsLength;
            $scope.orderCommitObj[shopId].groupDownTotal = $scope.goods[shopId].groupDownTotal;
            $scope.orderCommitObj[shopId].shopMoney = $scope.goods[shopId].shopMoney;
            $scope.orderCommitObj[shopId].voucherNum = 0;
            $scope.orderCommitObj[shopId].voucherName = "";
            $scope.orderCommitObj[shopId].voucherPrice = 0;
            $scope.orderCommitObj[shopId].freight = $scope.goods[shopId].freight;
            $scope.orderCommitObj[shopId].freightTip = $scope.goods[shopId].freightTip;


            if ($rootScope.orderCoupon && $rootScope.orderCoupon[shopId]) {
                $scope.orderInfo.orderGoodsInfo[shopId].voucherId = $rootScope.orderCoupon[shopId].couponRecordId;
                $scope.orderInfo.orderGoodsInfo[shopId].voucherPrice = $rootScope.orderCoupon[shopId].couponPrice;
                $scope.orderInfo.orderGoodsInfo[shopId].shopMoney = parseFloat(accSub(parseFloat($scope.orderInfo.orderGoodsInfo[shopId].shopMoney), parseFloat($rootScope.orderCoupon[shopId].couponPrice), 1));
                if ($scope.orderInfo.orderGoodsInfo[shopId].shopMoney < 0) {
                    $scope.orderInfo.orderGoodsInfo[shopId].shopMoney = 0;
                }
                $scope.orderCommitObj[shopId].voucherPrice = $rootScope.orderCoupon[shopId].couponPrice;
                $scope.orderCommitObj[shopId].voucherName = $rootScope.orderCoupon[shopId].couponName;
                $scope.orderCommitObj[shopId].shopMoney = $scope.orderInfo.orderGoodsInfo[shopId].shopMoney;
            }

            var money = $scope.parseScanMoney(shopId);
            $scope.couponWithScan(shopId, money); // 调用扫码优惠
            $scope.couponWithScanEmployee(shopId, money); // 调用扫员工码优惠
            $scope.parseScanMoneyForFreight(shopId); // 调用扫员工码优惠后判断是否减免运费

            var groupGoods = $scope.goods[shopId].groupGoods;
            var singleGoods = $scope.goods[shopId].singleGoods;
            $scope._param[shopId] = [];

            if (!!groupGoods) {
                $scope.orderInfo.orderGoodsInfo[shopId].groupGoods = {};
                $scope.orderCommitObj[shopId].groupGoods = {};
                for (promotionId in groupGoods) {
                    var giftList = [];
                    if (groupGoods[promotionId].giftList && groupGoods[promotionId].giftList.length) {
                        var quantity = 0;
                        for (var i = 0; i < groupGoods[promotionId].giftList.length; i++) {
                            var gift = groupGoods[promotionId].giftList[i];
                            quantity += gift.num;
                        }
                        if (quantity > 0) {
                            giftList = groupGoods[promotionId].giftList;
                        }
                    }
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId] = {};
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].goodses = [];
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].promotionTerm = groupGoods[promotionId].promotionTerm;
                    delete $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].promotionTerm['promotionName'];
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].money = groupGoods[promotionId].money;
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].moneyOrg = groupGoods[promotionId].moneyOrg;
                    var giftListArr = [];
                    for (var g = 0; g < giftList.length; g++) {
                        var giftListObj = {};
                        giftListObj.id = giftList[g].id;
                        giftListObj.num = giftList[g].num;
                        giftListArr.push(giftListObj);
                    }
                    $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].giftList = giftListArr;

                    $scope.orderCommitObj[shopId].promotionList.push(groupGoods[promotionId].promotionTerm.promotionName);
                    $scope.orderCommitObj[shopId].groupGoods[promotionId] = {};
                    $scope.orderCommitObj[shopId].groupGoods[promotionId].goodses = [];
                    $scope.orderCommitObj[shopId].groupGoods[promotionId].name = groupGoods[promotionId].name;
                    $scope.orderCommitObj[shopId].groupGoods[promotionId].promotionTerm = groupGoods[promotionId].promotionTerm;
                    $scope.orderCommitObj[shopId].groupGoods[promotionId].money = groupGoods[promotionId].money;
                    $scope.orderCommitObj[shopId].groupGoods[promotionId].msg = groupGoods[promotionId].msg;
                    $scope.orderCommitObj[shopId].groupGoods[promotionId].msgPill = groupGoods[promotionId].msgPill;
                    $scope.orderCommitObj[shopId].groupGoods[promotionId].moneyOrg = groupGoods[promotionId].moneyOrg;
                    $scope.orderCommitObj[shopId].groupGoods[promotionId].giftList = giftList;

                    for (i = 0; i < groupGoods[promotionId].goodses.length; i++) {
                        var goods = $scope.goodsDataProcessing(groupGoods[promotionId].goodses[i], shopId);
                        if (!!goods) {
                            $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].goodses.push(goods);
                            $scope.orderCommitObj[shopId].groupGoods[promotionId].goodses.push(groupGoods[promotionId].goodses[i]);
                        }
                    }
                    if (!$scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId].goodses[0]) {
                        delete $scope.orderInfo.orderGoodsInfo[shopId].groupGoods[promotionId];
                        delete $scope.orderCommitObj[shopId].groupGoods[promotionId];
                    }
                }
            }
            if (singleGoods[0]) {
                for (s = 0; s < singleGoods.length; s++) {
                    var goods = $scope.goodsDataProcessing(singleGoods[s], shopId);
                    if (goods) {
                        $scope.orderInfo.orderGoodsInfo[shopId].singleGoods.push(goods);
                        $scope.orderCommitObj[shopId].singleGoods.push(singleGoods[s]);
                    }
                }
            }
            if ((Object.keys($scope.orderInfo.orderGoodsInfo[shopId].groupGoods).length == 0) && !$scope.orderInfo.orderGoodsInfo[shopId].singleGoods[0]) {
                delete $scope.orderInfo.orderGoodsInfo[shopId];
                delete $scope.orderCommitObj[shopId];
            }
        }
        $scope.shopIdList = Object.keys($scope.orderInfo.orderGoodsInfo);
        for (var i = 0; i < $scope.shopIdList.length; i++) {
            $scope.shopIdList[i] = parseInt($scope.shopIdList[i]);
        }

        if (parseFloat($scope.order.orderprice.amountPayable) < 0) {
            $scope.order.orderprice.amountPayable = 0;
        }

        $rootScope.orderCommitProductObjCoupon = $scope.orderInfo.orderGoodsInfo;
        // console.log("orderCommitProductObj:",$scope.orderCommitObj);
        // console.log("orderCommitProductObjCoupon:",$rootScope.orderCommitProductObjCoupon);
        couponService.queryShopCouponNumInShoppingCarNotCheckMoney(function(msg) {
            // console.log(msg);
            for (shopId in msg) {
                var couponList = msg[shopId];
                // console.log("num",couponList.length);
                if ($scope.orderCommitObj && $scope.orderCommitObj[shopId]) {
                    $scope.orderCommitObj[shopId].voucherNum = couponList.length;
                }
            }
            $scope.shopVoucherNum(msg);
            $scope.hideLoad.userShopingCartInfo = true;
            $scope.hideLoadingAfterData();
        }, $scope.orderInfo.orderGoodsInfo, userMobile);
        $scope.totalPrice();

        $scope.getPointMoney();
    };

    $scope.pointMoney = {};
    $scope.pointMoney.consumePoint = 0
    $scope.pointMoney.userPointMoney = 0;
    $scope.getPointMoney = function(){
        // console.log($scope.goods[SELF_SHOP_ID]||{})
        var phone = userLocationFactory.user().phone;
        var info = {};
        for(shopId in $scope.goods){
            var shop = $scope.goods[shopId]||{};
            var goodsMoney = parseFloat(shop.shopMoney) - parseFloat(shop.freight);
            info[shopId] = goodsMoney||0;
        }

        // console.log('-->', money);
        orderService.userPointMoneyByShopBrand(function(data){
            // console.log('==>',data);
            if(data && data.resultCode=='success'){
                $scope.pointMoney =  data.resultTO || {};
                // $scope.totalPriceForPoint();
            }
        }, phone, info);
    };

    /**
     * 选择地址
     */
    $scope.goAddressMessage = function() {
        $scope.toAddressMessage('order-commit');
    };
    /**
     * 修改用户地址
     */
    $scope.updateUserAddress = function() {
        shopIdListFactory.put("order_commit_shopIdList", $scope.shopIdList);
        if (angular.isObject($scope.userChoiceCommunityAddress)) {
            //          console.log("address_message_updateAddress");
            communalLocationFactory.updateAddress.put("address_message_updateAddress", $scope.userChoiceCommunityAddress);
        }
        communalLocationFactory.createAddressObj.remove("create_address_info");
        $scope.toCreateAddress("order-commit");
    };

    /**
     * 检测商品
     */
    $scope.addOrderCheck = function() {
        var communityId = window.localStorage.getItem('userCommunityId');
        var _param = {};
        var _items = cartFactory.getItems();
        // 构造检验商品的json格式
        for (shopId in _items) {
            var val = _items[shopId];
            var goodses = val.goodses || [];
            _param[shopId] = [];
            for (var i = 0; i < goodses.length; i++) {
                var goods = goodses[i];
                var _paramSku = {};
                _paramSku.skuId = goods.goodsSkuId;
                _paramSku.skuPrice = goods.goodsSkuPrice;
                _paramSku.skuPromotion = goods.goodsSkuPromotion;
                // _paramSku.preferenceId = goods.preferenceId;
                _param[shopId].push(_paramSku);
            }

        }

        orderService.checkShoppingCartNew(function(data) {
            if (data.appServerStatus == 'close') {
                $scope.showAlertWindow(data.resultMsg, 'cart');
            }
            cartFactory.validGoods(data.resultFlush);
            $scope.loadMsg();
            // $scope.hideLoading();
        }, _param, userMobile, communityId);
    };

    /**
     * 没有地址信息时弹窗
     */
    $scope.noAddressAlert = function() {
        var message = "亲，要写详细的地址哦~~";
        $scope.showAlertWindow(message);
    };

    $scope.gotoCouponList = function(shopId) {
        var shop = {
            "id": shopId,
            "name": $scope.goods[shopId].name
        };
        window.localStorage.setItem('voucherShopId', JSON.stringify(shop));
        $rootScope.orderMoney = parseFloat($scope.goods[shopId].shopMoney);
        $scope.toCouponList('orderCommit');
    };

    /**
     * 添加订单
     */
    $scope.addOrder = function() {
        if ($scope.userChoiceCommunityAddress && $scope.userChoiceCommunityAddress.addressId > 0) {
            $scope.showLoading('loading_order_commit.html');
            //var vouchers = [];
            //if ($rootScope.orderCoupon) {
            //  vouchers.push($rootScope.orderCoupon.couponRecordId);
            //}
            if (!angular.isObject($scope.userChoiceCommunityAddress)) {
                $scope.showAlertWindow("请添加或编辑收货地址！");
                $scope.hideLoading();
                return;
            }
            $scope.orderInfo.addressId = $scope.userChoiceCommunityAddress.addressId;
            $scope.orderInfo.orderMobile = userLocationFactory.user().phone;
            $scope.orderInfo.orderPayInfo = {};
            $scope.orderInfo.orderPayInfo.payMethod = 0;
            if ($scope.order.orderprice.amountPayable == 0) {
                $scope.order.payment.choice = "货到付款";
            }
            if ($scope.order.payment.choice == "在线支付") {
                $scope.orderInfo.orderPayInfo.payMethod = 1;
            }
            //$scope.orderInfo.orderActivityInfo = $scope.order.msg.firstorder;
            $scope.orderInfo.orderCost = {};
            $scope.orderInfo.orderCost.voucherIds = [];
            $scope.orderInfo.orderCost.orderprice = {};
            $scope.orderInfo.orderCost.orderprice.goodsTotalPrice = $scope.order.orderprice.goodsTotalPrice;
            $scope.orderInfo.orderCost.orderprice.amountPayable = $scope.order.orderprice.amountPayable;
            $scope.onlinPayObj.orderAddress = angular.fromJson(angular.toJson($scope.userChoiceCommunityAddress));
            $scope.onlinPayObj.price = $scope.order.orderprice.amountPayable;
            if ($scope.order.orderprice.firstorder > 0) {
                $scope.orderInfo.orderCost.firstorder = true;
            } else {
                $scope.orderInfo.orderCost.firstorder = false;
            }
            $scope.orderInfo.orderCost.freight = $scope.order.orderprice.freight;

            $scope.orderInfo.orderCost.userPointMoney = $scope.switchDisabled ? 0 : $scope.pointMoney.userPointMoney;
            $scope.orderInfo.orderCost.consumePoint = $scope.switchDisabled ? 0 : $scope.pointMoney.consumePoint;

            for(shopId in $scope.orderInfo.orderGoodsInfo){
                $scope.orderInfo.orderGoodsInfo[shopId].point = $scope.switchDisabled ? 0 : (($scope.pointMoney.detail||{})[shopId]||{}).point;
                $scope.orderInfo.orderGoodsInfo[shopId].pointMoney = $scope.switchDisabled ? 0 : (($scope.pointMoney.detail||{})[shopId]||{}).pointMoney;

            }
            //$scope.orderInfo.orderCost.scanActualPriceDown = parseFloat($scope.order.scanActualPriceDown); // 添加扫码公共key值，实际减的金额，普通扫码和员工码都有
            //$scope.orderInfo.orderCost.scanType = $scope.order.scanType; // 添加扫码公共key值，扫码类型 normal:普通优惠码 employee:员工码
            //
            //$scope.orderInfo.orderCost.scanCouponPrice = $scope.order.scanCouponPrice; // 添加普通扫码key值，金额
            //$scope.orderInfo.orderCost.scanCouponId = $scope.order.scanCouponId; // 添加普通扫码key值，特殊优惠券Id
            //
            //$scope.orderInfo.orderCost.scanEmployeePrice = $scope.order.scanEmployeePrice; // 添加扫员工码key值，金额
            $scope.orderInfo.appEnvironment = appEnvironment;
            $scope.orderInfo.appVersion = appVersion;
            $scope.orderInfo.userLocalTime = new Date().format('yyyy-MM-dd hh:mm:ss');


            // console.log('数据：',JSON.stringify($scope.goods));
            // console.log('订单数据：',JSON.stringify($scope.orderInfo));
            // return false;
            orderService.addOrderBack(function(data) {
                if (data.resultCode == "error") {
                    $scope.showAlertWindow(data.resultMsg, '11');
                }
                if (data.resultCode == "success") {
                    $rootScope.orderCoupon = null;
                    $rootScope.selectVoucherIds = {};
                    $rootScope.scan = {};
                    $rootScope.scanEmployee = {};
                    if ($scope.order.payment.choice == "在线支付") {
                        $scope.onlinPayObj.orderNum = data.resultTO.orderNum;
                        $scope.onlinPayObj.orderId = data.resultTO.orderId;
                        $scope.toOnlinePay($scope.onlinPayObj);
                    } else {
                        $scope.toOrderList();
                    }
                    $scope.emptyCart();
                }
                $scope.hideLoading();
                GOODS_PROMOTION_RULE = {}; // 清除存储的验证规则
            }, $scope.orderInfo);
        } else {
            $scope.noAddressAlert();
        }
    };

    /**
     * 扫码按钮点击事件
     * 如果已经扫过码，则不能再次扫码
     */
    $scope.orderCommitScanner = function(shopId) {
        window.localStorage.setItem("scanShopId", shopId);
        if ($rootScope.scan[shopId] || $rootScope.scanEmployee[shopId]) {
            $ionicPopup.alert({
                title: '提示信息',
                template: '您已经扫码，不能再次扫码',
                okText: '知道了'
            });
        } else {
            $scope.scanner(shopId);
        }
    };

    /**
     * 订单扫码优惠
     * 给订单多添加三个key
     * @param money 优惠金额
     */
    $scope.couponWithScan = function(shopId, money) {
        if ($rootScope.scan[shopId]) {
            var _money = Math.min($scope.orderInfo.orderGoodsInfo[shopId].shopMoney, money);
            $scope.mountOrderMoney(shopId, money);
            $scope.orderInfo.orderGoodsInfo[shopId].scanActualPriceDown = _money.toFixed(1); // 实际优惠金额，页面使用和后台使用
            $scope.orderInfo.orderGoodsInfo[shopId].scanType = 'normal'; // 添加扫码公共key值，扫码类型 normal:普通优惠码 employee:员工码
            $scope.orderInfo.orderGoodsInfo[shopId].scanCouponPrice = money; // 添加普通扫码key值，金额
            $scope.orderInfo.orderGoodsInfo[shopId].scanCouponId = $rootScope.scan[shopId].scanCouponId; // 添加普通扫码key值，特殊优惠券Id
            $scope.orderCommitObj[shopId].scanActualPriceDown = $scope.orderInfo.orderGoodsInfo[shopId].scanActualPriceDown;
        }
    };

    /**
     * 订单扫员工码优惠
     * 给订单多添加两个key
     * @param money 优惠金额
     */
    $scope.couponWithScanEmployee = function(shopId, money) {
        if ($rootScope.scanEmployee[shopId]) {
            var _money = Math.min($scope.orderInfo.orderGoodsInfo[shopId].shopMoney, money);
            $scope.mountOrderMoney(shopId, money);
            $scope.orderInfo.orderGoodsInfo[shopId].scanActualPriceDown = _money.toFixed(1); // 实际优惠金额，页面使用和后台使用
            $scope.orderInfo.orderGoodsInfo[shopId].scanType = 'employee'; // 添加扫码公共key值，扫码类型 normal:普通优惠码 employee:员工码
            $scope.orderInfo.orderGoodsInfo[shopId].scanEmployeePrice = money; // 添加普通扫码key值，金额
            $scope.orderCommitObj[shopId].scanActualPriceDown = $scope.orderInfo.orderGoodsInfo[shopId].scanActualPriceDown;
        }
    };

    $scope.mountOrderMoney = function(shopId, money) {
        var _money = Math.min($scope.orderInfo.orderGoodsInfo[shopId].shopMoney, money);
        $scope.orderInfo.orderGoodsInfo[shopId].shopMoney = accSub($scope.orderInfo.orderGoodsInfo[shopId].shopMoney, _money.toFixed(1), 1);
        $scope.orderCommitObj[shopId].shopMoney = $scope.orderInfo.orderGoodsInfo[shopId].shopMoney;
        $scope.totalPrice();
    };

    /**
     * 计算扫码优惠金额，按不同的规则
     * $rootScope.scan 普通扫码，直接返回优惠金额
     * $rootScope.scanEmployee 扫员工码  街边店返回 0.3 ~ 1 之间的随机数 + 自营返回 0.3 ~ 自营商品合计*0.05
     */
    $scope.parseScanMoney = function(shopId) {
        var money = 0;
        if ($rootScope.scan[shopId]) {
            money = $rootScope.scan[shopId].scanCouponPrice;
        } else if ($rootScope.scanEmployee[shopId]) {
            money = $rootScope.scanEmployee[shopId].scanCouponPrice;
        } else {

        }

        return money;
    };

    $scope.parseScanMoneyForEmployee = function(streetMin, streetMax, platformMin, platformPersent) {
        var money = 0;
        var selfShopMoney = ($scope.orderInfo.orderGoodsInfo[SELF_SHOP_ID] || {}).shopMoney || 0;
        var streetShopMoney = 0;
        if ($scope.orderInfo.orderGoodsInfo) {
            for (shopId in $scope.orderInfo.orderGoodsInfo) {
                var shop = $scope.orderInfo.orderGoodsInfo[shopId];
                if (shopId == SELF_SHOP_ID) {} else {
                    streetShopMoney += shop.shopMoney;
                }
            }
        }
        if (selfShopMoney > platformMin) {
            var m1 = getRandomNum(platformMin, selfShopMoney * platformPersent);
            if (selfShopMoney * platformPersent <= platformMin) {
                m1 = 0;
            }
            money += m1;
        }
        if (streetShopMoney > streetMin) {
            var m2 = getRandomNum(streetMin, streetMax);
            money += m2;
        }
        return money;
    };

    $scope.parseScanMoneyForFreight = function(shopId) {
        if ($rootScope.scanEmployee[shopId] && $rootScope.scanEmployee[shopId].isFreight == '0') {
            $scope.orderInfo.orderGoodsInfo[shopId].isFreight = $rootScope.scanEmployee[shopId].isFreight == '0';
            $scope.orderInfo.orderGoodsInfo[shopId].shopMoney = accSub($scope.orderInfo.orderGoodsInfo[shopId].shopMoney, $scope.orderInfo.orderGoodsInfo[shopId].freight, 1);
            if ($scope.orderInfo.orderGoodsInfo[shopId].shopMoney < 0) {
                $scope.orderInfo.orderGoodsInfo[shopId].shopMoney = 0;
            }
            $scope.orderInfo.orderGoodsInfo[shopId].freight = 0;
            $scope.orderCommitObj[shopId].shopMoney = $scope.orderInfo.orderGoodsInfo[shopId].shopMoney;
            $scope.orderCommitObj[shopId].freight = $scope.orderInfo.orderGoodsInfo[shopId].freight;
            $scope.totalPrice();
        }
    };

    /**
     * 扫码后弹窗提示 优惠金额
     * @param money 金额
     */
    $scope.showScanMoney = function(shopId, money, name) {
        var _money = Math.min($scope.orderInfo.orderGoodsInfo[shopId].shopMoney, money).toFixed(1);
        if (name) {
            var text = '您好' + name + ',此次扫码为您优惠' + _money + '元';
        } else {
            var text = '您此次扫码优惠' + _money + '元';
        }
        $ionicPopup.alert({
            title: '提示信息',
            template: text,
            okText: '知道了'
        });
    };

    $scope.switchDisabled = true;

    $scope.toggleSwitch = function() {
        $scope.switchDisabled = !$scope.switchDisabled;
        $scope.totalPriceForPoint();
    };

    $scope.totalPriceForPoint = function(){
        // console.log($scope.order.orderprice.amountPayable);
        if(!$scope.switchDisabled){
            $scope.order.orderprice.amountPayable -= $scope.pointMoney.userPointMoney;
        }else{
            $scope.order.orderprice.amountPayable += $scope.pointMoney.userPointMoney;
        }
        if($scope.order.orderprice.amountPayable < 0){
            $scope.order.orderprice.amountPayable = 0;
        }
        $scope.order.orderprice.amountPayable = parseFloat($scope.order.orderprice.amountPayable.toFixed(2));
    };

    $scope.$on('order-commit-v2-init', function() {
        $scope.showLoading('loading.html');
        $scope.addOrderCheck();
    });

    /**
     * 监听此页面扫码之后的操作
     * @param e
     * @param priceDown 减多少钱
     */
    $scope.$on('orderCommitForScan', function(e, priceDown, id, resource) {
        var shopId = window.localStorage.getItem("scanShopId");
        $rootScope.scan[shopId] = {};
        $rootScope.scan[shopId].scanCouponPrice = priceDown;
        $rootScope.scan[shopId].scanCouponId = id;
        var money = $scope.parseScanMoney(shopId);
        $scope.showScanMoney(shopId, money);
        $scope.couponWithScan(shopId, money);
    });

    /**
     * 扫员工码
     * @param e
     * @param streetMin 街边店优惠最小金额
     * @param streetMax 街边店优惠最大金额
     * @param platformMin 平台自营优惠最小金额
     * @param platformPersent 平台自营优惠最大百分比
     */
    $scope.$on('orderCommitForScanEmployee', function(e, streetMin, streetMax, platformMin, platformPersent, isFreight, name) {
        var shopId = window.localStorage.getItem("scanShopId");
        $rootScope.scanEmployee[shopId] = {};
        $rootScope.scanEmployee[shopId].scanCouponPrice = $scope.parseScanMoneyForEmployee(streetMin, streetMax, platformMin, platformPersent);
        $rootScope.scanEmployee[shopId].isFreight = isFreight;
        $scope.parseScanMoneyForFreight(shopId);
        var money = $scope.parseScanMoney(shopId);
        $scope.showScanMoney(shopId, money, name);
        $scope.couponWithScanEmployee(shopId, money);
    });
}]);
