/**
 * Created by cwt on 2015/10/12.
 */
app.controller('orderEvaluateCtrl',['$scope', 'orderService', 'commentService', 'userLocationFactory', function($scope, orderService, commentService, userLocationFactory){

    /**
     * 用户手机号
     * @type {String}
     */
    var userMobile =  userLocationFactory.user().phone;
    /**
     * 缓存中取到的评论相关信息
     * @type {LocalStorageMap}
     */
    var evaluateCacheInfo = new LocalStorageMap("evaluateInfo");
    $scope.evaluateData = evaluateCacheInfo.get("evaluateInfo");
    $scope.evaluateData["logisticsPerson"] = $scope.evaluateData["logisticsPerson"] || "荷粉物流";
    /**
     * 评论信息的星级及内容
     * @type {{deliveryName: {}, shopName: {}, evaluateDescribe: string}}
     */
    $scope.evaluateInfo = {
        deliveryName : {
//            "张玉东" : 0
        },
        shopName : {
//            "田老师红烧肉盖饭" : 0,
//            "咖啡陪你" : 0,
//            "柳镇黄焖鸡" : 0
        },
        evaluateDescribe : ""
    };

    $scope.commentStarNum = {
        "shopBrandComment": [
//            {
//                "goodsSpuId": "2115",
//                "shopBrandId": "174",
//                "goodsSpuName": "康师傅冰红茶1L",
//                "shopBrandName": "保定市南市区红燕批发部",
//                "shopBrandStarNum": 5
//            }
        ],
        "logisticsPersonCommentStar": 0
    };

    /**
     * 初始化评论信息的星级
     */
    $scope.initEvaluateInfo = function(){
        $scope.evaluateInfo.deliveryName[$scope.evaluateData.logisticsPerson] = 5;
        var SBI = $scope.evaluateData.shopBrandInfo;
        for( var i=0; i<SBI.length; i++ ) {
            if( SBI[i].shopBrandGoodsList.length == 0 ) {
                continue;
            } else {
                var SBGL = SBI[i].shopBrandGoodsList;
                $scope.evaluateInfo.shopName[SBI[i].shopBrandName] = 5;
                var shopGoodsStar = {
                    "goodsSpuId": 0,
                    "shopBrandId": SBI[i].shopBrandId,
                    "goodsSpuName": "",
                    "shopBrandName": SBI[i].shopBrandName,
                    "shopBrandStarNum": $scope.evaluateInfo.shopName[SBI[i].shopBrandName]
                };
                for( var j=0; j<SBGL.length; j++){
                    shopGoodsStar.goodsSpuId = SBGL[j].goodsId;
                    shopGoodsStar.goodsSpuName = SBGL[j].goodsName;
                }
                $scope.commentStarNum.shopBrandComment.push(shopGoodsStar);
            }
        }
    };



    $scope.numberToObject = function( number ) {
        var newObject = {};
        for( var i=0; i < 5; i++ ) {
            if( number <= i ) {
                newObject[i] = 'gray';
            } else {
                newObject[i] = 'red';
            }
        }
        return newObject;
    };


    $scope.changeStar = function( infoKey, nameKey, num ) {
        num = parseInt(num);
        num = num + 1;
        $scope.evaluateInfo[infoKey][nameKey] = num;
    };

    $scope.submitEvaluate = function() {
        var SBC = $scope.commentStarNum.shopBrandComment;
        for( var i=0;i<SBC.length;i++ ) {
            SBC[i].shopBrandStarNum = $scope.evaluateInfo.shopName[SBC[i].shopBrandName];
        }

        $scope.commentStarNum.logisticsPersonCommentStar = $scope.evaluateInfo.deliveryName[$scope.evaluateData.logisticsPerson];
        var orderEvaluateInfo = {
            "commentOrderId": $scope.evaluateData.orderId,
            "commentUserMobile": userMobile,
            "commentStarNum": $scope.commentStarNum,
            "commentContent": $scope.evaluateInfo.evaluateDescribe
        };

        commentService.addComment(function(msg){
            if( msg.resultCode == "success" ) {
                $scope.toOrderList();
            } else if( msg.resultCode == "failed" ) {

            }
        },orderEvaluateInfo);

    };

    $scope.initEvaluateInfo();
}]);

app.directive('evaluate-star', function() {
    return {
        restrict: 'AC',
        replace: true,
        template: '<img ng-repeat="i in starNum" />',
        scope: {
            number: '=number'
        },
        link: function(scope, ele, attr, ctrl){
            scope.starNum = [];
            for (var i = 0; i < scope.number; i++) {
                scope.starNum.push(i);
            }
        }
    };
});

