/**
 * Created by cwt on 2015/9/25.
 */
app.controller('orderInfoCtrl', ['$scope', '$rootScope', '$timeout', '$state', '$ionicPopup', 'orderService', 'cartFactory', '$interval', function($scope, $rootScope, $timeout, $state, $ionicPopup, orderService, cartFactory, $interval) {
    //910 907 902 898 895 888 860 856 846 840 836 827 820 813 809 788 779 773 770 768 760 758 757 756

    /**
     * 订单Id
     * @type {Number}
     */
    $scope.orderId = parseInt(window.localStorage.getItem("orderInfoOrderId"));

    var limitNumber = 3;
    /**
     * 显示商品数量
     * @type {number}
     */
    $scope.showGoodsNumber = 0;
    /**
     * 限制显示商品数量
     * @type {number}
     */
    $scope.limitShowGoodsNumber = limitNumber;
    /**
     * 订单商品显示计数
     * @type {{Object}} {"171_0":1,"171_1":2,"171_2":3,"171_3":4}
     */
    $scope.orderGoodsShowCount = {};

    var orderInfo = {
        orderId: $scope.orderId
    };

    $scope.orderInfoShopGoods = {};

    /**
     * 订单发送信息
     * orderNumApp : "HF1509282303565",
     * orderNum : "2015092800001",
     * currentTime : 1444053196595,
     * orderConfirmTime : 1443541605275
     * @type {{orderNumApp: string, orderNum: string, currentTime: number, orderConfirmTime: number}}
     */
    $scope.orderInfoSend = {};

    /**
     * 订单地址信息
     * contactPerson : "陈文涛",
     * contactPhone : 15733238960,
     * communityName : "佳远水源湾小区",
     * addressContent : "乐凯北大街122号元吉泰典当行1-1-902",
     * addressId : 1
     * @type {{contactPerson: string, contactPhone: number, communityName: string, addressContent: string, addressId: number}}
     */
    $scope.orderInfoAddress = {};

    /**
     * 订单价格信息
     * amountPayable : "60.0",     //实际支付金额
     * goodsTotalPrice : "60.0",   //商品金额
     * freight : 0,                //运费
     * vouchersPrice : 0,          //优惠券金额
     * firstOrderPriceDown : 0,    //首单减免金额
     * firstOrder : false          //首单减免判断
     * @type {{amountPayable: string, goodsTotalPrice: string, freight: number, vouchersPrice: number, firstOrderPriceDown: number, firstOrder: boolean}}
     */
    $scope.orderInfoPrice = {};

    /**
     * 剩余到达时间
     */
    $scope.arriveTime = 0;

    /**
     * 再来一单的商品结构
     * @type {{goodsSpuId: number, goodsSpuName: string, goodsSpuImgs: string[], goodsSpuShopBrandName: string, goodsSpuShopBrandId: number, ingredientsInfo: {}, goodsSkuName: string, goodsSkuId: number, goodsSkuPromotionPrice: number, goodsSkuPrice: number, goodsSkuPromotion: Array, cNum: number, cPrice: number, oPrice: number, unitCPrice: number, unitOPrice: number, goodsPrice: number}}
     */
    $scope.againBuyGoods = {
        //        goodsSpuId: 1732,
        //        goodsSpuName: '出塞曲精装蒙古奶条酸奶味100g',
        //        goodsSpuImgs: [
        //            "222.222.181.238:8189/img/shopBrand/2015/05/15/1E5508CCEFFB3BEE3523EA8AD485E943_small.jpg",
        //            "222.222.181.238:8189/img/shopBrand/2015/05/15/1E5508CCEFFB3BEE3523EA8AD485E943_medium.jpg",
        //            "222.222.181.238:8189/img/shopBrand/2015/05/15/1E5508CCEFFB3BEE3523EA8AD485E943_big.jpg"
        //        ],
        //        goodsSpuShopBrandName: '保定市程意商贸有限公司',
        //        goodsSpuShopBrandId: 183,
        //        ingredientsInfo: {},
        //        goodsSkuName: '出塞曲精装蒙古奶条酸奶味100g(100g)',
        //        goodsSkuId: 10936,
        //        goodsSkuPromotionPrice: 0,
        //        goodsSkuPrice: 6.8,
        //        goodsSkuPromotion: [],
        //        cNum: 2,
        //        cPrice: 13.6,
        //        oPrice: 0,
        //        unitCPrice: 6.8,
        //        unitOPrice: 0,
        //        goodsPrice: 6.8
    };

    /**
     * 配送信息
     * @type {string}
     */
    $scope.sendInfo = "";

    /**
     * 订单状态
     * @type {number}
     */
    $scope.orderStatus = 0;
    /**
     * 订单支付方式
     * @type {string}
     */
    $scope.payMethod = "";
    /**
     * 支付成功     1:成功    0:失败
     * @type {number}
     */
    $scope.payStatus = 0;
    /**
     * 删除订单显示
     * @type {string}
     */
    $scope.deleteOrderStr = "删除订单";
    /**
     * 再来一单显示
     * @type {string}
     */
    $scope.againOrderStr = "再来一单";
    /**
     * 记录跳转订单信息页的上一页
     */
    $scope.upOrderInfo = localStorage.getItem("beforeOrderInfo");
    /**
     * 记录跳转购物车页的上一页
     */
    $scope.upCart = localStorage.getItem("beforeCart");

    $scope.scrollType = true;

    $scope.showText = "";

    /**
     * 判断是否第二版
     * @type {String} 'v2' | ''
     */
    $scope.orderInfoIsV2 = (typeof orderListVersion) === 'function' && orderListVersion(appEnvironment) == 'v2';
    $scope.orderInfoAll = {};
    $scope.orderRemark = '';
    /**
     * 返回事件
     */
    $scope.orderInfoGoBack = function() {
        var upOrderInfo = window.localStorage.getItem("beforeOrderInfo"); //获取跳转到订单详情页的上一页
        var upCart = window.localStorage.getItem("beforeCart"); //获取跳转到购物车页的上一页
        var goUrl = 'home';
        if(upOrderInfo == "order-list"){
            goUrl = 'order-list';
        }
        if(upOrderInfo == "order-list-v2"){
            goUrl = 'order-list-v2';
        }
        // if(upOrderInfo == "order-list"){
        //     goUrl = upOrderInfo;
        // }else if(upOrderInfo == "order-commit" && upCart == "order-info"){
        //     goUrl = 'home';
        // }else if(upOrderInfo == "order-info" && upCart == "order-info"){
        //     goUrl = "order-list";
        // }else if(upOrderInfo == "cart" && upCart == "order-info"){
        //     goUrl = "order-list";
        // }else{
        //     goUrl = upCart;
        // }
//        alert("goUrl:"+goUrl);
        $state.go(goUrl);
        /*
        if ($scope.upOrderInfo == "order-commit") {
            if ($scope.upCart == "order-info") {
                $scope.toHome();
            } else {
                $state.go($scope.upCart);
            }
            return;
        } else if ($scope.upOrderInfo == "order-list") {
            $scope.toOrderList();
            return;
        }*/
    };

    /**
     * 获取订单信息
     */
    $scope.getOrderInfo = function() {
        if($scope.orderInfoIsV2){
            var bossOrderNum = window.localStorage.getItem("orderInfoOrderId")||'';
            orderService.bossOrderDetails(function(msg) {
                // console.log("orderInfo："+JSON.stringify(msg));//orderInfoSend  orderInfoAddress orderInfoPrice
                $scope.orderInfoSend = msg.orderInfoSend;
                $scope.orderInfoPrice = msg.orderInfoPrice;
                $scope.orderInfoAddress = msg.orderInfoAddress;
                $scope.orderInfoShopGoods = msg.orderInfoShopGoods;
                // console.log("$scope.orderInfoShopGoods"+JSON.stringify($scope.orderInfoShopGoods));
                $scope.payStatus = msg.payStatus;
                $scope.payMethod = msg.payMethod;
                $scope.orderStatus = msg.orderStatus;
                $scope.arriveTime = $scope.subTime($scope.orderInfoSend.orderSendTime, $scope.orderInfoSend.currentTime);

                $scope.orderInfoAll = msg||{};

                for(shopId in msg.msg.orderGoodsInfo){
                    var info = msg.msg.orderGoodsInfo[shopId];
                    $scope.orderRemark += info.remark||'';
                }

                $scope.initFooterButton(); //初始化页面
                $scope.hideLoading();
            }, bossOrderNum);
        }else{
            orderService.queryOrder(function(msg) {
                // console.log("orderInfo："+JSON.stringify(msg));//orderInfoSend  orderInfoAddress orderInfoPrice
                $scope.orderInfoSend = msg.orderInfoSend;
                $scope.orderInfoPrice = msg.orderInfoPrice;
                $scope.orderInfoAddress = msg.orderInfoAddress;
                $scope.orderInfoShopGoods = msg.orderInfoShopGoods;
                // console.log("$scope.orderInfoShopGoods"+JSON.stringify($scope.orderInfoShopGoods));
                $scope.payStatus = msg.payStatus;
                $scope.payMethod = msg.payMethod;
                $scope.orderStatus = msg.orderStatus;
                $scope.arriveTime = $scope.subTime($scope.orderInfoSend.orderSendTime, $scope.orderInfoSend.currentTime);

                $scope.initFooterButton(); //初始化页面
                $scope.hideLoading();
            }, orderInfo);
        }

    };

    $rootScope.orderInfoTime = $interval(function(){
        $scope.arriveTime--;
        if( $scope.arriveTime <=0 ) {
            $interval.cancel($rootScope.orderInfoTime);
        }
    },6*1000);

    /**
     * 时间戳相减
     * @param sTime         开始时间
     * @param cTime         结束时间
     * @returns {number}    返回以分钟为单位的数
     */
    $scope.subTime = function(sTime, cTime) {
        var newTime = 0;
        newTime = parseInt((cTime - sTime) / (1000 * 60));
        newTime = 60 - newTime;
        //        console.log("newTime:"+newTime);
        if (newTime > 0) {
            return newTime;
        } else {
            return 0;
        }
    };

    /**
     * 商品显示判断
     * @returns {boolean}
     */
    $scope.showGoodsJudge = function(numKey, num) {

        if (!$scope.orderGoodsShowCount[numKey + "_" + num]) {
            $scope.showGoodsNumber++;
            $scope.orderGoodsShowCount[numKey + "_" + num] = $scope.showGoodsNumber;
        }
//        if( $scope.showGoodsNumber > 1 ) {
//            $scope.scrollType = true;
//        } else {
//            $scope.scrollType = false;
//        }
        if( $scope.scrollType ) {
            $scope.showText = '还有'+($scope.showGoodsNumber-3)+'件商品';
        }
        return ($scope.orderGoodsShowCount[numKey + "_" + num] > $scope.limitShowGoodsNumber);
    };
    /**
     * 显示更多的商品
     */
    $scope.showGoodsToggle = function() {
        if( $scope.scrollType ) {
//            if ($scope.limitShowGoodsNumber != $scope.showGoodsNumber) {
            $scope.limitShowGoodsNumber = $scope.showGoodsNumber;
//            } else {
//                $scope.limitShowGoodsNumber = limitNumber;
//            }
        }
        $scope.showText = '已到底部';
        $scope.scrollType = false;
    };
    /**
     * 收起更多显示商品
     */
    $scope.showGoodsFewer = function(){
        if( $scope.scrollType ) {
            $scope.limitShowGoodsNumber = $scope.showGoodsNumber;
            $scope.showText = '已到底部';
            $scope.scrollType = false;
        } else {
            $scope.showText = '还有'+($scope.showGoodsNumber-3)+'件商品';
            $scope.scrollType = true;
            $scope.limitShowGoodsNumber = limitNumber;
        }
    };

    /**
     * 跳转订单追踪页面
     */
    $scope.goOrderTracking = function( orderNumApp ) {
        $scope.toOrderTracking(orderNumApp);
    };

    $scope.goOrderTrackingNew = function( info ) {
        // console.log(info);
        $scope.toOrderTracking(info.bossOrderShopOrderNum);
    };


    /**
     * 更多配料的显示与隐藏
     * @param parameter1
     * @param parameter2
     */
    $scope.toggleRelishShow = function(parameter1, parameter2) {
        var dom = $dom('.' + parameter1);
        var angularDom = angular.element(dom);
        angularDom.toggleClass('relishShow');
        var dom2 = $dom('.' + parameter2);
        var angularDom2 = angular.element(dom2);
        angularDom2.toggleClass('icon_rotate');
    };

    /**
     * 底部左按钮
     */
    $scope.footerLeftBtn = function() {
        if ($scope.deleteOrderStr == "删除订单") {
            $scope.showConfirmDeleteWindow();
        } else if ($scope.deleteOrderStr == "返回列表") {
            $scope.toOrderList();
        } else if ($scope.deleteOrderStr == "取消订单") {
        	if( $scope.orderStatus < 1 ) {
	            $scope.showConfirmWindow();
        	} else if( $scope.orderStatus < 4 ) {
        		$scope.showCancelOrderAlertWindow("订单已确认，请联系荷粉客服。");
        	}
        }
    };
    /**
     * 显示确认删除订单窗口
     */
    $scope.showConfirmDeleteWindow = function() {
        var confirmPopup = $ionicPopup.confirm({
            title: '<strong>删除订单</strong>',
            template: '你真的要删除这个订单？',
            okText: '取消',
            okType: 'button-default',
            cancelText: '确认',
            cancelType: 'button-positive'
        });
        confirmPopup.then(function(res) {
            if (res) {} else {
                $scope.deleteOrder();
            }
        });
    };
    /**
     * 删除订单
     */
    $scope.deleteOrder = function(){
        var deleteOrderInfo = {
            orderId: $scope.orderId,
            orderStatus: 10
        };
        orderService.updateOrder(function(msg) {
            if (msg) {
                $scope.toOrderList();
            }
        }, deleteOrderInfo);
    };
    /**
     * 取消订单
     */
    $scope.cancelOrder = function(){
        var orderInfo3 = {
            orderId: $scope.orderId,
            orderStatus: 7
        };
        orderService.cancelOrder(function(msg) {
            if (msg == 1) {
                $scope.toOrderList();
            } else {
            	$scope.showCancelOrderAlertWindow("取消订单失败，请联系荷粉客服。");
//                alert("取消订单失败");
            }
        }, orderInfo3);
    };

    /**
     * 底部右按钮
     */
    $scope.footerRightBtn = function() {

        if( $scope.againOrderStr == "继续购物" ) {
            $scope.toHome();
        }
        if( $scope.againOrderStr == "支付" ) {
            $scope.againPay();
        }
        if( $scope.againOrderStr == "再来一单" ) {
            $scope.againOrder();
        }
    };
    /**
     * 再次支付
     */
    $scope.againPay = function(){
        var orderInfo2 = {
            orderId: $scope.orderId
        };
        orderService.againOrderGoodsInfo(function(msg) {
            if (msg.resultCode == "success") {
                var goodsName = "";
                var goodsDescription = "";
                var goodsArray = [];
                for (var key in msg.resultTO) {
                    goodsArray = goodsArray.concat(msg.resultTO[key].singleGoods);
                }
                for (var j = 0; j < goodsArray.length; j++) {
                    if( j != 0 ) {
                        goodsName += "、";
                        goodsDescription += "、";
                    }
                    goodsName += goodsArray[j].goodsSpuName;
                    goodsDescription += goodsArray[j].goodsSpuName+"("+goodsArray[j].goodsSkuName+")X"+goodsArray[j].goodsNum
                }

                var onlinePayObj = {
                    orderNum : $scope.orderInfoSend.orderNum,
                    orderId : $scope.orderId,
                    goodsName : goodsName,
                    goodsDescription : goodsDescription,
                    price : $scope.orderInfoPrice.amountPayable,
                    orderAddress : $scope.orderInfoAddress
                };
                $scope.toOnlinePay(onlinePayObj);
            }
        }, orderInfo2);
    };
    /**
     * 再来一单
     */
    $scope.againOrder = function(){
        $scope.emptyCart(); //清空购物车
        // console.log($scope.orderInfoShopGoods);
        var goodsList = $scope.orderGoodsTurnCartGoods($scope.orderInfoShopGoods);
        // console.log(JSON.stringify(goodsList));
        for(var i=0; i<goodsList.length; i++){
            var goods = goodsList[i];
            cartFactory.addItem(goods);
        }
        $scope.$emit("changeCart");
        $scope.toCart();
    };
    /**
     * 显示确认取消订单对话窗
     */
    $scope.showConfirmWindow = function() {
        var confirmPopup = $ionicPopup.confirm({
            title: '<strong>取消订单</strong>',
            template: '你真的不要这些商品啦？',
            cancelText: '<span class="cf_size">是的，绝心不要</span>',
            cancelType: 'button-default',
            okText: '<span class="cf_size">我还要</span>',
            okType: 'button-positive'
        });

        confirmPopup.then(function(res) {
            if (res) {

            } else {
                if( $scope.payStatus == 1 ) {
                    $scope.showAlertWindow( $scope.orderInfoPrice.amountPayable );
                } else {
                    $scope.cancelOrder();
                }
            }
        });
    };
    /**
     * 显示提示对话框
     */
    $scope.showAlertWindow = function( money ) {
        var alertPopup = $ionicPopup.alert({
            title: '温馨提示！',
            template: '您支付的￥'+money+'元，将于下个工作日返回您的账户中，如有疑问请拨打： 400-823-6969',
            okText: '我知道了'
        });
        alertPopup.then(function(res) {
            $scope.cancelOrder();
//            console.log('Thank you for not eating my delicious ice cream cone');
        });
    };

    /**
     * 初始化配送信息
     */
    $scope.initSendInfo = function(){
        //        {0:"正在确认",1:"订单确认",2:"采购完成",3:"已发货",4:"确认收货(完成)",5:"已评论",7:"已取消订单"}
        switch ($scope.orderStatus) {
            case 0:
                $scope.sendInfo = "";
                break;
            case 1:
                $scope.sendInfo = "";
                break;
            case 2:
                $scope.sendInfo = "";
                break;
            case 3:
                $scope.sendInfo = "";
                break;
            case 4:
                $scope.sendInfo = "";
                break;
            case 5:
                $scope.sendInfo = "";
                break;
            case 7:
                $scope.sendInfo = "";
                break;
            default:
                break;
        }
    };

    /**
     * 初始化底部按钮
     */
    $scope.initFooterButton = function() {
        //alert("$scope.upOrderInfo:"+$scope.upOrderInfo+"     $scope.payStatus:"+$scope.payStatus);
        if ($scope.upOrderInfo == "order-commit") {
//            $scope.deleteOrderStr = "继续购买";
            if( $scope.payStatus == 0 && $scope.payMethod == "在线支付" ) {
                //在线支付未成功
                $scope.againOrderStr = "支付";
                //未完成订单
                $scope.deleteOrderStr = "返回列表";
            } else {
            	//货到付款 未确认
                $scope.deleteOrderStr = "取消订单";
                $scope.againOrderStr = "继续购物";
            }
        } else {
            if ( $scope.orderStatus > 3 ) {
                //已完成订单
                $scope.deleteOrderStr = "删除订单";
            } else if( $scope.orderStatus < 1 ){
                $scope.deleteOrderStr = "取消订单";
            } else {
                //已确认未完成订单
//                $scope.deleteOrderStr = "返回列表";
                $scope.deleteOrderStr = "取消订单";
            }

            if( $scope.orderStatus == 7 ) {
            	$scope.againOrderStr = "再来一单";
            } else {
            	if( $scope.payStatus == 0 && $scope.payMethod == "在线支付" ) {
	                //在线支付未成功
	                $scope.againOrderStr = "支付";
	            } else {
	                $scope.againOrderStr = "再来一单";
	            }
            }
        }
//        if ($scope.upOrderInfo == "order-list") {}
    };

    $scope.$on('order-info-init', function(){
    	$scope.showLoading('loading.html');
    	$scope.orderNum = window.localStorage.getItem("orderInfoOrderNum");
    	if($scope.orderNum){
    		window.localStorage.removeItem("orderInfoOrderNum");
    		orderService.wxOnlinePayInfoSynchronous( $scope.orderNum );
    	}
        $scope.getOrderInfo();
    });

//    $scope.onlinePaySuccess = function(message){
//    	window.localStorage.removeItem("iosOnlinePay");
//		//message = message.toString();
//		//var payInfoArr = message.split('&');
//		//var orderNum = "";
//		//for(var i=0;i<payInfoArr.length;i++){
//			//if(payInfoArr[i].indexOf('out_trade_no') != -1){
//				//orderNum = payInfoArr[i].split('=')[1];
//				//break;
//			//}
//		//}
//		var data = {};
//		data.orderNum = message;
//		data.payInfo = "";
//		orderService.onlinePayInfoSynchronous(function(msg){
//			$scope.getOrderInfo();
//		}, data);
//	}
//
//    if(mobileSystem == "ios" && iosOnlinePayBack){
//    	iosOnlinePayBack = false;
//    	$scope.onlinePaySuccess(window.localStorage.getItem("iosOnlinePay"));
//    }

}]);
