app.controller('orderListCtrl', ['$scope', 'orderService', '$ionicSlideBoxDelegate', 'paginationFactory', 'userLocationFactory', 'cartFactory', function($scope, orderService, $ionicSlideBoxDelegate, paginationFactory, userLocationFactory, cartFactory) {

    /**
     * 用户手机号
     * @type {api.user.phone|*}
     */
    $scope.userMobile = userLocationFactory.user().phone;
    /**
     * 当前订单
     * @type {Array}
     */
    $scope.currentOrderListMap = [];
    /**
     * 历史订单
     * @type {Array}
     */
    $scope.historyOrderListMap = [];
    /**
     * 当前订单页数
     * @type {number}
     */
    $scope.curretnPage = 1;
    /**
     * 历史订单页数
     * @type {number}
     */
    $scope.historyPage = 1;
    /**
     * 当前订单滚动加载禁止   ture:禁止 false:允许
     * @type {boolean}
     */
    $scope.currentEnd = false;
    /**
     * 历史订单滚动加载禁止   ture:禁止 false:允许
     * @type {boolean}
     */
    $scope.historyEnd = false;

    /**
     * 当前订单是否有数据
     */
    $scope.noCurrentOrder = false;
    /**
     * 历史订单是否有数据
     */
    $scope.noHistoryOrder = false;

    /**
     * 每次加载订单长度
     * @type {number}
     */
    $scope.orderListLength = 10;
    /**
     * 评价使用数据
     * @type {{shopBrandInfo: {shopBrandGoodsList: {goodsId: null, goodsName: string}[], shopBrandName: string, shopBrandId: string}[], orderId: number}}
     */
    $scope.evaluateData = {
        "shopBrandInfo": [{
            "shopBrandGoodsList": [

            ],
            "shopBrandName": "河北鑫丰粮油物流有限公司",
            "shopBrandId": "182"
        }, {
            "shopBrandGoodsList": [{
                "goodsId": "10936",
                "goodsName": "出塞曲精装蒙古奶条酸奶味100g(100g)"
            }],
            "shopBrandName": "保定市程意商贸有限公司",
            "shopBrandId": "183"
        }]
    };
    $scope.currentScrool = true;
    $scope.historyScrool = true;

    //    var currentOrder = {
    //        "orderAddTime": "2015-05-15 20:25:41",  //订单创建时间
    //        "orderMoney": 12,                       //订单金额
    //        "goodsName": "脆脆鸡+章鱼小丸子",       //订单商品组名
    //        "goodsImg": "http://222 .222.181.238:8189/img/shopBrand/2015/04/06/C48DAC3DC65812FA1645BEE50B45BD78_small.jpg", //第一个商品的图片
    //        "orderStatusShow": true,                //订单状态显示   true:显示 false:隐藏
    //        "orderStatusText": "收货完成2",         //订单状态显示文本内容
    //        "buyerStatusShow": true,                //采购状态显示   true:显示 false:隐藏
    //        "buyerStatusText": "再次购买2",         //采购状态显示文本内容
    //        "evaluateStatusShow": true,             //评价状态显示   true:显示 false:隐藏
    //        "evaluateStatusText": "写评价2"         //评价状态显示文本内容
    //        "evaluateStatusImg": true               //评价图片显示控制 true:显示 false:隐藏
    //        "orderOperation": 1                     //订单操作 1：再次购买 2：再次支付  3：取消订单 4:确认收货
    //    };

    /**
     * 将接口返回的数据处理成页面需要的格式
     * @param orderArray
     * @param orderType
     * @returns {{}}
     */
    $scope.dataProcessing = function(orderArray, orderType) {
        var data = [];
        angular.forEach(orderArray, function(orderList) {
            var order = {};
            if (existObj(orderList.goodsInfo)) {
                order.orderAddTime = orderList.orderAddTime;
                order.orderId = orderList.orderId;
                order.orderAddress = orderList.orderAddress;
                order.orderNum = orderList.orderNum;
                order.orderMoney = orderList.orderCost.orderprice.amountPayable;
                order.goodsName = orderList.goodsInfo.goodsName;
                order.goodsImg = "http://" + orderList.goodsInfo.goodsImgs[0];

                order.shopBrandInfo = orderList.shopBrandInfo;
                order.orderLogisticsInfo = orderList.orderLogisticsInfo;

                order.orderOperation = 1;
                if (orderType = "current") {
                    order.orderStatusShow = true;
                    order.orderStatusText = "收货完成";
                    order.buyerStatusShow = true;
                    order.buyerStatusText = "再次购买";
                    order.evaluateStatusShow = false;
                    order.evaluateStatusImg = true;
                    order.evaluateStatusText = "写评价2";
                } else if (orderType = "history") {
                    order.buyerStatusShow = true;
                    order.buyerStatusText = "再次购买";
                    order.evaluateStatusShow = true;
                    order.evaluateStatusImg = true;
                    order.evaluateStatusText = "写评价";
                }
                order = $scope.orderStatusJudge(orderList, order);
                data.push(order);
            }
        });
        return data;
    };


    /**
     * 订单状态判断
     * @param orderInfo
     * @param order
     * @returns {*}
     */
    $scope.orderStatusJudge = function(orderInfo, order) {
        //        {0:"正在确认",1:"订单确认",2:"采购完成",3:"已发货",4:"确认收货(完成)",5:"已评论",7:"已取消订单"}
        switch (orderInfo.orderStatus) {
            case 0:
                order.orderStatusText = "正在确认中";
                break;
            case 1:
                order.orderStatusText = "订单确认";
                break;
            case 2:
                order.orderStatusText = "采购完成";
                break;
            case 3:
                order.orderStatusText = "已发货";
                break;
            case 4:
                order.orderStatusText = "确认收货";
                break;
            case 5:
                order.orderStatusText = "确认收货";
                break;
            case 7:
                order.orderStatusText = "已取消订单";
                order.buyerStatusShow = false;
                break;
            default:
                break;
        }

        if (orderInfo.orderStatus == 0 && orderInfo.orderPayInfo.payMethod == "货到付款") {
            order.orderStatusText = "正在确认";
            order.buyerStatusShow = true;
            order.buyerStatusText = "取消订单";
            order.orderOperation = 3;
        } else if (orderInfo.orderStatus < 2 && orderInfo.orderPayInfo.payMethod == "在线支付") {
            if (orderInfo.orderPayInfo.payStatus == 0) {
                order.orderStatusText = "未支付完成";
                order.buyerStatusShow = true;
                order.buyerStatusText = "再次支付";
                order.orderOperation = 2;
            } else if (orderInfo.orderPayInfo.payStatus == 1) {
                order.orderStatusText = "已支付成功";
            }
        }

        if (orderInfo.orderStatus == 3) {
            order.buyerStatusShow = true;
            order.buyerStatusText = "确认收货";
            order.orderOperation = 4;
        }
        if (orderInfo.orderStatus == 4) {
            order.evaluateStatusShow = true;
            order.evaluateStatusText = "写评价";
        }
        if (orderInfo.orderStatus == 5) {
            order.evaluateStatusShow = true;
            order.evaluateStatusText = "已评价";
        }

        if (orderInfo.orderCancelReason && orderInfo.orderStatus == 7) {
            order.buyerStatusShow = false;
            order.evaluateStatusShow = true;
            order.evaluateStatusImg = false;
            order.evaluateStatusText = "全部商品缺货";
        } else if (orderInfo.orderCancelReason && orderInfo.orderStatus != 7) {
            order.buyerStatusShow = false;
            order.orderStatusText = "部分商品缺货";
            order.evaluateStatusShow = false;
        }
        return order;
    };

    /**
     * 取消订单或者再次购买
     * @param orderOperation  订单操作 1：再次购买 2：再次支付  3：取消订单   4：确认收货
     * @param orderId
     * @param i               数组中的位置
     */
    $scope.buyerStatusClick = function(orderOperation, orderId, i) {
        if (orderOperation == 3) {
            var orderInfo3 = {
                orderId: orderId,
                orderStatus: 7
            };
            orderService.cancelOrder(function(msg) {
                if (msg == 1) {
                    $scope.currentOrderListMap[i].orderStatusText = "已取消订单";
                    $scope.currentOrderListMap[i].buyerStatusShow = false;
                } else {
                    $scope.showCancelOrderAlertWindow("取消订单失败，请联系荷粉客服。");
//                    alert("取消订单失败");
                }
            }, orderInfo3);
        } else if (orderOperation == 1) {
            var orderInfo1 = {
                orderId: orderId
            };
            orderService.againOrderGoodsInfo(function(data) {
                if (data.resultCode == "success") {
                    $scope.emptyCart(); //清空购物车
                    var goodsList = $scope.orderGoodsTurnCartGoods(data.resultTO);
                    for(var i=0; i<goodsList.length; i++){
                        var goods = goodsList[i];
                        cartFactory.addItem(goods);
                    }
                    $scope.$emit("changeCart");
                    $scope.toCart();
                }
                // if (msg.resultCode == "success") {
                //     $scope.emptyCart(); //清空购物车
                //     var goodsArray = [];
                //     for (var key in msg.resultTO) {
                //         goodsArray = goodsArray.concat(msg.resultTO[key].singleGoods);
                //     }
                //     for (var i = 0; i < goodsArray.length; i++) {
                //         $scope.againBuyGoods = $scope.orderGoodsTurnCartGoods(goodsArray[i]);
                //         cartFactory.addItem($scope.againBuyGoods);
                //     }
                //     $scope.$emit("changeCart");
                //     $scope.toCart();
                // }
            }, orderInfo1);
        } else if (orderOperation == 2) {
            //console.log("再次支付");
            var orderInfo2 = {
                orderId: orderId
            };
            orderService.againOrderGoodsInfo(function(msg) {
                if (msg.resultCode == "success") {
                    var orderAddress = $scope.currentOrderListMap[i].orderAddress;
                    var goodsName = "";
                    var goodsDescription = "";
                    var goodsArray = [];
                    for (var key in msg.resultTO) {
                        goodsArray = goodsArray.concat(msg.resultTO[key].singleGoods);
                    }
                    for (var j = 0; j < goodsArray.length; j++) {
                        if( j != 0 ) {
                            goodsName += "、";
                            goodsDescription += "、";
                        }
                        goodsName += goodsArray[j].goodsSpuName;
                        goodsDescription += goodsArray[j].goodsSpuName+"("+goodsArray[j].goodsSkuName+")X"+goodsArray[j].goodsNum
                    }

                    var onlinePayObj = {
                        orderNum : $scope.currentOrderListMap[i].orderNum,
                        orderId : orderId,
                        goodsName : goodsName,
                        goodsDescription : goodsDescription,
                        price : $scope.currentOrderListMap[i].orderMoney,
                        orderAddress : orderAddress
                    };
                    $scope.toOnlinePay(onlinePayObj);
                }
            }, orderInfo2);
        } else if (orderOperation == 4) {
            var orderInfo4 = {
                orderId: orderId,
                orderStatus: 4
            };
            orderService.updateOrder(function(msg) {
                if (msg == 1) {
                    $scope.currentOrderListMap[i].orderStatusText = "确认订单";
                    $scope.currentOrderListMap[i].buyerStatusText = "再次购买";
                } else {
                    alert("确认订单失败");
                }
            }, orderInfo4);
        }
    };

    $scope.goOrderEvaluate = function(eText, eShopBrandInfo, orderLogisticsInfo, eOrderId) {
        if (eText == "写评价") {
            $scope.evaluateData["shopBrandInfo"] = eShopBrandInfo;
            for( var key in orderLogisticsInfo ) {
	            $scope.evaluateData["logisticsPerson"] = orderLogisticsInfo[key].split("_")[0];
            }
            $scope.evaluateData["orderId"] = eOrderId;
            var evaluateCacheInfo = new LocalStorageMap("evaluateInfo");
            evaluateCacheInfo.put("evaluateInfo", $scope.evaluateData);
            $scope.toOrderEvaluate();
        } else if (eText == "已评价") {

        }
    };


    /**
     * 加载当前订单
     */
    $scope.loadCurrentOrder = function() {
    	if( !$scope.currentScrool ) {
        	return;
        }
        $scope.currentScrool = false;
        orderService.getOrderListByUserMobile(function(currentOrderListMap) {
            var currentList = $scope.dataProcessing(currentOrderListMap, "current");
            $scope.currentOrderListMap = $scope.currentOrderListMap.concat(currentList);
            $scope.currentEnd = currentOrderListMap.length < $scope.orderListLength;
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.noCurrentOrder = $scope.curretnPage == 1 && currentList.length == 0;
            $scope.curretnPage++;
            $scope.currentScrool = true;
            $scope.hideLoading();
        }, "current", $scope.curretnPage, $scope.orderListLength, $scope.userMobile);
    };

    /**
     * 加载历史订单
     */
    $scope.loadHistoryOrder = function() {
    	if( !$scope.historyScrool ) {
        	return;
        }
        $scope.historyScrool = false;
        orderService.getOrderListByUserMobile(function(historyOrderListMap) {
            var historyList = $scope.dataProcessing(historyOrderListMap, "history");
            $scope.historyOrderListMap = $scope.historyOrderListMap.concat(historyList);
            $scope.historyEnd = historyOrderListMap.length < $scope.orderListLength;
            $scope.noHistoryOrder = $scope.historyPage == 1 && historyList.length == 0;
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.historyPage++;
            $scope.historyScrool = true;
        }, "history", $scope.historyPage, $scope.orderListLength, $scope.userMobile);
    };

    /**
     * 点击切换当前或历史订单
     * @param index 0:当前    1:历史
     */
    $scope.changeSlider = function(index) {
        $ionicSlideBoxDelegate.slide(index);
    };

    /**
     * 滑动切换当前或历史订单
     * @param index 0:当前    1:历史
     */
    $scope.slideHasChanged = function(index) {
        var menu = document.getElementsByName("slideNavMenu");
        var navOne = document.getElementById("slideNavOne");
        var navTwo = document.getElementById("slideNavTwo");
        var menuDom = angular.element(menu);
        var navOneDom = angular.element(navOne);
        var navTwoDom = angular.element(navTwo);
        menuDom.removeClass("slider-nav-on-changed");
        if (index == 0) {
            navOneDom.addClass("slider-nav-on-changed");
        } else {
            navTwoDom.addClass("slider-nav-on-changed");
        }
    };

    /**
     * 跳转订单详情
     */
    $scope.goOrderInfo = function(orderId) {
        $scope.toOrderInfo(orderId);
    };

    $scope.$on('order-list-init', function() {
        // console.log('订单列表 V1 初始化了');
        $scope.loadCurrentOrder();
        // $scope.loadHistoryOrder(); //调用当前订单列表之后会自动调用历史订单的调用，所以这里不用手动调用历史订单接口
    });

    /**
     * 初始化订单列表
     */
    //    $scope.initOrderList = function(){
    //        $scope.loadCurrentOrder();
    //        $scope.loadHistoryOrder();
    //    };
    //
    //    $scope.initOrderList();
}]);
