app.controller('productListCtrl', ['$scope', '$ionicScrollDelegate', '$timeout', 'goodsService', 'searchService','paginationFactory', 'sunNavFactory', 'userLocationFactory', function($scope, $ionicScrollDelegate, $timeout, goodsService, searchService, paginationFactory, sunNavFactory, userLocationFactory){
    $scope.goodsListMap = [];
    $scope.noGoods = false;  // 是不是有商品
    $scope.endData = false;  // 数据是否已加载完毕
    $scope.scrool = true;
    $scope.categoryFirstLevelId = parseInt(window.localStorage.getItem('categoryId')) || null;
    $scope.categorySecondLevelId = parseInt(window.localStorage.getItem('categorySecondLevelId')) || null;
    $scope.categoryThreeLevelId = parseInt(window.localStorage.getItem('categoryThreeLevelId')) || null;
    $scope.categoryName = '';
    $scope.sortId = 1;
    $scope.hfPosition = {lat: window.localStorage.getItem('userCommunityLat'), lon: window.localStorage.getItem('userCommunityLon')};

    $scope.getDataCount = 0;

    var page, searchPage;

    /**
     * 页面初始化
     */
    var init = function(){

        $scope.getDataCount++;
        $scope.goodsListMap = [];
        $scope.noGoods = false;  // 是不是有商品
        $scope.endData = false;  // 数据是否已加载完毕
        page = paginationFactory.init();
        searchPage = paginationFactory.init();
        if(mobileSystem=='ios'){
            $ionicScrollDelegate.$getByHandle('productScrollHandle').scrollTop();
        }
    };

    /**
     * 加载商品
     */
    var loadGoods = function(){
    	if( !$scope.scrool ) {
        	return;
        }
        $scope.scrool = false;
        var communityId = window.localStorage.getItem('userCommunityId');
        goodsService.queryGoodsSpuListByPageWithDistanceCommunityId(function(data){
            $scope.noGoods = page.getCurrentPage()==1 && data.length==0;
            $scope.endData = data.length < page.getPerPage();
            if(data && data.length) {
                $scope.goodsListMap = $scope.goodsListMap.concat(data);
            }

            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.scrool = true;
            $scope.hideLoading();
        }, $scope.categoryFirstLevelId, $scope.categorySecondLevelId, $scope.categoryThreeLevelId, $scope.sortId, page, communityId);
    };

    /**
     * 加载商品搜索结果
     */
    var loadSearchGoods = function(){
        var communityId = window.localStorage.getItem('userCommunityId');
        var term = window.localStorage.getItem('searchTerm');
        var searchListUseCategory = window.localStorage.getItem('searchListUseCategory');
        var mobile = userLocationFactory.user().phone;
        searchService.searchGoodsSpuListCommunityId(function(dataMap){
            var data = dataMap.searchList;
            $scope.endData = data.length < searchPage.getPerPage();
            $scope.noGoods = searchPage.getCurrentPage()==1 && data.length==0;


            if(data && data.length) {
                $scope.goodsListMap = $scope.goodsListMap.concat(data);
            }
            if(searchListUseCategory != 'true'){
                if(searchPage.getCurrentPage()==1){
                    sunNavFactory.loadCategoryForSearch(dataMap.goodsCategoryList);
                }
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.hideLoading();
        }, term, mobile, $scope.categoryFirstLevelId, $scope.categorySecondLevelId, $scope.categoryThreeLevelId, $scope.sortId, searchPage, communityId);
    };

    var loadData = function(){
        var status = window.localStorage.getItem('productListStatus');
        if( status == "product" ){
            loadGoods();
        }else{
            loadSearchGoods();
        }
    };

    /**
     * 上拉加载更多
     */
    $scope.loadMore = function() {
        if($scope.getDataCount>1){
            loadData();
        }else{
            $timeout(function(){
                loadData();
            }, 300);
        }
    };

    /**
     * 关闭遮罩
     */
    $scope.closeBackdrop = function(){
        sunNavFactory.closeBackdrop();
    };

    /**
     * 监听在商品列表页面时，点击搜索按钮发出的广播 searchGoodsInner，以加载商品
     */
    // $scope.$on('searchGoodsInner', function(){
    //     init();

    //     if(mobileSystem == 'android'){
    //         loadData();
    //     }
    // });

    /**
     * 监听排序改变时的处理方法
     */
    $scope.$on('loadProductBySort', function(){
        $scope.sortId = sunNavFactory.productSortId;
        init();
        var top = $ionicScrollDelegate.getScrollPosition().top;
        if(top == 0 && mobileSystem == 'android'){
            loadData();
        }
    });

    /**
     * 监听分类改变时的处理方法
     */
    $scope.$on('loadProductByCategory', function(){
        window.localStorage.setItem('searchListUseCategory', true);
        $scope.categoryFirstLevelId = sunNavFactory.categoryFirstId;
        $scope.categorySecondLevelId = sunNavFactory.categoryPId;
        $scope.categoryThreeLevelId = sunNavFactory.categoryId;
        init();
        var top = $ionicScrollDelegate.getScrollPosition().top;
        if(top == 0 && mobileSystem == 'android'){
            loadData();
        }
    });

    $scope.$on('product-list-init', function(){
        $scope.categoryName = window.localStorage.getItem('categoryName')||'商品列表';
        var status = window.localStorage.getItem('productListStatus');
        if(status == 'search') {
            $scope.categoryName = '搜索';
        }
        $scope.showLoading('loading.html');
        init();
        if(mobileSystem == 'android'){
            loadData();
        }
    });

}]);
