app.controller('customProductListCtrl', ['$scope', '$ionicScrollDelegate', '$timeout', 'goodsService', 'searchService','paginationFactory', 'sunNavFactory', 'userLocationFactory', function($scope, $ionicScrollDelegate, $timeout, goodsService, searchService, paginationFactory, sunNavFactory, userLocationFactory){
    $scope.goodsListMap = [];
    $scope.noGoods = false;  // 是不是有商品
    $scope.endData = false;  // 数据是否已加载完毕
    $scope.scrool = true;
    $scope.titleName = '';
    $scope.getDataCount = 0;

    var page;

    /**
     * 页面初始化
     */
    var init = function(){

        $scope.getDataCount++;
        $scope.goodsListMap = [];
        $scope.noGoods = false;  // 是不是有商品
        $scope.endData = false;  // 数据是否已加载完毕
        page = paginationFactory.init();

        if(mobileSystem=='ios'){
            $ionicScrollDelegate.$getByHandle('productScrollHandle').scrollTop();
        }
    };

    /**
     * 加载商品
     */
    var loadGoods = function(){
    	if( !$scope.scrool ) {
        	return;
        }
        $scope.scrool = false;
        var list = angular.fromJson(window.localStorage.getItem('customProductIdList'));
        goodsService.queryGoodsSpuListByCustom(function(data){
            // window.localStorage.removeItem('customProductIdList');
            $scope.noGoods = page.getCurrentPage()==1 && data.length==0;
            $scope.endData = data.length < page.getPerPage();
            if(data && data.length) {
                $scope.goodsListMap = $scope.goodsListMap.concat(data);
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.scrool = true;
            $scope.hideLoading();
        }, list, page);
    };

    /**
     * 上拉加载更多
     */
    $scope.loadMore = function() {
        if($scope.getDataCount>1){
            loadGoods();
        }else{
            $timeout(function(){
                loadGoods();
            }, 300);
        }
    };

    $scope.$on('product-list-custom-init', function(){
        $scope.titleName = window.localStorage.getItem('customProductName')||'商品列表';
        init();
        if(mobileSystem == 'android'){
            loadGoods();
        }
    });

}]);
