app.controller('registerCtrl', ['$scope', '$ionicPopup', '$timeout', '$state', 'userService', 'userLocationFactory', function($scope, $ionicPopup, $timeout, $state, userService, userLocationFactory){
    var KEY = 'regist';
    var initTimeoutNum = CURRENT_ENV == 'product' ? 120 : 20;
    $scope.registTip = (typeof registTip) === 'function' ? registTip() : ''; // 应用外网JS的变量
    $scope.registTipStyle = (typeof registTipStyle === 'function') ? registTipStyle() : ''; // 应用外网JS的变量
    $scope.user = {};
    $scope.registerStep = 1;
    $scope.registerError = true;
    $scope.registerErrorInfo = {};
    $scope.registerErrorCurrent = '';
    $scope.clockNum = initTimeoutNum;
    $scope.vcode = '';
    $scope.check = {
        checkMobile: checkMobile
    };
    $scope.checkClass = false;
    // $scope.canClickForMsgRegist = false;

    var timeBar;
    var stopTimeBar = function(){
        $timeout.cancel(timeBar);
        timeBar = null;
    };


    /**
     * 添加推荐人
     */
    $scope.addRecommender = function(form){
        $scope.checkClass = !$scope.checkClass;
        $scope.checkForm(form);
    };

    /**
     * 检查表单的每个字断是否符合要求
     * @param  {[type]} form [description]
     * @return {[type]}      [description]
     */
    $scope.checkForm = function(form){
        $scope.registerErrorInfo.userPhoneRequired = !$scope.user.userPhone;
        $scope.registerErrorInfo.userPhonePattern = !$scope.check.checkMobile.test($scope.user.userPhone);
        $scope.registerErrorInfo.userPasswordRequired = !$scope.user.userPassword;
        $scope.registerErrorInfo.userPasswordMinlength = $scope.user.userPassword ? $scope.user.userPassword.length < 6 : false;
        $scope.registerErrorInfo.userRecommenderRequired = $scope.checkClass ? !$scope.user.userRecommender : false;
        $scope.registerErrorInfo.userRecommenderPattern = $scope.checkClass ? !$scope.check.checkMobile.test($scope.user.userRecommender) : false;
        $scope.validForm();
    };

    /**
     * 检查表单是否可以提交
     * @return {[type]} [description]
     */
    $scope.validForm = function(){
        var result = true;
        for(f in $scope.registerErrorInfo){
            var v = $scope.registerErrorInfo[f];
            result = result && !v;
        }
        $scope.registerError = !result;
    };

    /**
     * 获取验证码
     */
    $scope.getQrcode = function(form){
        // $scope.changBtnDisable();

        if(!$scope.registerError){
            // $scope.registerError = false;
            $scope.showConfirmQrcode();
        }else{
            // $scope.registerError = true;
        }
    };

    /**
     * 获取验证码
     */
    $scope.getQrcodeByCount = function(form){
        var count = userLocationFactory.readVerCodeCount();
        userLocationFactory.writeVerCodeCount(count+1);
        $scope.getQrcode(form);
    };

    /**
     * 显示验证码弹出框
     */
    $scope.showConfirmQrcode = function() {
        var phone = $scope.user.userPhone;
        var phone_str = phone.slice(0,3) + ' ' + phone.slice(3,7) + ' ' + phone.slice(7,11);
        var confirmPopup = $ionicPopup.confirm({
            template: '我们将发送短信验证码至：<div class="tip">'+phone_str+'</div>',
            cssClass: 'hf-popup-login',
            cancelText: '取消',
            okText: '确认',
            okType: 'button-assertive',
        });
        confirmPopup.then(function(res) {
            if(res) {
                // $scope.canClickForMsgRegist = false;
                $scope.registerStep = 2;
                // $scope.clockMinus();
                $scope.sendQrcode();
            } else {
                //console.log('You are not sure '+phone);
            }
        });
    };

    /**
     * 发送验证码
     */
    $scope.sendQrcode = function(){

        var mobile = $scope.user.userPhone;
        var count = userLocationFactory.readVerCodeCount();
        userService.sendVerCode(function(data){
            if(data >= 0){
                var seconds = data;
                if(data==0){
                    seconds = initTimeoutNum;
                }
                $scope.clockNum = seconds;
                $scope.clockMinus();
            }else{
                $ionicPopup.alert({
                    title: '提示信息',
                    template: '验证码发送失败',
                    buttons: [{
                        text: '确定',
                        type: 'button-assertive'
                    }]
                });
                $scope.clockNum = initTimeoutNum;
                $scope.clockMinus();
            }
        }, mobile, count, KEY);
    };

    /**
     * 倒计时
     */
    $scope.clockMinus = function(){
        $scope.clockNum--;
        timeBar = $timeout(function(){
            if($scope.clockNum == 0){
                // $scope.canClickForMsgRegist = true;
                stopTimeBar();
            }else{
                $scope.clockMinus();
            }
        }, 1000);
    };

    /**
     * 注册
     */
    $scope.doRegister = function(){
        $scope.showLoading('loading.html');

        var mobile = $scope.user.userPhone;
        var vcode = $scope.user.userQrcode;
        userService.checkVerCode(function(data){
            // console.log(data);
            if(data && data.resultCode == 1){
                userService.addUser(function(data){
                    if(data.status == 5){
                        userLocationFactory.login($scope.user.userPhone);
                        var url = window.localStorage.getItem('backUrl');
                        if(!url){
                            url = 'home';
                        }
                        $state.go(url);
                    }else{
                        $scope.registerError = true;
                        $scope.registerErrorCurrent = data.msg;
                    }
                    $scope.hideLoading();
                }, $scope.user.userPhone||'', $scope.user.userPassword||'', $scope.user.userRecommender);
            }else{
                $ionicPopup.alert({
                    title: '提示信息',
                    template: data.resultMsg || '注册失败，请稍后重试！',
                    buttons: [{
                        text: '确定',
                        type: 'button-assertive'
                    }]
                }).then(function(res){
                    // $scope.toHome();
                });
            }
        }, mobile, vcode, KEY);
    };

    /**
     * 验证是否已存在用户
     */
    $scope.checkExist = function(form){
        if(!$scope.registerErrorInfo.userPhoneRequired && !$scope.registerErrorInfo.userPhonePattern){
            userService.checkMobileExist(function(data){
                $scope.registerErrorInfo.userPhoneExist = data > 0;
                $scope.checkForm(form);
            }, $scope.user.userPhone||'');
        }
    };

    /**
     * 隐藏错误
     */
    // $scope.hideError = function(){
    //     $scope.registerError = false;
    //     $scope.registerErrorInfo.userPhoneExist = false;
    // };

    // $scope.changBtnDisable = function(){
    //     $scope.canClickForMsgRegist = false;
    //     $timeout(function(){
    //         $scope.canClickForMsgRegist = true;
    //     }, 2000);
    // };

    $scope.$on('register-leave', function(){
        stopTimeBar();
    });

}]);