app.controller('searchCtrl', ['$scope', '$rootScope', '$timeout', '$ionicHistory', 'searchService', 'userLocationFactory', function($scope, $rootScope, $timeout, $ionicHistory, searchService, userLocationFactory){
    //$scope.hfPosition = $rootScope.hfPosition||{};
	$scope.searchByword.term = '';
    $scope.hfPosition = {lat: window.localStorage.getItem('userCommunityLat'), lon: window.localStorage.getItem('userCommunityLon')};
    $scope.hotSearch = [];  // 热门搜索词语列表
    $scope.historySearch = []; // 搜索历史列表
    $scope.hotAndHistoryLoading = true;
    $scope.hotEmpty = false;
    $scope.historyEmpty = false;
    $scope.searchShopList = []; // 输入关键字后的店铺列表
    $scope.searchGoodsList = []; // 输入关键字后的商品列表
    $scope.searchShopDataLoading = true;
    $scope.searchGoodsDataLoading = true;
    $scope.searchDataShopEmpty = false;
    $scope.searchDataGoodsEmpty = false;

    $scope.firstWordForSearch = '';



    /**
     * 获取热门搜索关键字 和 搜索历史
     */
    var loadData = function() {
        var phone = userLocationFactory.user().phone;
        var communityId = window.localStorage.getItem('userCommunityId');
        if(communityId){
            searchService.getHotWordsAndSearchHistoryCommunityId(function(data){
                $scope.hotAndHistoryLoading = false;
                $scope.hotEmpty = data.hotWords.length == 0;
                $scope.historyEmpty = data.searchHistory.length == 0;
                $scope.hotSearch = data.hotWords||[];
                $scope.historySearch = data.searchHistory||[];
                //$scope.setSearchFocus();
                $scope.hideLoading();
            }, phone, communityId);
        }
    };

    /**
     * 获取搜索的店铺列表
     */
    var loadShopInSearchPage = function(){
        var term = ($scope.searchByword.term || '').replace(checkSearchKey, '');
        var communityId = window.localStorage.getItem('userCommunityId');
        if(term != ''){
            var currentFirstWord = term[0] || '';
            if($scope.firstWordForSearch == currentFirstWord){
                // console.log('这里不加载第一个字母后的数据:', term, $scope.firstWordForSearch);
            }else{
                //console.log('第一个字母', term);
                initShop();
                $scope.firstWordForSearch = currentFirstWord;

                searchService.getPromptedShopBrandCommunityId(function(data){
                    //console.log('getPromptedShopBrand',data);
                    $scope.searchDataShopEmpty = data.length == 0;
                    $scope.searchShopDataLoading = false;
                    $scope.searchShopList = data||[];
                }, $scope.firstWordForSearch, communityId);
            }
        }
    };

    /**
     * 获取搜索的商品列表
     */
    var loadGoodsInSearchPage = function(){
        var term = $scope.searchByword.term || '';
        var communityId = window.localStorage.getItem('userCommunityId');
        if(term != ''){
            initGoods();
            searchService.getPromptedGoodsSpuCommunityId(function(data){
                //console.log('getPromptedGoodsSpu',data);
                $scope.searchDataGoodsEmpty = data.length == 0;
                $scope.searchGoodsDataLoading = false;
                $scope.searchGoodsList = data||[];
            }, term, communityId);
        }
    };

    /**
     * 获取搜索的店铺列表和商品列表
     * 2016-03-26 修改
     * 店铺搜索，如果输入词的第一个字符改变，则调用接口，否则，不调用接口
     * 商品搜索，输入词改变则调用接口
     * 将一些前置操作放在各自的处理方法中
     */
    var loadSearchGoodsAndShop = function(){
        loadShopInSearchPage();
        loadGoodsInSearchPage();
    };


    /**
     * 初始化方法
     */
    var init = function() {
        loadData();
        // if($scope.searchByword.term != ''){
        //    loadSearchGoodsAndShop();
        // }
    };

    /**
     * 初始化店铺
     * 店铺是否加载数据中、是否为空数据、店铺数据列表置为空
     */
    var initShop = function(){
        $scope.searchShopDataLoading = true;
        $scope.searchDataShopEmpty = false;
        $scope.searchShopList = [];
    };

    /**
     * 初始化商品
     * 商品是否加载数据中、是否为空数据、商品数据列表置为空
     */
    var initGoods = function(){
        $scope.searchGoodsDataLoading = true;
        $scope.searchDataGoodsEmpty = false;
        $scope.searchGoodsList = [];
    };

    var time1, time2;
    $scope.$on('loadByKeyInSearchPage', function(){
        time1 = (new Date).getTime();
        $timeout(function(){
            time2 = (new Date).getTime();
            if(time2 - time1 >= 500){
                loadSearchGoodsAndShop();
                //console.log('可以加载 !!');
            }else{
                //console.log('不能加载...');
            }
        }, 500);
    });

    $scope.$on('search-init', function(){
        init();
    });

}]);
