app.controller('shopListCtrl', ['$scope', '$rootScope', '$timeout', '$ionicScrollDelegate', 'shopBrandService', 'paginationFactory', 'sunNavFactory', function($scope, $rootScope, $timeout, $ionicScrollDelegate, shopBrandService, paginationFactory, sunNavFactory) {
    //$scope.hfPosition = $rootScope.hfPosition||{};
    $scope.noShops = false;
    $scope.scrool = true;
    $scope.hfPosition = {lat: window.localStorage.getItem('userCommunityLat'), lon: window.localStorage.getItem('userCommunityLon')};
    $scope.showPosition = !!$scope.hfPosition.lat;
    $scope.shopList = [];
    // $scope.sortId = !!$scope.hfPosition.lat ? "3" : "1";
    $scope.sortId = "1";


    $scope.categoryFirstLevelId = parseInt(window.localStorage.getItem('categoryId')) || null;
    $scope.categorySecondLevelId = parseInt(window.localStorage.getItem('categorySecondLevelId')) || null;
    $scope.categoryThreeLevelId = parseInt(window.localStorage.getItem('categoryThreeLevelId')) || null;
    $scope.categoryName = '';

    $scope.dataEnd = false;
    $scope.getDataCount = 0;

    var page;

    /**
     * 页面初始化
     */
    var init = function(){
        $scope.noShops = false;
        $scope.shopList = [];
        $scope.getDataCount++;
        $scope.dataEnd = false;
        page = paginationFactory.init();
        if(mobileSystem=='ios'){
            $ionicScrollDelegate.$getByHandle('shopScrollHandle').scrollTop();
        }
    };

    /**
     * 加载店铺
     */
    var loadShop = function(){
        if( !$scope.scrool ) {
        	return;
        }
        $scope.scrool = false;
        var communityId = window.localStorage.getItem('userCommunityId');
        shopBrandService.queryShopBrandListCommunity(function(data){
            $scope.noShops = page.getCurrentPage()==1 && data.length==0;
            if(data.length){
                $scope.shopList = $scope.shopList.concat(data);
            }
            $scope.dataEnd = data.length < page.getPerPage();
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.scrool = true;
            $scope.hideLoading();
        }, communityId, $scope.categoryFirstLevelId, $scope.categorySecondLevelId, $scope.categoryThreeLevelId, $scope.sortId, page);
    };

    /**
     * 上拉加载更多
     */
    $scope.loadMore = function() {
        if($scope.getDataCount > 1){
            loadShop();
        }else{
            $timeout(function(){
                loadShop();
            }, 300);
        }
    };

    /**
     * 关闭遮罩
     */
    $scope.closeBackdrop = function(){
        sunNavFactory.closeBackdrop();
    };

    /**
     * 监听排序改变时的处理方法
     */
    $scope.$on('loadShopBySort', function(){
        $scope.sortId = sunNavFactory.shopSortId;
        init();
        var top = $ionicScrollDelegate.getScrollPosition().top;
        if(top == 0 && mobileSystem == 'android'){
            loadShop();
        }
    });

    /**
     * 监听分类改变时的处理方法
     */
    $scope.$on('loadShopByCategory', function(){

        $scope.categoryFirstLevelId = sunNavFactory.categoryFirstId;
        $scope.categorySecondLevelId = sunNavFactory.categoryPId;
        $scope.categoryThreeLevelId = sunNavFactory.categoryId;
        init();
        var top = $ionicScrollDelegate.getScrollPosition().top;
        if(top == 0 && mobileSystem == 'android'){
            loadShop();
        }
    });

    $scope.$on('shop-list-init', function(){
        $scope.categoryName = window.localStorage.getItem('categoryName')||'店铺列表';
        $scope.showLoading('loading.html');
        init();
        if(mobileSystem == 'android'){
            loadShop();
        }
    });

}])



