app.controller('shopProductListCtrl', ['$scope', 'goodsService', '$ionicScrollDelegate', '$timeout', function($scope, goodsService, $ionicScrollDelegate, $timeout){

    $scope.goodsListMap = [];//页面数据
    $scope.sortNameMap = [];
    $scope.selectSortName = "";
    $scope.selectSortNameTwo = "";
    $scope.scrollSortChangeStatus = true;
    $scope.start = true;
    $scope.shopName = '';
    $scope.shopMessageContent = {"shopBrandImg":"img/logo.jpg"};

    $scope.shopMessage = function ( data ) {
        var startTime = "";
        var endTime = "";
        var activityContent = "";
        var activityArr = data.shopBrandPromotions;
        for( start in data.shopBrandHours ) {
            if( !startTime ){
                startTime = start;
            }
            endTime = data.shopBrandHours[start];
        }
        if( activityArr ){
            for( var i = 0; i < activityArr.length; i++ ) {
                if( !activityContent ){
                    activityContent += "<span>• " + activityArr[i].promotionName + "</span>";
                }else{
                    activityContent += "<span>&nbsp;&nbsp;&nbsp;• " + activityArr[i].promotionName + "</span>";
                }
            }
        }

        $scope.shopMessageContent.shopBrandHours = startTime + "-" + endTime;
        $scope.shopMessageContent.shopBrandAddress = data.shopBrandAddress;
        $scope.shopMessageContent.shopBrandPhone = data.shopBrandPhone;
        if( data.shopBrandImg[1] ){
            $scope.shopMessageContent.shopBrandImg = "http://" + data.shopBrandImg[1];
        }
        $scope.shopMessageContent.shopBrandPromotions = activityContent;

    };

    /**
     * 加载页面
     */
    $scope.loadGoods = function(){
    	var communityId = parseInt(window.localStorage.getItem('userCommunityId'));
        var shopName = window.localStorage.getItem('shopProductList');
        goodsService.queryShopGoodsListByCommunityId(function(data){
            $scope.goodsListMap = data.goods;
            //$scope.shopMessage(data.shop);
            $timeout(function(){
                $scope.hideLoading();
            }, 400);
        }, shopName, communityId);
    };

    /**
     * 改变左侧导航栏选中项
     * @param name 选中名字
     */
    $scope.navChoiced = function(name){
        var navList = document.getElementsByName("navList");
        var navSortName = document.getElementById("nav"+name);
        var navListDom = angular.element(navList);
        var domActive = angular.element(navSortName);
        navListDom.removeClass('shop-product-list-sortNameSelete');
        domActive.addClass('shop-product-list-sortNameSelete');
    };

    /**
     * 点击分类改变商品列表位置
     * @param sortName 分类名
     */
    $scope.choiceSortName = function( sortName ){
        $scope.scrollSortChangeStatus = false;
        var ele = document.getElementById(sortName);
        $ionicScrollDelegate.scrollTo(0,ele.offsetTop,true);
        if($scope.timeSwitch){
            $timeout.cancel($scope.timeSwitch);
        }
        $scope.timeSwitch = $timeout(function(){
            $scope.scrollSortChangeStatus = true;
        }, 300);
        $scope.navChoiced(sortName);
    };

    /**
     * 滚动商品列表改变分类
     */
    $scope.sortNameShow = function(){
        if( $scope.start ) {
            angular.forEach($scope.goodsListMap, function( value ) {
                var obj = {};
                var ele = document.getElementById(value.name);
                obj.name = value.name;
                obj.top = ele.offsetTop;
                $scope.sortNameMap.push(obj);
            });
            $scope.start = false;
        }
        if($scope.scrollSortChangeStatus){
            var currTop = $ionicScrollDelegate.getScrollPosition().top;
            angular.forEach($scope.sortNameMap, function( nameList ) {
                if( nameList.top-5 < currTop ){
                    $scope.selectSortName = nameList.name;
                }else if(currTop == 0){
                    $scope.selectSortName = $scope.sortNameMap[0].name;
                }
                if( $scope.selectSortName != $scope.selectSortNameTwo ) {
                    $scope.navChoiced($scope.selectSortName);
                    $scope.selectSortNameTwo = $scope.selectSortName;
                }
            });
        }
    };

    $scope.$on('shop-product-list-init', function(){
        $scope.shopName = window.localStorage.getItem('shopProductList')||'商品列表';
        $scope.showLoading('loading.html');
        $scope.loadGoods();
    });

  }]);
