app.controller('updateCommitCtrl', ['$scope', '$rootScope', '$timeout', '$interval', 'userService', 'searchService', 'userLocationFactory', 'shopIdListFactory', '$ionicPopup', function($scope, $rootScope, $timeout, $interval, userService, searchService, userLocationFactory, shopIdListFactory, $ionicPopup ){
    var stop;  // 间隔获取用户位置的handle
    $scope.keySearchCommunityEmpty = false;
    $scope.fistTerm = "";

    /**
     * 初始化页面
     */
    var init = function(){
        $scope.hideLoading();
        loadHistoryPositionData();
        $scope.checkPosition();
    };
    var createAddressUrlSource = window.localStorage.getItem('createAddressUrlSource');

    var shopIdList = [];
    if( createAddressUrlSource == "order-commit" ) shopIdList = shopIdListFactory.get("order_commit_shopIdList");
//    console.log("shopIdList222:"+JSON.stringify(shopIdList))

    /**
     * 加载输入搜索词后的小区列表
     * 如果定位不到，在希望用户触发此函数
     */
    var loadSearchPositionData = function(term, lat, lon){
    	$scope.keySearchCommunityEmpty = true;
        if(term != ''){
            searchService.queryCommunityList(function(data){
                //console.log('d1:', data);
                $scope.keySearchCommunityEmpty = false;
                $scope.fistTerm = term;
                $scope.communitySearchList = data;
                $scope.searchDataEmpty = data.length == 0;
            }, term, lat, lon, shopIdList );
        }
    };

    /**
     * 加载获取到用户定位之后的附近的小区列表
     */
    var loadSidePositionData = function(lat, lon){
    	if(ionic.Platform.isIOS()){
    		userService.queryPositionCommunity(function(dataMap){
                //console.log('d2:',dataMap);
                $scope.sideDataLoading = false;

                var communityList = dataMap.nearCommunityList;
                $scope.communitySideList = communityList;
                $scope.sideDataEmpty = communityList.length == 0;

                var firstCommunity = dataMap.locationCommunity;
                $scope.communityForUser = firstCommunity;
                $scope.communityForUserEmpty = Object.keys(firstCommunity).length == 0;


            }, lat, lon, shopIdList);
    	}else{
    		userService.queryBdPositionCommunity(function(dataMap){
                //console.log('d2:',dataMap);
                $scope.sideDataLoading = false;

                var communityList = dataMap.nearCommunityList;
                $scope.communitySideList = communityList;
                $scope.sideDataEmpty = communityList.length == 0;

                var firstCommunity = dataMap.locationCommunity;
                $scope.communityForUser = firstCommunity;
                $scope.communityForUserEmpty = Object.keys(firstCommunity).length == 0;


            }, lat, lon, shopIdList);
    	}
    };

    /**
     * 加载用户历史地址
     */
    var loadHistoryPositionData = function(){
        var mobile = userLocationFactory.user().phone.toString()||'';
        userService.queryUserCommunityHistory(function(data){
            //console.log('d3:',data);
            $scope.historyDataLoading = false;
            $scope.historyDataEmpty = data.length == 0;
            $scope.communityHistoryList = data;
        }, mobile, shopIdList);
    };

    $scope.position = {};    // 储存搜索关键字{term:京南一品}
    $scope.hfPosition = {};  // 获取的用户位置{lat:xxxx,lon:yyyy}

    $scope.communitySearchList = [];  // 用户输入关键字后的小区列表
    $scope.searchDataEmpty = false;   // 用户输入关键字后的小区列表是否为空
    $scope.communityForUser = {};     // 用户定位小区
    $scope.communityForUserEmpty = false; // 用户定位小区是否为空
    $scope.communitySideList = [];  // 用户定位附近的小区列表
    $scope.sideDataLoading = true;  // 用户定位附近的小区列表是否正在加载
    $scope.sideDataEmpty = false;   // 用户定位附近的小区列表是否为空
    $scope.communityHistoryList = [];  // 用户使用过的小区列表
    $scope.historyDataLoading = true;  // 用户使用过的小区列表是否正在加载
    $scope.historyDataEmpty = false;   // 用户使用过的小区列表是否为空
    $scope.communityChoiceId = window.localStorage.getItem('userCommunityId')||'';
    /**
     * 第一版，只判断是不是IOS
     */
    //$scope.showPositionContent = !(mobileSystem == 'ios' && $scope.communityChoiceId == '');

    $scope.showPositionContent = $rootScope.hfPosition && $rootScope.hfPosition.errorCode != 1;
    $scope.showContent = function(){
        $scope.showPositionContent = true;
    };
    $scope.clearHistory = function(){
        $scope.communityHistoryList = [];
    };

    $scope.checkPosition = function(){
        if ( angular.isDefined(stop) ) {
            return false;
        }

        stop = $interval(function() {
            if($scope.hfPosition.lat){
                loadSidePositionData($scope.hfPosition.lat, $scope.hfPosition.lon);
                $scope.stopCheck();
            }else{
                $scope.hfPosition = $rootScope.hfPosition||{};
            }
        }, 600);
    };

    $scope.stopCheck = function() {
        if (angular.isDefined(stop)) {
            $interval.cancel(stop);
            stop = undefined;
        }
    };

    var time1, time2;
    $scope.loadCommunityList = function(){
        if(!$scope.position.term){
            $scope.communitySearchList = [];
            $scope.searchDataEmpty = false;
            $scope.fistTerm = "";
        }
        time1 = (new Date).getTime();
        $timeout(function(){
            time2 = (new Date).getTime();
            if(time2 - time1 >= 500  && !$scope.fistTerm){
                loadSearchPositionData($scope.position.term, $scope.hfPosition.lat, $scope.hfPosition.lon);
                //console.log('可以加载 !!', $scope.position.term);
            }else{
                //console.log('不能加载...');
            }
        }, 500);

    };

    $scope.choiceCommunity = function(community){
//    	community.isClearShopCat = 0;
//    	alert("community:"+JSON.stringify(community));
    	if( community.isClearShopCat == 0 ) {
    		$scope.showConfirmEmptyCart(community);
    		return;
    	}
//    	console.log("community:"+JSON.stringify(community));
//    	console.log("communityHistoryList:"+JSON.stringify($scope.communityHistoryList));
    	var communityHistory = false;
    	for( var i=0;i<$scope.communityHistoryList.length;i++ ){
    		if($scope.communityHistoryList[i].communityName == community.communityName) {
    			communityHistory = true;
    		}
    	}

//    	var updateCommunityUrlSource = window.localStorage.getItem('updateCommunityUrlSource');

        if( communityHistory && createAddressUrlSource == "order-commit" ) {
        	var pos = community.communityLongitudeLatitude || {};
        	window.localStorage.setItem('userCommunityId', community.communityId);
        	window.localStorage.setItem('userCommunityName', community.communityName);
        	window.localStorage.setItem('userCommunityLat', pos.latitude||0);
        	window.localStorage.setItem('userCommunityLon', pos.longitude||0);
        	$scope.userCommunity.communityId = community.communityId;
        	$scope.userCommunity.communityName = community.communityName;
        	$scope.toOrderCommit();
        } else {
        	window.localStorage.setItem('updateCommunityCommunityName', community.communityName);
        	window.localStorage.setItem('updateCommunityCommunityId', community.communityId);
	        $scope.toCreateAddress(createAddressUrlSource);
        }


    };

    $scope.showConfirmEmptyCart = function(community) {
        var confirmPopup = $ionicPopup.confirm({
            title: '<strong>提示</strong>',
            template: '地址变更会超出配送范围，如确认，请重新选择商品。',
            okText: '取消',
            okType: 'button-default',
            cancelText: '确认',
            cancelType: 'button-positive'
        });
        confirmPopup.then(function(res) {
            if (res) {
            } else {
            	var pos = community.communityLongitudeLatitude || {};
            	window.localStorage.setItem('userCommunityId', community.communityId);
            	window.localStorage.setItem('userCommunityName', community.communityName);
            	window.localStorage.setItem('userCommunityLat', pos.latitude||0);
            	window.localStorage.setItem('userCommunityLon', pos.longitude||0);
            	$scope.emptyCart();
        		$scope.toHome();
            }
        });
    };


    $scope.$on('$destroy', function() {
        $scope.stopCheck();
    });

    $scope.$on('update-community-init', function(){
        init();
    });

}]);
