app.controller('userCenterCtrl', ['$scope', '$state','orderService', '$ionicPopup', 'userLocationFactory', function($scope, $state,orderService, $ionicPopup, userLocationFactory){
    var showConfirm = function() {
        var confirmPopup = $ionicPopup.confirm({
            title: '<strong>退出应用?</strong>',
            template: '你确定要退出应用吗?',
            okText: '退出',
            cancelText: '取消'
        });

        confirmPopup.then(function(res) {
            if (res) {
                ionic.Platform.exitApp();
            } else {
                // Don't close
            }
        });
    };
    $scope.userMobile = "";
    $scope.thisDevice = ionic.Platform.isAndroid();

    /**
     * 加载用户信息
     */
    $scope.loadUser = function(){
        var mobile = userLocationFactory.user().phone.toString();
        $scope.userMobile = mobile.substring(0,3) +"*****"+ mobile.substring(8,11);
    };
    /**
     * 订单状态数量
     */
     $scope.loadOrderNumber=function(){
        // var userMobile='18932682780';
        var userMobile = userLocationFactory.user().phone;
        orderService.queryOrderStatusCount(function(data){
            if (data.resultCode == 'success') {
                    $scope.waitDeliver = data.resultTO.waitDeliver ;
                    $scope.waitFetch = data.resultTO.waitFetch ;
                    $scope.waitEvaluate = data.resultTO.waitEvaluate ;
                    $scope.waitPay = data.resultTO.waitPay;
                }
        },userMobile);
     };
    /**
     * 退出登录
     */
    $scope.logout = function(){
        userLocationFactory.logout();
        window.localStorage.removeItem('backUrl');
        window.localStorage.removeItem('backUrlForScan');
        $state.go('login');
    };

    /**
     * 退出App
     */
    $scope.exitApp = function(){
        showConfirm();
    };


    $scope.goOrderListByStatus = function(status){
        window.localStorage.setItem('orderStatus', status);
        $scope.toOrderList();
    };

    $scope.$on('user-center-init', function() {
        $scope.loadUser();
        $scope.loadOrderNumber();
    });

}]);
