/**
 * 当前APP环境
 * app => 荷粉到家; school => 荷粉校园; appWX => 荷粉到家微信公共号; schoolWX => 荷粉校园微信公共号
 */
var appEnvironment = 'app';
// var appEnvironment = 'school';
/* 当前APP版本 */
var appVersion = 'android-3.0.17';
/* 手机系统 */
var mobileSystem = "";
/* 广告比例 高/宽 */
var percentAdvert = 450 / 1080;
var advertHeight = parseInt(percentAdvert * window.innerWidth);
var advertHeightSmall = parseInt(percentAdvert * window.innerWidth * 0.75);

var percentProduct = 510 / 600;
var productHeight = parseInt(percentProduct * window.innerWidth);
var weixinCode;
var appNameMap = {
    app: '荷粉到家',
    school: '荷粉校园'
};

/* 首页接口 Map，分类&商品 */
var homeColumnMap = {
    'app': 'homeColumnByCommunityId',
    'appWX': 'homeColumnByCommunityId',
    'school': 'homeColumnByCommunityIdForSchool',
    'schoolWX': 'homeColumnByCommunityIdForSchool'
};

/* 首页接口 Map，广告 */
var getAdvertMap = {
    'app': 'queryAdvertisementList',
    'appWX': 'queryAdvertisementList',
    'school': 'queryAdvertisementListForSchool',
    'schoolWX': 'queryAdvertisementListForSchool'
};

/* 搜索页面热门词和搜索历史 Map */
var hotWordsAndSearchHistoryMap = {
    'app': 'getHotWordsAndSearchHistoryCommunityId',
    'appWX': 'getHotWordsAndSearchHistoryCommunityId',
    'school': 'getHotWordsAndSearchHistoryCommunityIdForSchool',
    'schoolWX': 'getHotWordsAndSearchHistoryCommunityIdForSchool'
};

/* 搜索页接口 Map，商品提示词 */
var searchPromptSpuMap = {
    'app': 'getPromptedGoodsSpuCommunityId',
    'appWX': 'getPromptedGoodsSpuCommunityId',
    'school': 'getPromptedGoodsSpuCommunityIdForSchool',
    'schoolWX': 'getPromptedGoodsSpuCommunityIdForSchool'
};

/* 搜索页接口 Map，店铺提示词 */
var searchPromptShopBrandMap = {
    'app': 'getPromptedShopBrandCommunityId',
    'appWX': 'getPromptedShopBrandCommunityId',
    'school': 'getPromptedShopBrandCommunityIdForSchool',
    'schoolWX': 'getPromptedShopBrandCommunityIdForSchool'
};

/* 搜索结果，显示在商品列表 */
var searchSpuMap = {
    'app': 'searchGoodsSpuListCommunityId',
    'appWX': 'searchGoodsSpuListCommunityId',
    'school': 'searchGoodsSpuListCommunityIdForSchool',
    'schoolWX': 'searchGoodsSpuListCommunityIdForSchool'
};

/* 获取分类接口 */
var queryIndexCategoryMap = {
    'app': 'queryIndexCategory',
    'appWX': 'queryIndexCategory',
    'school': 'queryIndexCategoryForSchool',
    'schoolWX': 'queryIndexCategoryForSchool'
};


/* 添加用户地址接口  addUserAddress */
var addUserAddressMap = {
    'app': 'addUserAddress',
    'appWX': 'addUserAddress',
    'school': 'addUserAddressForSchool',
    'schoolWX': 'addUserAddressForSchool'
};
/* 修改用户地址接口  updateUserAddress */
var updateUserAddressMap = {
    'app': 'updateUserAddress',
    'appWX': 'updateUserAddress',
    'school': 'updateUserAddressForSchool',
    'schoolWX': 'updateUserAddressForSchool'
};
/* 获取用户地址列表接口 queryUserAddressByUserTable */
var queryUserAddressByUserTableMap = {
    'app': 'queryUserAddressByUserTable',
    'appWX': 'queryUserAddressByUserTable',
    'school': 'queryUserAddressByUserTableForSchool',
    'schoolWX': 'queryUserAddressByUserTableForSchool'
};
/* 修改用户默认地址接口 updateUserDefaultAddress */
var updateUserDefaultAddressMap = {
    'app': 'updateUserDefaultAddress',
    'appWX': 'updateUserDefaultAddress',
    'school': 'updateUserDefaultAddressForSchool',
    'schoolWX': 'updateUserDefaultAddressForSchool'
};

/* 删除用户地址接口 deleteUserAddressByAddressId */
var deleteUserAddressByAddressIdMap = {
    'app': 'deleteUserAddressByAddressId',
    'appWX': 'deleteUserAddressByAddressId',
    'school': 'deleteUserAddressByAddressIdForSchool',
    'schoolWX': 'deleteUserAddressByAddressIdForSchool'
};

/* 获取按用户位置附近的小区接口  queryPositionCommunity */
var queryPositionCommunityMap = {
    'app': 'queryPositionCommunity',
    'appWX': 'queryPositionCommunity',
    'school': 'queryPositionCommunityForSchool',
    'schoolWX': 'queryPositionCommunityForSchool'
};
/* 获取按用户位置百度坐标附近的小区接口  queryBdPositionCommunity */
var queryBdPositionCommunityMap = {
    'app': 'queryBdPositionCommunity',
    'appWX': 'queryBdPositionCommunity',
    'school': 'queryBdPositionCommunityForSchool',
    'schoolWX': 'queryBdPositionCommunityForSchool'
};
/* 获取用户小区历史记录。包含用户的收货地址和小区搜索历史接口  queryUserCommunityHistory */
var queryUserCommunityHistoryMap = {
    'app': 'queryUserCommunityHistory',
    'appWX': 'queryUserCommunityHistory',
    'school': 'queryUserCommunityHistoryForSchool',
    'schoolWX': 'queryUserCommunityHistoryForSchool'
};
/* 检索小区列表接口  queryCommunityList */
// var queryCommunityListMap = {
//     'app': 'queryCommunityList',
//     'appWX': 'queryCommunityList',
//     'school': 'queryCommunityListForSchool',
//     'schoolWX': 'queryCommunityListForSchool'
// };
var queryCommunityListMap = {
    'app': 'queryCommunityListNew',
    'appWX': 'queryCommunityListNew',
    'school': 'queryCommunityListForSchoolNew',
    'schoolWX': 'queryCommunityListForSchoolNew'
};



/* 修改地址页面  获取按用户位置附近的小区接口  getPositionCommunity */
var getPositionCommunityMap = {
    'app': 'getPositionCommunity',
    'appWX': 'getPositionCommunity',
    'school': 'getPositionCommunityForSchool',
    'schoolWX': 'getPositionCommunityForSchool'
};
/* 修改地址页面  获取按用户位置百度坐标附近的小区接口  getBdPositionCommunity */
var getBdPositionCommunityMap = {
    'app': 'getBdPositionCommunity',
    'appWX': 'getBdPositionCommunity',
    'school': 'getBdPositionCommunityForSchool',
    'schoolWX': 'getBdPositionCommunityForSchool'
};
/* 获取用户小区历史记录。包含用户的收货地址和小区搜索历史接口  getUserCommunityHistory */
var getUserCommunityHistoryMap = {
    'app': 'getUserCommunityHistory',
    'appWX': 'getUserCommunityHistory',
    'school': 'getUserCommunityHistoryForSchool',
    'schoolWX': 'getUserCommunityHistoryForSchool'
};
/* 修改地址页面  检索小区列表接口  searchCommunityList */
// var searchCommunityListMap = {
//     'app': 'searchCommunityList',
//     'appWX': 'searchCommunityList',
//     'school': 'searchCommunityListForSchool',
//     'schoolWX': 'searchCommunityListForSchool'
// };
var searchCommunityListMap = {
    'app': 'searchCommunityListNew',
    'appWX': 'searchCommunityListNew',
    'school': 'searchCommunityListForSchoolNew',
    'schoolWX': 'searchCommunityListForSchoolNew'
};

/* 订单提交下单接口  addOrderBack */
var addOrderBackMap = {
    'app': 'addOrderBack',
    'appWX': 'addOrderBack',
    'school': 'addOrderBackForSchool',
    'schoolWX': 'addOrderBackForSchool'
};

/* 促销活动数字与类型 enum 用于显示商品图片的小标 */
var promotionEnum = {
    '1': 'jiang',
    '2': 'cuxiao',
    '3': 'jian',
    '4': 'jian',
    '5': 'zeng',
    '6': 'zeng',
    '7': 'jian',
    '8': 'zeng'
};

/* 促销类型 */
var promotionTypeEnum = {
    '1': 'zhijiang',
    '2': 'zhekou',
    '3': 'danpin_manjian',
    '4': 'heji_manjian',
    '5': 'heji_manzeng',
    '6': 'danpin_manzeng',
    '7': 'mei_manjian',
    '8': 'mei_manzeng'
};

/* 促销类型中文提示 */
var promotionTypeCnEnum = {
    '1': '直降',
    '2': '折扣',
    '3': '满减',
    '4': '满减',
    '5': '满赠',
    '6': '满赠',
    '7': '每满减',
    '8': '每满赠'
};

/* 店铺列表排序 enum */
var shopSortEnum = {
    '1': 'running',
    '2': 'comment',
    '3': 'sale'
};

/**
 * 登录结果错误信息状态吗 enum
 * 账号或密码为空：1，此用户不存在：2，密码错误：3，登陆成功：4
 */

var loginEnum = {
    '1': 'blankError',
    '2': 'notExistError',
    '3': 'passwordError',
    '4': 'loginSuccess'
};

/**
 * 注册结果错误信息状态码 enum
 * 用户电话或密码为空：1，用户已存在：2，推荐人电话错误或未注册 ：3， 添加失败：4， 添加成功：5
 */

var registerEnum = {
    '1': 'blankError',
    '2': 'existError',
    '3': 'recommenderError',
    '4': 'addError',
    '5': 'addSuccess'
};

/**
 * 广告跳转页面数字与类型转化
 */
var advertEnum = {
    '1': 'shop',
    '2': 'category',
    '3': 'area',
    '4': 'goods'
};

/* 购物车最大数量 */
var CART_MAX_LENGTH = 20;

/* 自营店铺Id */
var SELF_SHOP_ID = '0';
var SELF_SHOP_NAME = '荷粉自营';

/** 校园版默认校区 **/
var APP_SCHOOL_DEFAULT_COMMUNITY_ID = 630;
var APP_SCHOOL_DEFAULT_COMMUNITY_NAME = '河北农大西校区';
/**
 * 调用接口时，如果超时，是否记录地址url, 用于 MQ 调用
 * 默认为false，不做记录
 * 调用接口前，设置为true（表示记录错误页面url），如果此次接口调用没有超时，则在success里设置为false
 * 这样。起到的作用是，多次调用接口时，前几次调用不做记录，只在最后一次做处理
 */
var isRecordError = false;

/**
 * 商品信息的验证规则
 * {shopId:{skuId:{num:商品是否可以售卖,promotions:[{promotionName:"",promotionType:"",priceReach:"",priceDown:"",discount:""}]}}}
 * @example {}
 */
var GOODS_PROMOTION_RULE = {};

/* 定义验证手机号的正则 */
var checkMobile = /^1[3|4|5|7|8]\d{9}$/;
/* 定义验证密码的正则 */
var checkPassword = /^[A-Za-z0-9]{6,15}$/;
/* 定义检测价格正则表达式(整数或者小数点后面2位数) */
var checkPrice = /^[0-9]+(.[0-9]{2}|.[0-9]{1})?$/;

var checkValue = /[\.\ ]/g;
/* 定义邮箱验证的正则 */
var checkEmail = /w+([-+.]w+)*@w+([-.]w+)*.w+([-.]w+)*/;
//验证输入特殊符号
var checkEnterTextAll = /[\`\~\!\@\#\$\%\^\&\*\(\)\[\]\{\}\=\+\ \,\.\/\;\'\\\<\>\?\:\"\|]/;
//用户地址特殊符号验证
var checkEnterTextAllTwo = /[\`\$\%\^\&\*\{\}\=\/\'\\\<\>\"]/;
//验证关键词禁止输入特殊符号 允许空格
var checkWorkText = /[\`\~\!\@\#\$\%\^\&\*\(\)\[\]\{\}\=\-\+\_\,\.\/\;\'\\\<\>\?\:\"\|]/;
//检测数字
var checkNumber = /^[0-9]*$/;
//检测条形码
var checkCode = /^[0-9a-zA-Z]*$/;
//验证时间正则表达式
var checkTime = /(^([0-1][0-9]|[2][0-3]):([0-5][0-9])$)|(^(([0-1][0-9]|[2][0-3]):([0-5][0-9]))-(([0-1][0-9]|[2][0-3]):([0-5][0-9]))$)/;
//验证中文，数字，字母
var checkSearchKey = /[^\d\w\u4E00-\u9FA5]/g;

/**
 * 关于页面Header，有三种：首页Header、登录注册页面Header、其他内页Header
 * 如果当前页面url在showIndexHeaderUrl列表中，显示首页Header
 * 如果当前页面url在showLoginHeaderUrl列表中，显示登录注册页面Header
 * 其他情况，显示其他内页Header
 */
/**
 * 显示首页Header的页面
 */
// var showIndexHeaderUrl = [
//     '/home',
//     '/user-center'
// ];

/**
 * 隐藏头部
 */
var hideAllHeaderUrl = [
    '/find-community',
    '/home',
    '/search',
    '/pay-online'
];

/**
 * 显示登录Header的页面
 */
// var showLoginHeaderUrl = [
//     '/login',
//     '/register'
// ];


/* 隐藏底工具栏的页面 */
var hideBarFooterUrl = [
    '/cart',
    '/order-commit',
    '/order-commit-v2',
    '/address-message',
    '/create-address',
    '/find-community',
    '/order-info',
    '/position-list',
    '/contact-list'
];

/* 需要登录验证的页面 */
var checkLoginUrl = [
    '/user-center',
    '/order-list',
    '/order-commit',
    '/order-list-v2',
    '/order-commit-v2'
];

/*需要显示Loading弹窗的页面*/
var showLoadingUrl = [
    '/home',
    '/cart',
    '/shop-list',
    '/shop-details',
    '/product-list',
    '/product-details',
    '/shop-product-list',
    '/classification',
    '/order-list',
    '/order-info',
    '/search',
    '/position-list'
];

// 微信
var wechatAppId = 'wx59d7cae50d1731c2'; //荷粉到家
var wechatAppSecret = '8e2285f11a521f3097dfe948ef7c301b'; //荷粉到家
var wechatAppAccessToken = 'HsU07rmqzWdI2hyB388GG-NsG3F0FIzzH440ezUVg9j_1JNBDtn9StMNqhDQjfNBTLUPOB-ydD85IajtxGO3EQzjf0xw55SQs_wxH4xx41UwZ3_Wq1NRIFhV3Me5MaTCMPUaAIAEHM';
var wechatAppTicket = 'sM4AOVdWfPE4DxkXGEs8VHxD8wVMC23WrRurtMuGTLe2A7xYHTKtfLEQZW-fBZ5XUc2wtqA54jITxFf1cTaotw';
