/**
*   本地存储map对象
*   demo:
*   var lm = new LocalStorageMap("shopingcart");
*   //数据写入
*   lm.put("店铺名",[商品id:{商品对象信息}])；
*   //数据读取操作
*   var goodes = lm.get("店铺名")；
*   //添加一个新商品到该店铺
*   var goods ＝ {goodsId:1,goodsName:'驴火一枚'......}
*   goodes[goodes.length] = goods;
*   lm.put("店铺名"， goodes);
*
*   //遍历操作
*
*   var shopNames = lm.getKeys();
*
*   for(var shopName in shopNames) {
*       var goodes = lm.get(shopName);
*       for( var index in goodes ) {
*           var goodsObj = goodes[index];
*           ......
*           .....
*       }
*
*/
var LocalStorageMap = function(name) {
    if(!window.localStorage) {
        alert("该浏览器不支持本地存储");
    } else {
        this.suffix = "987,75~&";
        this.divide = "_";
        this.keyLineReplace = "<->";
        this.name = name;
        this.keyName = name+"_keys";
        if( !localStorage.getItem(this.keyName) ){
            window.localStorage.setItem(this.keyName,"");
        }

    }
};
/**
*   添加数据
*/
LocalStorageMap.prototype.put = function( key, value ) {

    key = this.encodeKey(key);
    var keyStr = window.localStorage.getItem(this.keyName);
    if(!keyStr) keyStr = "";
    var isSaveed = false;
    isSaveed = keyStr.indexOf(this.divide+key+this.divide)>=0;
    if(!isSaveed){
        if(keyStr!="") keyStr += "0,";
        keyStr += this.divide+key+this.divide;
        window.localStorage.setItem( this.keyName, keyStr );
    }
    window.localStorage.setItem( this.name+this.divide+key, JSON.stringify( value ));
};
/**
*  返回数组所有的建
*/
LocalStorageMap.prototype.getKeys = function() {
    var nKeyArr = [];
    if(window.localStorage.getItem(this.keyName)) {
        var keyArr = window.localStorage.getItem(this.keyName).split("0,");
        for(var i=0; i<keyArr.length; i++) {
            //var key = keyArr[i];
            if(keyArr[i]) {
                nKeyArr[nKeyArr.length] = this.decodeKey(keyArr[i].replace(new RegExp(this.divide,"gm"),"").replace("0,").replace(","));
            }
        }
        if(nKeyArr.length==0) nKeyArr[0] = this.decodeKey(window.localStorage.getItem(this.keyName).replace(new RegExp(this.divide,"gm"),""));
    }
    return nKeyArr;
};
/**
 *
 * @param key
 */
LocalStorageMap.prototype.decodeKey = function( key ) {

    if( key.indexOf(this.keyLineReplace)>=0 ) {
        key = key.replace(new RegExp(this.keyLineReplace,"gm"), this.divide);
    }
    return key;
};

LocalStorageMap.prototype.encodeKey = function( key ) {
    if(!key && key.indexOf(this.divide)>=0 ) {
        key = key.replace(new RegExp(this.divide,"gm"), this.keyLineReplace);
    }
    return key;
};

/**
    获取数据
*/
LocalStorageMap.prototype.get = function(key) {
    key = this.encodeKey(key);
    var obj = JSON.parse(localStorage.getItem(this.name+this.divide+key));
    return obj;
}

/*LocalStorageMap.prototype.getItem = function(key) {

}*/
/**
    删除
*/
LocalStorageMap.prototype.remove = function(key) {
    key = this.encodeKey(key);
    var keyStr = window.localStorage.getItem( this.keyName );
    keyStr = keyStr.replace("0,"+this.divide+key+this.divide,"");
    keyStr = keyStr.replace(this.divide+key+this.divide,"");

    window.localStorage.removeItem(this.name+this.divide+key);
    window.localStorage.setItem(this.keyName, keyStr);
};