/**
 * MQDao Module
 *
 * 与MQ通信基类
 */

var isTimeoutMq = false;
var timeoutIdMq;
var HEFENPASSKEY = '0102030405060000';
var HEFENPASSPRE = 'cyc32_';
var mqenurl = [
    'addOrderBack',
    'addOrderBackForSchool'
];

angular.module('MQDao', [])
    .service("$mqDao", ['$mqDaoStack', "$app_config", "$http", '$state', '$timeout', '$q', function($mqDaoStack, $app_config, $http, $state, $timeout, $q) {

        return function(queue, methodName, dataObj, callBack, error) {
            var canceler = $q.defer();
            $mqDaoStack.push(queue, methodName, dataObj, callBack, error, canceler);

            var parseParam = function(method, data){
                var paramObj = {};
                paramObj.methodName = method;
                paramObj.data = data;
                return paramObj;
            };

            var getServerData = function(mqNext, mqData){
                $http({
                    url: $app_config.mqUrl,
                    method: "JSONP",
                    timeout: mqNext.canceler.promise,
                    params: {
                        queue: mqNext.queue,
                        jsonpcallback: "JSON_CALLBACK",
                        param: mqData
                    }
                })
                .success(function(data, status, headers, config){
                    // console.log('请求成功！！');
                    if(timeoutIdMq){
                        $timeout.cancel(timeoutIdMq);
                        timeoutIdMq = null;
                    }
                    $mqDaoStack.clear(mqNext);
                    mqNext.callBack(data.data, status, headers, config);
                    //$timeout(function(){
                        mqNextExec();
                    //}, 1*1000);
                })
                .error(function(data, status) {
                    // if (CURRENT_ENV != 'product') {
                    //     alert('请求失败！');
                    // }
                    /*** test code start ...  ***/
                    if(timeoutIdMq){
                        $timeout.cancel(timeoutIdMq);
                        timeoutIdMq = null;
                    }
                    if( isTimeoutMq ) {
                        if($state.current.name != 'error-page'){
                            window.localStorage.setItem('backUrlForError', $state.current.name);
                            $state.go('error-page');
                        }
                        isTimeoutMq = false;
                    }
                    // console.log('MQ 请求失败！');
                });
            };

            var mqNextExec = function(){
                var mqNext = $mqDaoStack.getNext();
                if(mqNext){
                    // console.log('请求接口：', mqNext.queue , mqNext.methodName, JSON.stringify(mqNext.dataObj));
                    // var d1 = hfEncrypt(params);
                    // console.log(d1);
                    // var d2 = hfDecrypt(d1);
                    // console.log(d2);
                    // return false;
                    var mqData = JSON.stringify(parseParam(mqNext.methodName, mqNext.dataObj));
                    var isEn;
                    if(typeof getEncUrl === 'function'){
                        isEn = getEncUrl();
                    }else{
                        isEn = true;
                    }

                    if(isEn && mqenurl.indexOf(mqNext.methodName) > -1){
                        mqData = HEFENPASSPRE + aesEncrypt(mqData, HEFENPASSKEY);
                    }

                    getServerData(mqNext, mqData);

                    if(timeoutIdMq){
                        $timeout.cancel(timeoutIdMq);
                        timeoutIdMq = null;
                    }

                    timeoutIdMq = $timeout(function() {
                        isTimeoutMq = true;
                        $mqDaoStack.clearAll();
                    },  12 * 1000);

                }
            };

            var conn = HefenConnection();
            if (conn) {
                var mqCurrent = $mqDaoStack.getCurrent();
                // console.log('当前MQ:',mqCurrent);
                if(!mqCurrent){
                    mqNextExec();
                }
            } else {
                //alert('您好！您的网络不给力，请摔碎手机！');
                if($state.current.name != 'error-page'){
                    window.localStorage.setItem('backUrlForError', $state.current.name);
                    $state.go('error-page');
                }
            }
        };
    }]);
