app.service('advertService', ['$mqDao', function($mqDao) {
    this.queueName = 'app_advertisement_service';
    /**
     * 注意，所有接口方法需要执行callback()方法，即使返回空数组[]空对象{}，因为要隐藏页面中的Loading弹窗
     */

    /**
     * 获取首页Banner广告
     */
    this.getAdvertByPosition = function(callback, position) {
        var positionMap = {
            index: 0,
            classification: 1
        };
        var params = {
            advertisement: {
                advertisementPosition: positionMap[position]
            }
        };
        var method = getAdvertMap[appEnvironment];
        $mqDao(this.queueName, method, params, function(data) {
            var result = [];
            if (data && data.length) {
                for (var i = 0; i < data.length; i++) {
                    var ad = data[i];
                    // ad.advertImg = parseImgUrlNew(ad.advertisementImg, 'medium');
                    ad.advertImg = parseImgUrlFromArray(ad.advertisementImg);
                    // console.log('广告', ad.advertisementId, ad.advertisementImg, ad.advertImg);
                    result.push(ad);
                };
            }
            callback(result);
        });
    };

    /**
     * 获取分类页面广告
     */
    this.queryCategoryAdvertisementList = function(callback) {
        var params = {};
        $mqDao(this.queueName, 'queryCategoryAdvertisementList', params, function(data) {
            callback(data);
        });
    }
}]);
