app.service('commentService', ['$mqDao', function($mqDao){
    this.queueName = 'app_comment_service';
    /**
     * 注意，所有接口方法需要执行callback()方法，即使返回空数组[]空对象{}，因为要隐藏页面中的Loading弹窗
     */

    /**
     * 获取评价信息
     * @param callback 回调函数
     */
    this.getCommentListByGoodsId = function(callback, goodsId, page) {
        var params = {
            comment: {
                searchKey: 'goodsSpuId',
                searchValue: goodsId.toString()
            },
            pageNum: page.getCurrentPage()
        };
        $mqDao(this.queueName, 'queryCommentList', params, function(msg) {
            var data = [];
            if(msg.resultCode=='success'){
                angular.forEach(msg.resultTO||[], function(item){
                    var starObj = arrayGetItemByKey(item.commentStarNum.shopBrandComment, 'goodsSpuId', goodsId);
                    item.customStarNum = starObj.shopBrandStarNum||0;
                    item.customMobile = item.commentUserMobile.substr(0,7)+'****';
                    data.push(item);
                });
            }
            callback(data);
            page.updateCurrentPage();
        });
    };

    /**
     * 给订单添加评论
     * @param callback
     * @param orderEvaluateInfo
     */
    this.addComment = function(callback, orderEvaluateInfo){
        var params = {
            comment: orderEvaluateInfo
        };
        $mqDao(this.queueName, 'addComment', params, function(msg) {
            callback(msg);
        });
    };

}]);
