app.service('couponService', ['$mqDao', function($mqDao) {
    this.queueName = 'app_coupon_service';
    /**
     * 注意，所有接口方法需要执行callback()方法，即使返回空数组[]空对象{}，因为要隐藏页面中的Loading弹窗
     */

    /**
     * 扫码
     * @param param 扫码结果
     * @param type 码类型
     */
    this.scanCode = function(callback, param, type) {
        var params = {
            param: param || '',
            type: type || ''
        };

        $mqDao(this.queueName, 'scanCode', params, function(msg) {
            var result = {};
            if (msg) {
                result = msg;
            }
            callback(result);
        });
    };

    this.scanCodeEncrypted = function(callback, param, type){
        var params = {
            param: param || '',
            type: type || ''
        };

        $mqDao(this.queueName, 'scanCodeEncrypted', params, function(msg) {
            var result = {};
            if (msg) {
                result = msg;
            }
            callback(result);
        });
    };

    this.addCoupon = function(callback, infoId, recommender, uuid, picker){
        var params = {
            couponInfoId: infoId,
            recommender: recommender,
            couponUUID: uuid,
            userMobile: picker
        };
        $mqDao(this.queueName, 'addCoupon', params, function(msg) {
            var result = {};
            if (msg) {
                result = msg;
            }
            callback(result);
        });
    };

    /**
     * 获取优惠券列表，全部
     * @param callback
     * @param phone 用户手机号
     * @param page 分页对象
     * {
            "valid": [{
            "couponBarcode": 0,
            "couponCreateTime": null,
            "couponEndTime": {
                "date": 10,
                "day": 3,
                "hours": 0,
                "minutes": 0,
                "month": 1,
                "seconds": 0,
                "time": 1455033600000,
                "timezoneOffset": -480,
                "year": 116
            },
            "couponEndTimeStr": "2016.02.10",
            "couponImg": "",
            "couponInfoId": 1481,
            "couponIsValid": 1,
            "couponLimitPrice": 1,
            "couponName": "10元代金券",
            "couponOverTime": 0,
            "couponPrice": 10,
            "couponRecordId": 6105,
            "couponRestrict": [],
            "couponRestrictType": 0,
            "couponStartTime": {
                "date": 26,
                "day": 2,
                "hours": 0,
                "minutes": 0,
                "month": 0,
                "seconds": 0,
                "time": 1453737600000,
                "timezoneOffset": -480,
                "year": 116
            },
            "couponStartTimeStr": "2016.01.26",
            "couponUpdateTime": null,
            "couponUsed": 0,
            "couponUserMobile": "13833012330"
        }],
            "invalid": []
        }
     * couponRestrictType ==>使用范围： 0无限制 1品类限制 2供货商限制 3单品spu限制
     * couponImg ==> 尺寸620*160
     */
    this.queryAllCouponListByUserMobile = function(callback, phone, page) {

        var params = {
            userMobile: phone
        };
        $mqDao(this.queueName, 'queryAllCouponListByUserMobile', params, function(msg) {
            var result = {};
            if (msg) {
                result = msg;
            }
            callback(result);
        });
    };

    this.queryCouponListInShoppingCar = function(callback, goodsInfo, userMobile) {
        var params = {
            goodsInfo: goodsInfo,
            userMobile: userMobile
        };
        $mqDao(this.queueName, 'queryCouponListInShoppingCar', params, function(msg) {
            var result = [];
            if (msg && msg.length) {
                result = msg;
            }
            callback(result);
        });
    };

    this.queryShopCouponListInShoppingCarNotCheckMoney = function(callback, goodsInfo, userMobile, shopId) {
        var params = {
            goodsInfo: goodsInfo,
            userMobile: userMobile,
            shopBrandId: shopId
        };
        $mqDao(this.queueName, 'queryShopCouponListInShoppingCarNotCheckMoney', params, function(msg) {
            var result = [];
            if (msg && msg.length) {
                result = msg;
            }
            callback(result);
        });
    };

    this.queryShopCouponNumInShoppingCarNotCheckMoney = function(callback, goodsInfo, userMobile) {
      var params = {
        goodsInfo: goodsInfo,
        userMobile: userMobile
      };
      $mqDao(this.queueName, 'queryShopCouponNumInShoppingCarNotCheckMoney', params, function(msg) {
        var result = {};
        if (msg) {
          result = msg;
        }
        callback(result);
      });
    };

}]);
