app.service('searchService', ['$mqDao', function($mqDao) {
    this.queueName = 'app_search_service';
    /**
     * 注意，所有接口方法需要执行callback()方法，即使返回空数组[]空对象{}，因为要隐藏页面中的Loading弹窗
     */

    /**
     * 获取商品搜索列表
     * @param callback 回调函数
     * @param keyword 关键词
     * @param mobile 用户手机号
     * @param categoryId 顶级分类Id
     * @param subCategoryId 二级分类Id
     * @param orderBy 排序方式 =>排序方式。1-默认 2-营业 4-热销 5-好评
     * @param page 分页对象
     */
    // this.searchGoodsSpuList = function(callback, keyword, mobile, categoryFirstId, categoryPId, categoryId, orderBy, page, lat, lon) {
    //     var searchListUseCategory = window.localStorage.getItem('searchListUseCategory');

    //     var params = {
    //         term: keyword,
    //         pageInfo: {pageNum:page.getCurrentPage()},
    //         userMobile: mobile,
    //         goodsSpu: {
    //             goodsSpuCategory: {
    //                 categoryFirstId: searchListUseCategory=='true' ? parseInt(categoryFirstId) : null,
    //                 categoryPId: searchListUseCategory=='true' ? parseInt(categoryPId) : null,
    //                 categoryId: searchListUseCategory=='true' ? parseInt(categoryId) : null
    //             },
    //             sort: orderBy.toString()
    //         },
    //         userLat: lat,
    //         userLon: lon
    //     };
    //     $mqDao(this.queueName, 'searchGoodsSpuList', params, function(msg) {
    //         var data = {};
    //         data['goodsCategoryList'] = [];
    //         data['searchList'] = [];
    //         if(msg.resultCode=='success'){
    //             var result = msg.resultTO;
    //             data['goodsCategoryList'] = result.goodsCategoryList||[];
    //             if(result.searchList && result.searchList.length){
    //                 angular.forEach(result.searchList, function(goods, i) {
    //                     var _goods = {};
    //                     _goods.goodsSpuShopBrandName = goods.goodsSpuShopBrandName;
    //                     _goods.goodsSpuId = goods.goodsSpuId;
    //                     _goods.goodsSpuName = goods.goodsSpuName;
    //                     _goods.imgUrl = parseImgUrlNew(goods.goodsSpuImgs, 'small');
    //                     _goods.goodsSort = goods.goodsSpuType == 1; //商品是否荷粉自营0-自营1-非自营，默认0
    //                     _goods.shopOff = goods.goodsSpuOnBusiness == 0; //商品是否营业0-未营业 1-营业，默认1
    //                     _goods.starNum = goods.goodsSpuCommentInfo.goodsStarNum;
    //                     _goods.promotionTypeKey = promotionTypeToKeyNew(goods.goodsSpuPromotionInfo||{});
    //                     _goods.TPrice = parseFloat(goods.goodsSpuPrice.promotionalPrice);
    //                     _goods.Price = parseFloat(goods.goodsSpuPrice.originalPrice);
    //                     _goods.commentNum = goods.goodsSpuCommentInfo.goodsCommentNum;
    //                     _goods.cartInfo = goods;
    //                     data['searchList'].push(_goods);
    //                 });
    //             }
    //         }
    //         callback(data);
    //         page.updateCurrentPage();
    //     });
    // };
    this.searchGoodsSpuListCommunityId = function(callback, keyword, mobile, categoryFirstId, categoryPId, categoryId, orderBy, page, communityId){
        var searchListUseCategory = window.localStorage.getItem('searchListUseCategory');

        var params = {
            term: keyword,
            pageInfo: {pageNum:page.getCurrentPage()},
            userMobile: mobile,
            goodsSpu: {
                goodsSpuCategory: {
                    categoryFirstId: searchListUseCategory=='true' ? parseInt(categoryFirstId) : null,
                    categoryPId: searchListUseCategory=='true' ? parseInt(categoryPId) : null,
                    categoryId: searchListUseCategory=='true' ? parseInt(categoryId) : null
                },
                sort: orderBy.toString()
            },
            communityId: parseInt(communityId) || 0
        };
        var method = searchSpuMap[appEnvironment];
        $mqDao(this.queueName, method, params, function(msg) {
            var data = {};
            data['goodsCategoryList'] = [];
            data['searchList'] = [];
            if(msg.resultCode=='success'){
                var result = msg.resultTO;
                data['goodsCategoryList'] = result.goodsCategoryList||[];
                if(result.searchList && result.searchList.length){
                    angular.forEach(result.searchList, function(goods, i) {
                        var _goods = {};
                        _goods.goodsSpuShopBrandName = goods.goodsSpuShopBrandName;
                        _goods.goodsSpuId = goods.goodsSpuId;
                        _goods.goodsSpuName = goods.goodsSpuName;
                        _goods.imgUrl = parseImgUrlNew(goods.goodsSpuImgs, 'small');
                        _goods.goodsSort = goods.goodsSpuType == 1; //商品是否荷粉自营0-自营1-非自营，默认0
                        _goods.hideShop = goods.hideShop; // 是否隐藏进店按钮
                        _goods.shopOff = goods.goodsSpuOnBusiness == 0; //商品是否营业0-未营业 1-营业，默认1
                        _goods.starNum = goods.goodsSpuCommentInfo.goodsStarNum;
                        _goods.promotionTypeKey = promotionTypeToKeyNew(goods.goodsSpuPromotionInfo||{});
                        _goods.TPrice = parseFloat(goods.goodsSpuPrice.promotionalPrice);
                        _goods.Price = parseFloat(goods.goodsSpuPrice.originalPrice);
                        _goods.commentNum = goods.goodsSpuCommentInfo.goodsCommentNum;
                        _goods.cartInfo = goods;
                        data['searchList'].push(_goods);
                    });
                }
            }
            callback(data);
            page.updateCurrentPage();
        });
    };

    /**
     * 热门搜索关键字 和 搜索历史
     * @param mobile 手机号
     */
    this.getHotWordsAndSearchHistory = function(callback, mobile){
        var params = {
            userMobile: mobile
        };
        // var data = {"hotWords":["上海生煎","云南白药","好好吃面","杨铭宇","白家罩饼","紫菜包饭","经典烧仙草","老吴家","肉夹馍","馅饼"],"searchHistory":["洗衣皂","黄酒","肥皂","心相印","婴儿纸"]};

        // callback(data);
        $mqDao(this.queueName, 'getHotWordsAndSearchHistory', params, function(msg) {
            var result = {};
            result.hotWords = [];
            result.searchHistory = [];
            if(msg){
                result.hotWords = msg.hotWords || [];
                result.searchHistory = msg.searchHistory || [];
            }
            callback(result);
        });
    };

    /**
     * 获取商品热词和搜索记录词。未输入检索词时调用此接口
     * @param userMobile 用户电话，默认空串
     * @param communityId 小区ID
     * @return 无结果时为空数组
     * {"hotWords":["上海生煎","云南白药","好好吃面","杨铭宇","白家罩饼","紫菜包饭","经典烧仙草","老吴家","肉夹馍","馅饼"],"searchHistory":["洗衣皂","黄酒","肥皂","心相印","婴儿纸"]}
     */
    // @IsMqFunction(paramNames={"userMobile=","communityId"})
    // Map<String,Object> getHotWordsAndSearchHistoryCommunityId(String userMobile,int communityId);

    this.getHotWordsAndSearchHistoryCommunityId = function(callback, mobile, communityId){
        var params = {
            userMobile: mobile,
            communityId: parseInt(communityId) || 0
        };
        // var data = {"hotWords":["上海生煎","云南白药","好好吃面","杨铭宇","白家罩饼","紫菜包饭","经典烧仙草","老吴家","肉夹馍","馅饼"],"searchHistory":["洗衣皂","黄酒","肥皂","心相印","婴儿纸"]};

        // callback(data);
        var method = hotWordsAndSearchHistoryMap[appEnvironment];
        $mqDao(this.queueName, method, params, function(msg) {
            var result = {};
            result.hotWords = [];
            result.searchHistory = [];
            if(msg){
                result.hotWords = msg.hotWords || [];
                result.searchHistory = msg.searchHistory || [];
            }
            callback(result);
        });
    };

    /**
     * 检索小区列表
     * @param keyword 搜索关键字，小区名称
     * @param lat 用户定位lat
     * @param lon 用户定位lon
     */
    this.searchCommunityList = function(callback, keyword, lat, lon){
        var params = {
            term: keyword||'',
            userLat: parseFloat(lat)||0,
            userLon: parseFloat(lon)||0
        };
        //searchCommunityList
        var method = searchCommunityListMap[appEnvironment];
        $mqDao(this.queueName, method, params, function(msg){
            var result = [];
            if(msg){
                result = msg;
            }
            callback(result);
        });
    };

    /**
     * 检索小区列表
     * @param keyword 搜索关键字，小区名称
     * @param lat 用户定位lat
     * @param lon 用户定位lon
     * @param shopIdList 店铺id列表
     */
    this.queryCommunityList = function(callback, keyword, lat, lon, shopIdList ){
    	var params = {
    			term: keyword||'',
    			userLat: parseFloat(lat)||0,
    			userLon: parseFloat(lon)||0,
    			shopIdList: shopIdList
    	};
    	//queryCommunityList
    	var method = queryCommunityListMap[appEnvironment];
    	$mqDao(this.queueName, method, params, function(msg){
    		var result = [];
    		if(msg){
    			result = msg;
    		}
    		callback(result);
    	});
    };

    /**
     * 检索提示词。提示供应商和商品
     * @param term 检索词，非空
     * @param userLon 用户位置，默认为0
     * @param userLat 用户位置，默认为0
     * @return 供应商按匹配度取前10后按距离取前5   商品按匹配度取前10
     * {"promptedGoodsSpuList":[{"goodsSpuName":"蒸蛋糕","goodsSpuOnBusiness":1,"goodsSpuPrice":{"originalPrice":"23","promotionalPrice":"0"},"goodsSpuShopBrandName":"干果糖果总汇"}],"promptedShopBrandList":[{"az":"desc","shopBrandId":74,"shopBrandName":"豆腐蛋糕","userDistance":99999}]}
     */

    this.getPromptedShopBrandAndGoodsSpu = function(callback, keyword, lat, lon){
        var params = {
            term: keyword||'',
            userLat: parseFloat(lat)||0,
            userLon: parseFloat(lon)||0
        };
        $mqDao(this.queueName, 'getPromptedShopBrandAndGoodsSpu', params, function(msg){
            var result = {};
            result.promptedShopBrandList = [];
            result.promptedGoodsSpuList = [];
            if(msg){
                result.promptedShopBrandList = msg.promptedShopBrandList || [];
                if(msg.promptedGoodsSpuList && msg.promptedGoodsSpuList.length){
                    for(var i=0; i<msg.promptedGoodsSpuList.length; i++){
                        var goods = msg.promptedGoodsSpuList[i];
                        goods.showPrice = parseFloat(goods.goodsSpuPrice.promotionalPrice) || parseFloat(goods.goodsSpuPrice.originalPrice);
                    }
                    result.promptedGoodsSpuList = msg.promptedGoodsSpuList || [];
                }

            }
            callback(result);
        });
    };

    /**
     * 检索提示商品信息
     * @param term 检索词
     * @return
     * [{"goodsSpuName":"蒸蛋糕","goodsSpuOnBusiness":1,"goodsSpuPrice":{"originalPrice":"23","promotionalPrice":"0"},"goodsSpuShopBrandName":"干果糖果总汇"}]
     */
    // this.getPromptedGoodsSpu = function(callback, keyword, lat, lon){
    //     var params = {
    //         term: keyword||'',
    //         userLat: parseFloat(lat)||0,
    //         userLon: parseFloat(lon)||0
    //     };
    //     $mqDao(this.queueName, 'getPromptedGoodsSpu', params, function(msg){
    //         var result = [];
    //         if(msg && msg.length){
    //             for(var i=0; i<msg.length; i++){
    //                 var goods = msg[i];
    //                 goods.showPrice = parseFloat(goods.goodsSpuPrice.promotionalPrice) || parseFloat(goods.goodsSpuPrice.originalPrice);
    //             }
    //             result = msg;
    //         }
    //         callback(result);
    //     });
    // };

    this.getPromptedGoodsSpuCommunityId = function(callback, keyword, communityId){
        var params = {
            term: keyword||'',
            communityId: parseInt(communityId) || 0
        };
        var mothod = searchPromptSpuMap[appEnvironment];
        $mqDao(this.queueName, mothod, params, function(msg){
            var result = [];
            if(msg && msg.length){
                for(var i=0; i<msg.length; i++){
                    var goods = msg[i];
                    goods.showPrice = parseFloat(goods.goodsSpuPrice.promotionalPrice) || parseFloat(goods.goodsSpuPrice.originalPrice);
                }
                result = msg;
            }
            callback(result);
        });
    };

    /**
     * 检索提示供应商信息
     * @param term 检索词
     * @param userLon
     * @param userLat
     * @return 用户位置为0时，距离为默认值99999
     * [{"az":"desc","shopBrandId":74,"shopBrandName":"豆腐蛋糕","shopBrandNamePinYin":"豆腐蛋糕 doufudangao dfdg  豆腐 蛋糕  doufu dangao  df dg","userDistance":99999}]
     */
    // this.getPromptedShopBrand = function(callback, keyword, lat, lon){
    //     var params = {
    //         term: keyword||'',
    //         userLat: parseFloat(lat)||0,
    //         userLon: parseFloat(lon)||0
    //     };
    //     $mqDao(this.queueName, 'getPromptedShopBrand', params, function(msg){
    //         var result = [];
    //         if(msg){
    //             result = msg;
    //         }
    //         callback(result);
    //     });
    // };

    this.getPromptedShopBrandCommunityId = function(callback, keyword, communityId){
        var params = {
            term: keyword||'',
            communityId: parseInt(communityId) || 0
        };
        var method = searchPromptShopBrandMap[appEnvironment];
        $mqDao(this.queueName, method, params, function(msg){
            var result = [];
            if(msg){
                result = msg;
            }
            callback(result);
        });
    };
}]);
