app.factory('userLocationFactory', [function(){
    var _currentUserKey = "hefenUser";
    var _currentUserCache = new LocalStorageMap(_currentUserKey);

    /**
     * 设置用户信息
     * @param key 用户的信息字段
     * @param val 用户的信息
     */
    var _setUserInfo = function(key, val){
        _currentUserCache.put(key, val);
    };

    /**
     * 获取用户某字段的信息
     * @param key 用户的信息字段
     */
    var _getUserInfo = function(key){
       return _currentUserCache.get(key);
    };

    /**
     * 移除用户某字段信息
     * @param key 用户的信息字段
     */
    var _removeUserInfo = function(key){
        _currentUserCache.remove(key);
    };

    var api = {
        user: function(){
            return {phone: _getUserInfo('phone')||''}
        },
        login: function(val){
            _setUserInfo('phone', val);
        },
        logout: function(){
            _removeUserInfo('phone');
        },
        isLoggedIn: function(){
            return !!_getUserInfo('phone');
        },
        writeVerCodeCount: function(n){
            _setUserInfo('verCount', n);
        },
        readVerCodeCount: function(){
            return parseInt(_getUserInfo('verCount')) || 0;
        }
    };

    return api;
}]);