/**
 * 与 MQ 通信工具[$mqDao] 的堆栈
 * 有 MQ 请求时，先放入堆栈，再从堆栈顺序取出，执行通信
 */
app.factory('$mqDaoStack', function() {
    /**
     * 记录所有 MQ 请求列表
     * @exmaple [{queue:'app_goods_service',methodName:'getGoodsList',...},{}]
     */
    // console.log('MQ 堆栈 初始化！！！');
    var _mqDaoList;
    var _mqCurrent;
    
    if((typeof propertles_current) === 'function'){
        if(propertles_current()){
            CURRENT_ENV = 'product';
        }
    }
    
    var _init = function() {
        _mqDaoList = [];
        _mqCurrent = null;
    };
    /**
     * 格式化 MQ 信息，放入堆栈
     */
    var _parseMqInfo = function(queue, methodName, dataObj, callBack, error, canceler) {
        var info = {
            queue: queue,
            methodName: methodName,
            dataObj: dataObj,
            callBack: callBack,
            error: error,
            canceler: canceler
        };
        return info;
    };

    var api = {
        push: function(queue, methodName, dataObj, callBack, error, canceler) {
            var mqInfo = _parseMqInfo(queue, methodName, dataObj, callBack, error, canceler);
            _mqDaoList.push(mqInfo);
        },
        getNext: function() {
            var mqNext = _mqDaoList[0];
            if (mqNext && mqNext != _mqCurrent) {
                _mqCurrent = mqNext;
                return mqNext;
            }
            return null;
        },
        getCurrent: function() {
            // console.log('MQ 堆栈长度:',_mqDaoList.length);
            return _mqCurrent;
        },
        clear: function(mq) {
            _mqDaoList = arrayRemoveItem(_mqDaoList, mq);
            if(_mqDaoList.length == 0){
                _init();
            }
        },
        clearAll: function() {
            angular.forEach(_mqDaoList, function(mq, i){
                mq.canceler.resolve();
                // console.log('清除 MQ：', mq.queue , mq.methodName, JSON.stringify(mq.dataObj));
            });
            _init();
        }
    };
    _init();
    return api;
});
